/*
 *  Copyright 2010 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <linux/kernel.h>
#include <linux/init.h>

#include <mach/hardware.h>
#include <asm/mach-types.h>
#include <asm/mach/arch.h>
#include <mach/gpio.h>

#include <linux/io.h>
#include <linux/delay.h>


#include "../generic.h"
#include "../irq.h"
#include "../timer.h"

#define APBSS_PHYS_TO_VIRT(physaddr) 	(physaddr-CXD9225GG_APBSS_BASE+CXD9225GG_APB_REG_VIRT_BASE)
#define SYSC_PHYS_TO_VIRT(physaddr) 	(physaddr-CXD9225GG_SYSC_REG_PHYS_BASE+CXD9225GG_SYSC_REG_VIRT_BASE)


void __init avp13_init(void)
{
    cxd9225gg_gpio_init();
    cxd9225gg_init();
}


MACHINE_START(AVP13, "AVP13 evaluation board")
	.phys_io      = CXD9225GG_1M_MAP_0_PHYS_BASE,
	.io_pg_offst  = (CXD9225GG_1M_MAP_0_VIRT_BASE >> 18) & 0xfffc,
	.boot_params  = PHYS_OFFSET + 0x100,
	.map_io       = cxd9225gg_map_io,
	.init_irq     = cxd9225gg_init_irq,
	.init_machine = avp13_init,
	.timer        = &cxd9225gg_timer,
MACHINE_END
