/* 2014-08-28: File changed by Sony Corporation */
/*
 *Copyright 2012 Sony Corporation
 *This program is free software; you can redistribute it and/or modify
 *it under the terms of the GNU General Public License, version 2, as
 *published by the Free Software Foundation.
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *GNU General Public License for more details.
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef _EXPCD_DRIVER_H
#define _EXPCD_DRIVER_H

#define EXPCD_SLOT_MAX                  2

/* Card Type */
enum {
	EXPCD_NON = 0,
	EXPCD_PCIEX,
	EXPCD_USB,
	EXPCD_PCIEX_USB,
	EXPCD_CARDKIND_END
};

/* Card Power Control/Status */
enum {
	EXPCD_POWOFF = 0,
	EXPCD_POWON,
	EXPCD_POWOFF_RDY,
	EXPCD_POWREJ,
	EXPCD_POWREQ_ERR,
	EXPCD_POWOFF_FAIL,
	EXPCD_POWOCOFF,
	EXPCD_POWCS_END
};

typedef struct EXPCDCARDSTATUS_t {
    unsigned int slotno;
    int card_status;
    int pow_status;
} EXPCDCARDSTATUS;

typedef enum {
	USBTCONNECTUNDEF			= 0,
	USBDISCONNECTEDSTATUS,
	USBCONNECTEDSTATUS
} USBCONNECTSTATUS;

typedef void (*pfn_expcd_callback)(EXPCDCARDSTATUS * pstatus);

int expcdCardStatusGet(EXPCDCARDSTATUS * pStatus);

int expcdCardPowCtrl(int slotno, int pow);

int expcdCardStatusChgRegister(void * pFunc);

int expcdCardStatusChgUnRegister(void *pFunc);

int expcdOverCurrentRegister(void *pFunc);

int expcdOverCurrentUnRegister(void *pFunc);

unsigned int expcdDriverVersionGet(void);

int expcdSelfDiagnose(int flag);

int expcdAutoPowControl(int pw);

int expcdAutoPowUseControl(int slotno, int kind);

int expcdAutoPowUseForceControl(int slotno, int kind);

void expcdTestModeAllInterruptDisable(void);

int expcdErrorForceDetach(int port);

int expcdForcedDetach(int slotno);

#endif /* _EXPCD_DRIVER_H */

