/* 2014-08-28: File changed by Sony Corporation */
/*
 *Copyright 2012 Sony Corporation
 *This program is free software; you can redistribute it and/or modify
 *it under the terms of the GNU General Public License, version 2, as
 *published by the Free Software Foundation.
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *GNU General Public License for more details.
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef _EXPCD_IOCTL_H
#define _EXPCD_IOCTL_H

#define EXPCD_CHAR_DEV                  "/dev/expcd"

#define SIG_EXPCD_UDC_HP                39 /* USB tcb HotPlug signal */
#define SIG_EXPCD_HP                    40 /* HotPlug signal */
#define SIG_EXPCD_OC                    41 /* OverCurrent signal */
#define SIG_EXPCD_SC                    42 /* StatusChanged signal */

#define SIG_EXPCD_UDC_IN                48
#define SIG_EXPCD_UDC_OUT               49

/* expcd hotplug status flag */
#define EXPCD_SLOT_SHIFT                (0)
#define EXPCD_SLOT_0                    (0x0<<EXPCD_SLOT_SHIFT)
#define EXPCD_SLOT_1                    (0x1<<EXPCD_SLOT_SHIFT)
#define EXPCD_SLOT_MASK                 (0x1<<EXPCD_SLOT_SHIFT)
#define EXPCD_IF_SHIFT                  (8)
#define EXPCD_IF_USB                    (0x0<<EXPCD_IF_SHIFT)
#define EXPCD_IF_PCIE                   (0x1<<EXPCD_IF_SHIFT)
#define EXPCD_IF_MASK                   (0x1<<EXPCD_IF_SHIFT)
#define EXPCD_OP_SHIFT                  (16)
#define EXPCD_OP_PULLOUT                (0x0<<EXPCD_OP_SHIFT)
#define EXPCD_OP_PLUGIN                 (0x1<<EXPCD_OP_SHIFT)
#define EXPCD_OP_MASK                   (0x1<<EXPCD_OP_SHIFT)
#define EXPCD_IRQ_SHIFT                 (24)

/*
sig_param of SIG_EXPCD_HP is a int:

slotno	  = (sig_param & EXPCD_SLOT_MASK) >> EXPCD_SLOT_SHIFT;
is_pcie   = (sig_param & EXPCD_IF_PCIE);
is_plugin = (sig_param & EXPCD_OP_PLUGIN);

----------------------------------------

sig_param of SIG_EXPCD_HP is a int:

slotno    = sig_param;
*/
#define EXPCD_LED_SLOT_SHIFT	(3)
#define EXPCD_LED_SLOT_0	(0x0<<EXPCD_LED_SLOT_SHIFT)
#define EXPCD_LED_SLOT_1	(0x1<<EXPCD_LED_SLOT_SHIFT)
#define EXPCD_LED_SLOT_MASK	(0x1<<EXPCD_LED_SLOT_SHIFT)
#define EXPCD_LED_COLOR_SHIFT	(1)
#define EXPCD_LED_COLOR_GREEN	(0x0<<EXPCD_LED_COLOR_SHIFT)
#define EXPCD_LED_COLOR_RED	(0x1<<EXPCD_LED_COLOR_SHIFT)
#define EXPCD_LED_COLOR_YELLOW	(0x2<<EXPCD_LED_COLOR_SHIFT)
#define EXPCD_LED_COLOR_MASK	(0x3<<EXPCD_LED_COLOR_SHIFT)
#define EXPCD_LED_ON_SHIFT	(0)
#define EXPCD_LED_ON_OFF	(0x0<<EXPCD_LED_ON_SHIFT)
#define EXPCD_LED_ON_ON	(0x1<<EXPCD_LED_ON_SHIFT)
#define EXPCD_LED_ON_MASK (0x1<<EXPCD_LED_ON_SHIFT)

enum EXPCD_IOCTL_CMD {
	EXPCD_IOCTL_SigHandlerDone = 0,
	EXPCD_IOCTL_GetSigParam,

	EXPCD_IOCTL_CardStatusGet,
	EXPCD_IOCTL_CardPowCtrl,
	EXPCD_IOCTL_ForcedDetach,
	EXPCD_IOCTL_ErrorForceDetach,
	EXPCD_IOCTL_GetConnectStatus,
	EXPCD_IOCTL_SetMassOn,
	EXPCD_IOCTL_aldControl,
	EXPCD_IOCTL_aldRedControl,
	EXPCD_IOCTL_aldRedControl_now,
	EXPCD_IOCTL_aldTimingSet,
	EXPCD_IOCTL_aldVersionGet,
	EXPCD_IOCTL_aldSelfDiagnose,
	EXPCD_IOCTL_expcd_slot_set_led,
	EXPCD_IOCTL_MAX,
};

typedef struct EXPCDCARDPOWCTRL_t {
	int slotno;
	int pow;
	int result;
} EXPCDCARDPOWCTRL;

#endif /* _EXPCD_IOCTL_H */

