/* 2014-08-28: File changed by Sony Corporation */
#ifndef _EXPCD_LOCAL_H
#define _EXPCD_LOCAL_H

#include <mach/gpio.h>

#include "expcd_ioctl.h"

/* expcd gpios and interrupts */
#define EXPCD_INT_S0_USB                CXD9225GG_GPINT_00
#define EXPCD_INT_S0_PCIE               CXD9225GG_GPINT_01
#define EXPCD_INT_S0_OVC                CXD9225GG_GPINT_02
#define EXPCD_INT_S0_WAKE               CXD9225GG_GPINT_03 //not used
#define EXPCD_INT_S1_USB                CXD9225GG_GPINT_04
#define EXPCD_INT_S1_PCIE               CXD9225GG_GPINT_05
#define EXPCD_INT_S1_OVC                CXD9225GG_GPINT_06
#define EXPCD_INT_S1_WAKE               CXD9225GG_GPINT_07 //not used

/* GPIO BIT */
#define	EXPCD_GPIO_SLOT0_CPPE_SHIFT     (8)
#define	EXPCD_GPIO_SLOT0_CPPE_BIT       (1<<EXPCD_GPIO_SLOT0_CPPE_SHIFT)
#define	EXPCD_GPIO_SLOT0_CPUSB_SHIFT    (9)
#define	EXPCD_GPIO_SLOT0_CPUSB_BIT      (1<<EXPCD_GPIO_SLOT0_CPUSB_SHIFT)
#define	EXPCD_GPIO_SLOT0_STBY_SHIFT     (10)
#define	EXPCD_GPIO_SLOT0_STBY_BIT       (1<<EXPCD_GPIO_SLOT0_STBY_SHIFT)
#define	EXPCD_GPIO_SLOT0_SHDN_SHIFT     (11)
#define	EXPCD_GPIO_SLOT0_SHDN_BIT       (1<<EXPCD_GPIO_SLOT0_SHDN_SHIFT)
#define	EXPCD_GPIO_SLOT1_CPPE_SHIFT     (12)
#define	EXPCD_GPIO_SLOT1_CPPE_BIT       (1<<EXPCD_GPIO_SLOT1_CPPE_SHIFT)
#define	EXPCD_GPIO_SLOT1_CPUSB_SHIFT    (13)
#define	EXPCD_GPIO_SLOT1_CPUSB_BIT      (1<<EXPCD_GPIO_SLOT1_CPUSB_SHIFT)
#define	EXPCD_GPIO_SLOT1_STBY_SHIFT     (14)
#define	EXPCD_GPIO_SLOT1_STBY_BIT       (1<<EXPCD_GPIO_SLOT1_STBY_SHIFT)
#define	EXPCD_GPIO_SLOT1_SHDN_SHIFT     (15)
#define	EXPCD_GPIO_SLOT1_SHDN_BIT       (1<<EXPCD_GPIO_SLOT1_SHDN_SHIFT)
#define	EXPCD_GPIO_SLOT0_OC_SHIFT       (22)
#define	EXPCD_GPIO_SLOT0_OC_BIT         (1<<EXPCD_GPIO_SLOT0_OC_SHIFT)
#define	EXPCD_GPIO_SLOT1_OC_SHIFT       (23)
#define	EXPCD_GPIO_SLOT1_OC_BIT         (1<<EXPCD_GPIO_SLOT1_OC_SHIFT)

/* gpio utilities */
int expcd_slot_check(int slotno, int iface);
int expcd_slot_get_status(unsigned int * pstatus);
void expcd_slot_set_power(int slotno, int pwr_up);
int expcd_slot_get_power(int slotno);
void expcd_power_ctrl(int slotno, int is_powon, int is_pcie);
void expcd_slot_set_led(int slotno, int on, int color);

#endif /* _EXPCD_LOCAL_H */

