/* 2014-08-28: File changed by Sony Corporation */
#include <linux/spinlock.h>
#include <linux/list.h>
#include <linux/kthread.h>
#include <linux/wait.h>

/* use udif framework to raise my schedule policy and priority. */
//#define EXPCD_THD_USE_UDIF

struct expcd_task_list {
	struct list_head list; 			/* list of tasks */
#ifdef EXPCD_THD_USE_UDIF
	pid_t pid;
	volatile int should_stop;
#else
	struct task_struct *task;		/* task struct for thread(only for head) */
#endif
	void (*func)(unsigned long);	/* function for thread */
	unsigned long data;				/* data for thread function */
	spinlock_t lock;				/* lock for thread(only for head) */
	wait_queue_head_t wait_queue;	/* wait queue for thread(only for head) */
	struct completion thread_comp;	/* completion for thread(only for head) */
};

extern void expcd_create_thread(struct expcd_task_list *head);
extern void expcd_add_task(struct expcd_task_list *head, 
			void (*func)(unsigned long data), unsigned long data);
extern void expcd_stop_thread(struct expcd_task_list *head);

