/* 2014-08-28: File changed by Sony Corporation */
/*
 *Copyright 2012 Sony Corporation
 *This program is free software; you can redistribute it and/or modify
 *it under the terms of the GNU General Public License, version 2, as
 *published by the Free Software Foundation.
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *GNU General Public License for more details.
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include<linux/kernel.h>
#include <linux/module.h>
#include <linux/interrupt.h>

#define PCIEH_HOST_MAX_CONTROL 2

enum
{
    PCIEH_CLOCK_GATED_ON = 0,
    PCIEH_CLOCK_GATED_OFF = 1
};


#include "mach/cxd9225gg_Interrupt.h"

typedef struct EXPCDINTERRUPTINFO_t
{
	unsigned int		ch	;		/**< Interrupt Controller ch	*/
}EXPCDINTERRUPTINFO ;

const	EXPCDINTERRUPTINFO	expcdInterruptTbl[] =
{
    /*	    	ch	    	*/
    {	INT_SRC_IOB_GPINT1	} ,
    {	INT_SRC_IOB_GPINT0	} ,
    {	INT_SRC_IOB_GPINT5	} ,
    {	INT_SRC_IOB_GPINT4	}
} ;

#define		EXPCD_ARRAY_NUM(ar)   (sizeof(ar)/sizeof((ar)[0]))


const	unsigned int	expcdInterruptTblCnt = EXPCD_ARRAY_NUM(expcdInterruptTbl) ;

#define		EXPCD_CXD9225GGBSPINTDISABLE(p)  disable_irq( (p) )	

#define     EXPCD_SLOT_TO_PORT(slot) ((0)?(((slot)+1)&1):(slot))

/**
 * expcdTestModeAllInterruptDisabled
 *
 * @brief
 *   eXg[hpɂׂĂ̑}荞݂~
 *
 * @param[in]   Ȃ
 *
 * @retval  Ȃ
 *
 * @note
 *
 */
void expcdTestModeAllInterruptDisabled
(
    void
)
{
    unsigned int   cnt ;

	/* ׂĂ̑}ch}XN */
    for( cnt = 0 ; cnt < expcdInterruptTblCnt ; cnt++ )
    {
	   /* 荞݃}XN */
       EXPCD_CXD9225GGBSPINTDISABLE(expcdInterruptTbl[cnt].ch) ;
    }

	return  ;
}

/* these functions are in pciehc.c */
extern void bsp_pcie_port_gated_clock_on(int port);
extern void bsp_pcie_port_gated_clock_off(int port);

/**
 * pciehGatedClockOff:
 *
 * @brief
 * PCI-ExpressQ[ebhNbNRg[֐
 *
 * @param[in]  port Q[ebhNbÑRg[sportԍ
 *
 * @retval
 *
 * @note
 *  Q[ebhNbNOFFɂāANbNLɂB
 *  portԍƃRg[H/WID͈ȉ̂悤ɂÂĂB
 *
 *   port = 0, CXD9225GG_GATED_CTS_PCIEX1L0
 *   port = 1, CXD9225GG_GATED_CTS_PCIEX1L1
 *
 */
void pciehGatedClockOff
(
    unsigned int port
)
{
    bsp_pcie_port_gated_clock_off(port);
}

/**
 * pciehGatedClockOn:
 *
 * @brief
 * PCI-ExpressQ[ebhNbNRg[֐
 *
 * @param[in]  port Q[ebhNbÑRg[sportԍ
 * @param[in]  ctrl PCIEH_CLOCK_GATED_OFF  Q[ebhNbNOFF
 *                  PCIEH_CLOCK_GATED_ON   Q[ebhNbNON
 *
 * @retval OK    
 *
 * @note
 *  Q[ebhNbNONɂāANbN𖳌ɂB
 *  portԍƃRg[H/WID͈ȉ̂悤ɂÂĂB
 *
 *   port = 0, NCONNECTPM_GATED_CTS_PCIEX0
 *   port = 1, NCONNECTPM_GATED_CTS_PCIEX1
 *
 */
void pciehGatedClockOn
(
    unsigned int port
)
{
        bsp_pcie_port_gated_clock_off(port);
}

/**
 * pciehGatedClockControl:
 *
 * @brief
 * PCI-ExpressQ[ebhNbNRg[֐
 *
 * @param[in]  port Q[ebhNbÑRg[sportԍ
 * @param[in]  ctrl PCIEH_CLOCK_GATED_OFF  Q[ebhNbNOFF
 *                  PCIEH_CLOCK_GATED_ON   Q[ebhNbNON
 *
 * @retval void
 *
 * @note
 *
 */
void pciehGatedClockControl
(
    unsigned int port,
    unsigned int ctrl
)
{
 	/* \[Xr */
	if (PCIEH_CLOCK_GATED_OFF == ctrl)
    {
       pciehGatedClockOff(port);
    }
    else
    {
       pciehGatedClockOn(port);
    }

    return;
}


extern int bsp_pcie_port_init(int port, int is_pow_on);

#include <linux/delay.h>

/*
*
* cxd9225ggBspPcieInit - CXD9225GG PCI EXPRESS interface initialization
*
* This routine initializes the CXD9225GG PCI EXPRESS interface.
 Refer to CXD9225GG User's manual for the detail information.
*
* RETURNS: N/A
*/
int cxd9225ggBspPcieInit
(
    int port
)
{
	return bsp_pcie_port_init(port, 0);
}

/**
 * pciehBspPcieInit:
 *
 * @brief
 * w|[ǧŒRtBO[V{
 *
 * @param[in]  port     |[gԍ
 *
 * @retval 0 
 *
 * @note
 * BSP񋟂I/FgpŒRtBO[V{B
 * {֐R[邱ƂŃzXgRg[̓ZbgԂɂȂB
 *
 */
int pciehBspPcieInit
(
    unsigned int port
)
{
	int	bspRet;
	
	EXPCD_SLOT_TO_PORT(port);
	
	bspRet = cxd9225ggBspPcieInit(port);

	if(0 == bspRet)
	{
		//taskDelay(PCIEH_DELAY_TIME(PCIEH_DELAYTIME_BEFORECONFIG));
        mdelay(100);
    }

	return (bspRet);
}

/**
 * pciehTestModeEnable
 *
 * @brief
 * PCI-ExpresseXg[hL
 *
 * @param  
 *
 * @retval 0		I
 * @retval -1	    ُI
 *
 * @note
 *
 */
int pciehTestModeEnable
(
    void
)
{
    unsigned int cnt ;

	/* }荞݂}XN */
    expcdTestModeAllInterruptDisabled() ;

	/* portׂẴRg[𗧂グ */
    for( cnt=0 ; cnt < PCIEH_HOST_MAX_CONTROL ; cnt++ )
	{
	   pciehGatedClockControl(cnt, PCIEH_CLOCK_GATED_OFF);
	   pciehBspPcieInit(cnt) ;
	}

	return 0 ;
}
EXPORT_SYMBOL(pciehTestModeEnable);

