/* 2014-08-28: File changed by Sony Corporation */
/*
 * Copyright 2012 Sony Corporation
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */


#ifndef	INCcxd9225ggIOh
#define	INCcxd9225ggIOh

#ifdef __cplusplus
extern "C" {
#endif

#include <mach/cxd9225gg_Chipset.h>

#define PMCR_CYCLE_CNT_DIV_64TH   (1<<3)
#define PMCR_ALL_COUNTER_ENABLE   (1<<0)

#define RB_CXD9225GG_SYSTEMCLK	1000000

#define RB_CXD9225GG_PCLK_66MHz	66666667
#define RB_CXD9225GG_PCLK		RB_CXD9225GG_PCLK_66MHz	/* APB clock */

/* GPIO initial values */
#define RB_CXD9225GG_PORT00_DEFAULT	0x00000000
#define RB_CXD9225GG_PORT01_DEFAULT	0x00000000
#define RB_CXD9225GG_PORT02_DEFAULT	0x00000000
#define RB_CXD9225GG_PORT03_DEFAULT	0x00000000
#define RB_CXD9225GG_PORT04_DEFAULT	0x00000000
#define RB_CXD9225GG_PORT05_DEFAULT	0x00000000
#define RB_CXD9225GG_PORT10_DEFAULT	0x00000073
#define RB_CXD9225GG_PORT10_DEFAULT2	0x000000Fb
#define RB_CXD9225GG_PORT11_DEFAULT	0x000000Fb
#define RB_CXD9225GG_PORT12_DEFAULT	0x000000F0
#define RB_CXD9225GG_PORT13_DEFAULT	0x00000000
#define RB_CXD9225GG_PORT14_DEFAULT	0x000000C9
#define RB_CXD9225GG_PORT15_DEFAULT	0x00000000
#define RB_CXD9225GG_PM00_DEFAULT		0x00000002
#define RB_CXD9225GG_PM01_DEFAULT		0x00000001
#define RB_CXD9225GG_PM02_DEFAULT		0x00000002
#define RB_CXD9225GG_PM03_DEFAULT		0x00000001
#define RB_CXD9225GG_PM04_DEFAULT		0x00000002
#define RB_CXD9225GG_PM05_DEFAULT		0x000000FF
#define RB_CXD9225GG_PM10_DEFAULT		0x00000000
#define RB_CXD9225GG_PM11_DEFAULT		0x00000000
#define RB_CXD9225GG_PM12_DEFAULT		0x0000000F
#define RB_CXD9225GG_PM13_DEFAULT		0x000000FF
#define RB_CXD9225GG_PM14_DEFAULT		0x0000003E
#define RB_CXD9225GG_PM15_DEFAULT		0x000000F7
#define RB_CXD9225GG_PMC00_DEFAULT		0x00000003
#define RB_CXD9225GG_PMC01_DEFAULT		0x00000003
#define RB_CXD9225GG_PMC02_DEFAULT		0x00000003
#define RB_CXD9225GG_PMC03_DEFAULT		0x00000003
#define RB_CXD9225GG_PMC04_DEFAULT		0x00000007
#define RB_CXD9225GG_PMC05_DEFAULT		0x00000003

/* PCI-Express */
#define RB_CXD9225GG_PCIE_GPE0_DEFAULT	0x00000000
#define RB_CXD9225GG_PCIE_GPE1_DEFAULT	0x00000000
#define RB_CXD9225GG_PCIE_GPE2_DEFAULT	0x00000000
#define RB_CXD9225GG_PCIE_GPE3_DEFAULT	0x00000000

/****************/
/* Base address */
/****************/

/* PCIe memory space */
#define CXD9225GG_PCIE_AXI_MEM_BASE	CXD9225GG_SDRAM_REAL_BASE		/* PCIe Address(PCIe -> AXI) (for mem space) */
#define CXD9225GG_PCIE_AXI_MEM_LIMIT	0x5FF00000			/* PCIe Limit(PCIe -> AXI) (for mem space) */

#define CXD9225GG_PCIE_AXI_BAR0_BASE	CXD9225GG_SDRAM_REAL_BASE		/* PCIe Address(PCIe -> AXI) (for BAR0) */
#define CXD9225GG_PCIE_AXI_BAR0_MASK	0x1FFFFFFF			/* PCIe Size(PCIe -> AXI) (for BAR0) */
#define CXD9225GG_PCIE_AXI_BAR0_AWBASE0	0x00000000			/* PCIe Address(PCIe -> AXI) (for AWBASE0) */
#define CXD9225GG_PCIE_AXI_BAR0_AWMASK0	(CXD9225GG_SDRAM_SIZE - 1)		/* PCIe Size(PCIe -> AHB) (for AWMASK0) */
#define CXD9225GG_PCIE_AXI_BAR0_AWDEST0	CXD9225GG_SDRAM_REAL_BASE		/* AXI Address(PCIe -> AXI) (for AWDEST0) */
#define CXD9225GG_PCIE_AXI_BAR0_AWBASE1	0x20000000			/* PCIe Address(PCIe -> AXI) (for AWBASE1) */
#define CXD9225GG_PCIE_AXI_BAR0_AWMASK1	0				/* PCIe Size(PCIe -> AHB) (for AWMASK1) */
#define CXD9225GG_PCIE_AXI_BAR0_AWDEST1	0x20000000			/* AXI Address(PCIe -> AXI) (for AWDEST1) */
#define CXD9225GG_PCIE_AXI_BAR0_AWBASE2	0x20000000			/* PCIe Address(PCIe -> AXI) (for AWBASE2) */
#define CXD9225GG_PCIE_AXI_BAR0_AWMASK2	0				/* PCIe Size(PCIe -> AHB) (for AWMASK2) */
#define CXD9225GG_PCIE_AXI_BAR0_AWDEST2	0x20000000			/* AXI Address(PCIe -> AXI) (for AWDEST2) */
#define CXD9225GG_PCIE_AXI_BAR0_AWBASE3	0x20000000			/* PCIe Address(PCIe -> AXI) (for AWBASE3) */
#define CXD9225GG_PCIE_AXI_BAR0_AWMASK3	0				/* PCIe Size(PCIe -> AHB) (for AWMASK3) */
#define CXD9225GG_PCIE_AXI_BAR0_AWDEST3	0x20000000			/* AXI Address(PCIe -> AXI) (for AWDEST3) */

#define CXD9225GG_AXI_PCIE_PWBASE0		CXD9225GG_PCIEX1L0_MEM_SPACE_BASE	/* AXI Address(AXI -> PCIe) (for PWBASE0) */
#define CXD9225GG_AXI_PCIE_PWMASK0		(CXD9225GG_PCIEX1L0_MEM_SPACE_SIZE - 1)	/* AXI Size(AXI -> PCIe) (for PWMASK0) */
#define CXD9225GG_AXI_PCIE_PWDEST0		0x00000000			/* PCIe Address(AXI -> PCIe) (for PWDEST0) */
#define CXD9225GG_AXI_PCIE_PWBASE1		CXD9225GG_PCIEX1L1_MEM_SPACE_BASE	/* AXI Address(AXI -> PCIe) (for PWBASE1) */
#define CXD9225GG_AXI_PCIE_PWMASK1		(CXD9225GG_PCIEX1L1_MEM_SPACE_SIZE - 1)	/* AXI Size(AXI -> PCIe) (for PWMASK1) */
#define CXD9225GG_AXI_PCIE_PWDEST1		0x00000000			/* PCIe Address(AXI -> PCIe) (for PWDEST1) */
#define CXD9225GG_AXI_PCIE_PWBASE2		CXD9225GG_PCIEX4L_MEM_SPACE_BASE	/* AXI Address(AXI -> PCIe) (for PWBASE2) */
#define CXD9225GG_AXI_PCIE_PWMASK2		(CXD9225GG_PCIEX4L_MEM_SPACE_SIZE - 1)	/* AXI Size(AXI -> PCIe) (for PWMASK2) */
#define CXD9225GG_AXI_PCIE_PWDEST2		0x00000000			/* PCIe Address(AXI -> PCIe) (for PWDEST2) */

#ifdef __cplusplus
}
#endif

#endif	/* INCcxd9225ggIOh */
