/* 2014-08-28: File changed by Sony Corporation */
/*
 * Copyright 2012 Sony Corporation
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __INCcxd9225ggInterrupth
#define __INCcxd9225ggInterrupth

#ifdef __cplusplus
extern "C" {
#endif

#include <mach/cxd9225gg_types.h>


/******************************************************************************
 *
 * INTCγװ
 *
 * NOTE: CPUIRQ㳰ߤ³Ƥޤ
 */

/* Interrupt sources */
#define INT_SRC_TIMER0_INT		0	/* Compare Timer 0                    */
#define INT_SRC_TIMER1_INT		1	/* Compare Timer 1                    */
#define INT_SRC_TIMER2_INT		2	/* Compare Timer 2                    */
#define INT_SRC_TIMER3_INT		3	/* Compare Timer 3                    */
#define INT_SRC_TIMER4_INT		4	/* Compare Timer 4                    */
#define INT_SRC_TIMER5_INT		5	/* Compare Timer 5                    */
#define INT_SRC_TIMER6_INT		6	/* Compare Timer 6                    */
#define INT_SRC_TIMER7_INT		7	/* Compare Timer 7                    */
#define INT_SRC_TIMER8_INT		8	/* Compare Timer 8                    */
#define INT_SRC_UART0_INT		9	/* UART0 Int                          */
#define INT_SRC_UART1_INT		10	/* UART1 Int                          */
#define INT_SRC_CSI_INT			11	/* CSI Int                            */
#define INT_SRC_IIC_INT			12	/* IIC Int                            */
#define INT_SRC_CPU0_COMMRX		13	/* CPU0 COMMRX                        */
#define INT_SRC_CPU0_COMMTX		14	/* CPU0 COMMTX                        */
#define INT_SRC_CPU0_PMUIRQ		15	/* CPU0 PMUIRQ                        */
#define INT_SRC_CPU1_COMMRX		16	/* CPU1 COMMRX                        */
#define INT_SRC_CPU1_COMMTX		17	/* CPU1 COMMTX                        */
#define INT_SRC_CPU1_PMUIRQ		18	/* CPU1 PMUIRQ                        */
#define INT_SRC_BUS_X2H_ERRINT		19	/* AXI to AHB Bus ERRINT              */
#define INT_SRC_BUS_H2H_ERRINT		20	/* AHB to AHB Bus ERRINT              */
#define INT_SRC_BUS_H2X_ERRINT		21	/* AHB to AXI Bus ERRINT              */
#define INT_SRC_PCIEX1L0_INTA		22	/* PCIEX1L0 Root Complex INTA         */
#define INT_SRC_PCIEX1L0_INTB		23	/* PCIEX1L0 Root Complex INTB         */
#define INT_SRC_PCIEX1L0_INTC		24	/* PCIEX1L0 Root Complex INTC         */
#define INT_SRC_PCIEX1L0_INTD		25	/* PCIEX1L0 Root Complex INTD         */
#define INT_SRC_PCIEX1L0_INTMSI		26	/* PCIEX1L0 Root Complex MSI Receive  */
#define INT_SRC_PCIEX1L0_MSG_INT	27	/* PCIEX1L0 Root Complex MSG Receive  */
#define INT_SRC_PCIEX1L0_PCIE_ERR	28	/* PCIEX1L0 Root Complex PCIe Error   */
#define INT_SRC_PCIEX1L0_AXI_ERR	29	/* PCIEX1L0 Root Complex AXI-BR Error */
#define INT_SRC_PCIEX1L0_INTALL		30	/* PCIEX1L0 Root Complex INT ALL      */
#define INT_SRC_PCIEX1L1_INTA		31	/* PCIEX1L1 Root Complex INTA         */
#define INT_SRC_PCIEX1L1_INTB		32	/* PCIEX1L1 Root Complex INTB         */
#define INT_SRC_PCIEX1L1_INTC		33	/* PCIEX1L1 Root Complex INTC         */
#define INT_SRC_PCIEX1L1_INTD		34	/* PCIEX1L1 Root Complex INTD         */
#define INT_SRC_PCIEX1L1_INTMSI		35	/* PCIEX1L1 Root Complex MSI Receive  */
#define INT_SRC_PCIEX1L1_MSG_INT	36	/* PCIEX1L1 Root Complex MSG Receive  */
#define INT_SRC_PCIEX1L1_PCIE_ERR	37	/* PCIEX1L1 Root Complex PCIe Error   */
#define INT_SRC_PCIEX1L1_AXI_ERR	38	/* PCIEX1L1 Root Complex AXI-BR Error */
#define INT_SRC_PCIEX1L1_INTALL		39	/* PCIEX1L1 Root Complex INT ALL      */
#define INT_SRC_PCIEX4L_INTA		40	/* PCIEX4L Root Complex INTA          */
#define INT_SRC_PCIEX4L_INTB		41	/* PCIEX4L Root Complex INTB          */
#define INT_SRC_PCIEX4L_INTC		42	/* PCIEX4L Root Complex INTC          */
#define INT_SRC_PCIEX4L_INTD		43	/* PCIEX4L Root Complex INTD          */
#define INT_SRC_PCIEX4L_INTMSI		44	/* PCIEX4L Root Complex MSI Receive   */
#define INT_SRC_PCIEX4L_MSG_INT		45	/* PCIEX4L Root Complex MSG Receive   */
#define INT_SRC_PCIEX4L_PCIE_ERR	46	/* PCIEX4L Root Complex PCIe Error    */
#define INT_SRC_PCIEX4L_AXI_ERR		47	/* PCIEX4L Root Complex AXI-BR Error  */
#define INT_SRC_PCIEX4L_INTALL		48	/* PCIEX4L Root Complex INT ALL       */
#define INT_SRC_USBF2_U2F_INT		49	/* USB Function (BRIDGE)              */
#define INT_SRC_USBF2_U2F_EPC_INT	50	/* USB Function (EPC)                 */
#define INT_SRC_SYSC_SYSINT0		51	/* SYSC CPU Hand Shake Interrupt0     */
#define INT_SRC_SYSC_SYSINT1		52	/* SYSC CPU Hand Shake Interrupt1     */
#define INT_SRC_SYSC_SYSINT2		53	/* SYSC CPU Hand Shake Interrupt2     */
#define INT_SRC_SYSC_SYSINT3		54	/* SYSC CPU Hand Shake Interrupt3     */
#define INT_SRC_SYSC_SYSINT4		55	/* SYSC CPU Hand Shake Interrupt4     */
#define INT_SRC_SYSC_SYSINT5		56	/* SYSC CPU Hand Shake Interrupt5     */
#define INT_SRC_SYSC_SYSINT6		57	/* SYSC CPU Hand Shake Interrupt6     */
#define INT_SRC_SYSC_SYSINT7		58	/* SYSC CPU Hand Shake Interrupt7     */
#define INT_SRC_SYSC_SYSINT8		59	/* SYSC CPU Hand Shake Interrupt8     */
#define INT_SRC_SYSC_SYSINT9		60	/* SYSC CPU Hand Shake Interrupt9     */
#define INT_SRC_SYSC_SYSINT10		61	/* SYSC CPU Hand Shake Interrupt10    */
#define INT_SRC_SYSC_SYSINT11		62	/* SYSC CPU Hand Shake Interrupt11    */
#define INT_SRC_SYSC_SYSINT12		63	/* SYSC CPU Hand Shake Interrupt12    */
#define INT_SRC_SYSC_SYSINT13		64	/* SYSC CPU Hand Shake Interrupt13    */
#define INT_SRC_SYSC_SYSINT14		65	/* SYSC CPU Hand Shake Interrupt14    */
#define INT_SRC_SYSC_SYSINT15		66	/* SYSC CPU Hand Shake Interrupt15    */
#define INT_SRC_PCI_DEVINT_O0		67	/* PCI Device Interrupt 0             */
#define INT_SRC_PCI_DEVINT_O1		68	/* PCI Device Interrupt 1             */
#define INT_SRC_PCI_DEVINT_O2		69	/* PCI Device Interrupt 2             */
#define INT_SRC_PCI_DEVINT_O3		70	/* PCI Device Interrupt 3             */
#define INT_SRC_PCI_UNITINT_O		71	/* PCI Unit Interrupt                 */
#define INT_SRC_BSIF_INT		72	/* BSIF Interrupt                     */
#define INT_SRC_BSIF_ERRINT		73	/* BSIF Error Interrupt               */
#define INT_SRC_SYSCON_INT		74	/* SYSCON Interrupt                   */
#define INT_SRC_SYSCON_ERRINT		75	/* SYSCON Error Interrupt             */
#define INT_SRC_STCC_INT		76
#define INT_SRC_LBIF_INT		77	/* LBIF Interrupt                     */
#define INT_SRC_AXI2NCI_ERRINT		78	/* AXI to NCI Error Interrupt         */
#define INT_SRC_NCI2AXI_ERRINT		79	/* NCI to AXI Error Interrupt         */
#define INT_SRC_BSSNCO_INT0		80	/* Nconnect BSS Interrupt0            */
#define INT_SRC_BSSNCO_INT1		81	/* Nconnect BSS Interrupt1            */
#define INT_SRC_BSSNCO_ERRINT		82	/* Nconnect BSS Error Interrupt       */
#define INT_SRC_DVCODEC_INT0		83	
#define INT_SRC_DVCODEC_INT1		84	
#define INT_SRC_DVCODEC_INT2		85	
#define INT_SRC_DVCODEC_ERRINT		86	
#define INT_SRC_DVCODEC_MON0		87	
#define INT_SRC_DVCODEC_MON1		88	
#define INT_SRC_DVCODEC_MON2		89	
#define INT_SRC_DVCODEC_MON3		90	
#define INT_SRC_DVCODEC_MON4		91	
#define INT_SRC_DVCODEC_MON5		92	
#define INT_SRC_DVCODEC_MON6		93	
#define INT_SRC_HFDMA_DMA_CH0		94	/* HFDMA ch0 Interrupt                */
#define INT_SRC_HFDMA_DMA_CH1		95	/* HFDMA ch1 Interrupt                */
#define INT_SRC_HFDMA_DMA_CH2		96	/* HFDMA ch2 Interrupt                */
#define INT_SRC_HFDMA_DMA_CH3		97	/* HFDMA ch3 Interrupt                */
#define INT_SRC_HFDMA_DMA_COM		98	/* HFDMA Common Register Interrupt    */
#define INT_SRC_SFMEMC_INT		99	/* SFMEMC Interrupt                   */
#define INT_SRC_IOB_GPINT0		100	/* GPIO Interrupt0                    */
#define INT_SRC_IOB_GPINT1		101	/* GPIO Interrupt1                    */
#define INT_SRC_IOB_GPINT2		102	/* GPIO Interrupt2                    */
#define INT_SRC_IOB_GPINT3		103	/* GPIO Interrupt3                    */
#define INT_SRC_IOB_GPINT4		104	/* GPIO Interrupt4                    */
#define INT_SRC_IOB_GPINT5		105	/* GPIO Interrupt5                    */
#define INT_SRC_IOB_GPINT6		106	/* GPIO Interrupt6                    */
#define INT_SRC_IOB_GPINT7		107	/* GPIO Interrupt7                    */
#define INT_SRC_IOB_GPINT8		108	/* GPIO Interrupt8                    */
#define INT_SRC_IOB_GPINT9		109	/* GPIO Interrupt9                    */
#define INT_SRC_IOB_GPINT10		110	/* GPIO Interrupt10                   */
#define INT_SRC_IOB_GPINT11		111	/* GPIO Interrupt11                   */
#define INT_SRC_IOB_GPINT12		112	/* GPIO Interrupt12                   */
#define INT_SRC_IOB_GPINT13		113	/* GPIO Interrupt13                   */
#define INT_SRC_IOB_GPINT14		114	/* GPIO Interrupt14                   */
#define INT_SRC_IOB_GPINT15		115	/* GPIO Interrupt15                   */
#define INT_SRC_IOB_GPINT16		116	/* GPIO Interrupt16                   */
#define INT_SRC_IOB_GPINT17		117	/* GPIO Interrupt17                   */
#define INT_SRC_IOB_GPINT18		118	/* GPIO Interrupt18                   */
#define INT_SRC_IOB_GPINT19		119	/* GPIO Interrupt19                   */
#define INT_SRC_MTCC_INT		120	/* MTCC Interrupt                     */



/******************************************************************************
 *
 * Interrupt Vectors
 *
 * NOTE: These definitions need to have 'INT_VEC_' prefix.
 */
#define INT_VEC_TIMER0_INT		IVEC_TO_INUM(INT_SRC_TIMER0_INT)
#define INT_VEC_TIMER1_INT		IVEC_TO_INUM(INT_SRC_TIMER1_INT)
#define INT_VEC_TIMER2_INT		IVEC_TO_INUM(INT_SRC_TIMER2_INT)
#define INT_VEC_TIMER3_INT		IVEC_TO_INUM(INT_SRC_TIMER3_INT)
#define INT_VEC_TIMER4_INT		IVEC_TO_INUM(INT_SRC_TIMER4_INT)
#define INT_VEC_TIMER5_INT		IVEC_TO_INUM(INT_SRC_TIMER5_INT)
#define INT_VEC_TIMER6_INT		IVEC_TO_INUM(INT_SRC_TIMER6_INT)
#define INT_VEC_TIMER7_INT		IVEC_TO_INUM(INT_SRC_TIMER7_INT)
#define INT_VEC_TIMER8_INT		IVEC_TO_INUM(INT_SRC_TIMER8_INT)
#define INT_VEC_UART0_INT		IVEC_TO_INUM(INT_SRC_UART0_INT)
#define INT_VEC_UART1_INT		IVEC_TO_INUM(INT_SRC_UART1_INT)
#define INT_VEC_CSI_INT			IVEC_TO_INUM(INT_SRC_CSI_INT)
#define INT_VEC_IIC_INT			IVEC_TO_INUM(INT_SRC_IIC_INT)
#define INT_VEC_CPU0_COMMRX		IVEC_TO_INUM(INT_SRC_CPU0_COMMRX)
#define INT_VEC_CPU0_COMMTX		IVEC_TO_INUM(INT_SRC_CPU0_COMMTX)
#define INT_VEC_CPU0_PMUIRQ		IVEC_TO_INUM(INT_SRC_CPU0_PMUIRQ)
#define INT_VEC_CPU1_COMMRX		IVEC_TO_INUM(INT_SRC_CPU1_COMMRX)
#define INT_VEC_CPU1_COMMTX		IVEC_TO_INUM(INT_SRC_CPU1_COMMTX)
#define INT_VEC_CPU1_PMUIRQ		IVEC_TO_INUM(INT_SRC_CPU1_PMUIRQ)
#define INT_VEC_BUS_X2H_ERRINT		IVEC_TO_INUM(INT_SRC_BUS_X2H_ERRINT)
#define INT_VEC_BUS_H2H_ERRINT		IVEC_TO_INUM(INT_SRC_BUS_H2H_ERRINT)
#define INT_VEC_BUS_H2X_ERRINT		IVEC_TO_INUM(INT_SRC_BUS_H2X_ERRINT)
#define INT_VEC_PCIEX1L0_INTA		IVEC_TO_INUM(INT_SRC_PCIEX1L0_INTA)
#define INT_VEC_PCIEX1L0_INTB		IVEC_TO_INUM(INT_SRC_PCIEX1L0_INTB)
#define INT_VEC_PCIEX1L0_INTC		IVEC_TO_INUM(INT_SRC_PCIEX1L0_INTC)
#define INT_VEC_PCIEX1L0_INTD		IVEC_TO_INUM(INT_SRC_PCIEX1L0_INTD)
#define INT_VEC_PCIEX1L0_INTMSI		IVEC_TO_INUM(INT_SRC_PCIEX1L0_INTMSI)
#define INT_VEC_PCIEX1L0_MSG_INT	IVEC_TO_INUM(INT_SRC_PCIEX1L0_MSG_INT)
#define INT_VEC_PCIEX1L0_PCIE_ERR	IVEC_TO_INUM(INT_SRC_PCIEX1L0_PCIE_ERR)
#define INT_VEC_PCIEX1L0_AXI_ERR	IVEC_TO_INUM(INT_SRC_PCIEX1L0_AXI_ERR)
#define INT_VEC_PCIEX1L0_INTALL		IVEC_TO_INUM(INT_SRC_PCIEX1L0_INTALL)
#define INT_VEC_PCIEX1L1_INTA		IVEC_TO_INUM(INT_SRC_PCIEX1L1_INTA)
#define INT_VEC_PCIEX1L1_INTB		IVEC_TO_INUM(INT_SRC_PCIEX1L1_INTB)
#define INT_VEC_PCIEX1L1_INTC		IVEC_TO_INUM(INT_SRC_PCIEX1L1_INTC)
#define INT_VEC_PCIEX1L1_INTD		IVEC_TO_INUM(INT_SRC_PCIEX1L1_INTD)
#define INT_VEC_PCIEX1L1_INTMSI		IVEC_TO_INUM(INT_SRC_PCIEX1L1_INTMSI)
#define INT_VEC_PCIEX1L1_MSG_INT	IVEC_TO_INUM(INT_SRC_PCIEX1L1_MSG_INT)
#define INT_VEC_PCIEX1L1_PCIE_ERR	IVEC_TO_INUM(INT_SRC_PCIEX1L1_PCIE_ERR)
#define INT_VEC_PCIEX1L1_AXI_ERR	IVEC_TO_INUM(INT_SRC_PCIEX1L1_AXI_ERR)
#define INT_VEC_PCIEX1L1_INTALL		IVEC_TO_INUM(INT_SRC_PCIEX1L1_INTALL)
#define INT_VEC_PCIEX4L_INTA		IVEC_TO_INUM(INT_SRC_PCIEX4L_INTA)
#define INT_VEC_PCIEX4L_INTB		IVEC_TO_INUM(INT_SRC_PCIEX4L_INTB)
#define INT_VEC_PCIEX4L_INTC		IVEC_TO_INUM(INT_SRC_PCIEX4L_INTC)
#define INT_VEC_PCIEX4L_INTD		IVEC_TO_INUM(INT_SRC_PCIEX4L_INTD)
#define INT_VEC_PCIEX4L_INTMSI		IVEC_TO_INUM(INT_SRC_PCIEX4L_INTMSI)
#define INT_VEC_PCIEX4L_MSG_INT		IVEC_TO_INUM(INT_SRC_PCIEX4L_MSG_INT)
#define INT_VEC_PCIEX4L_PCIE_ERR	IVEC_TO_INUM(INT_SRC_PCIEX4L_PCIE_ERR)
#define INT_VEC_PCIEX4L_AXI_ERR		IVEC_TO_INUM(INT_SRC_PCIEX4L_AXI_ERR)
#define INT_VEC_PCIEX4L_INTALL		IVEC_TO_INUM(INT_SRC_PCIEX4L_INTALL)
#define INT_VEC_USBF2_U2F_INT		IVEC_TO_INUM(INT_SRC_USBF2_U2F_INT)
#define INT_VEC_USBF2_U2F_EPC_INT	IVEC_TO_INUM(INT_SRC_USBF2_U2F_EPC_INT)
#define INT_VEC_SYSC_SYSINT0		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT0)
#define INT_VEC_SYSC_SYSINT1		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT1)
#define INT_VEC_SYSC_SYSINT2		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT2)
#define INT_VEC_SYSC_SYSINT3		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT3)
#define INT_VEC_SYSC_SYSINT4		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT4)
#define INT_VEC_SYSC_SYSINT5		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT5)
#define INT_VEC_SYSC_SYSINT6		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT6)
#define INT_VEC_SYSC_SYSINT7		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT7)
#define INT_VEC_SYSC_SYSINT8		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT8)
#define INT_VEC_SYSC_SYSINT9		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT9)
#define INT_VEC_SYSC_SYSINT10		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT10)
#define INT_VEC_SYSC_SYSINT11		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT11)
#define INT_VEC_SYSC_SYSINT12		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT12)
#define INT_VEC_SYSC_SYSINT13		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT13)
#define INT_VEC_SYSC_SYSINT14		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT14)
#define INT_VEC_SYSC_SYSINT15		IVEC_TO_INUM(INT_SRC_SYSC_SYSINT15)
#define INT_VEC_PCI_DEVINT_O0		IVEC_TO_INUM(INT_SRC_PCI_DEVINT_O0)
#define INT_VEC_PCI_DEVINT_O1		IVEC_TO_INUM(INT_SRC_PCI_DEVINT_O1)
#define INT_VEC_PCI_DEVINT_O2		IVEC_TO_INUM(INT_SRC_PCI_DEVINT_O2)
#define INT_VEC_PCI_DEVINT_O3		IVEC_TO_INUM(INT_SRC_PCI_DEVINT_O3)
#define INT_VEC_PCI_UNITINT_O		IVEC_TO_INUM(INT_SRC_PCI_UNITINT_O)
#define INT_VEC_BSIF_INT		IVEC_TO_INUM(INT_SRC_BSIF_INT)
#define INT_VEC_BSIF_ERRINT		IVEC_TO_INUM(INT_SRC_BSIF_ERRINT)
#define INT_VEC_SYSCON_INT		IVEC_TO_INUM(INT_SRC_SYSCON_INT)
#define INT_VEC_SYSCON_ERRINT		IVEC_TO_INUM(INT_SRC_SYSCON_ERRINT)
#define INT_VEC_STCC_INT		IVEC_TO_INUM(INT_SRC_STCC_INT)
#define INT_VEC_LBIF_INT		IVEC_TO_INUM(INT_SRC_LBIF_INT)
#define INT_VEC_AXI2NCI_ERRINT		IVEC_TO_INUM(INT_SRC_AXI2NCI_ERRINT)
#define INT_VEC_NCI2AXI_ERRINT		IVEC_TO_INUM(INT_SRC_NCI2AXI_ERRINT)
#define INT_VEC_BSSNCO_INT0		IVEC_TO_INUM(INT_SRC_BSSNCO_INT0)
#define INT_VEC_BSSNCO_INT1		IVEC_TO_INUM(INT_SRC_BSSNCO_INT1)
#define INT_VEC_BSSNCO_ERRINT		IVEC_TO_INUM(INT_SRC_BSSNCO_ERRINT)
#define INT_VEC_DVCODEC_INT0		IVEC_TO_INUM(INT_SRC_DVCODEC_INT0)
#define INT_VEC_DVCODEC_INT1		IVEC_TO_INUM(INT_SRC_DVCODEC_INT1)
#define INT_VEC_DVCODEC_INT2		IVEC_TO_INUM(INT_SRC_DVCODEC_INT2)
#define INT_VEC_DVCODEC_ERRINT		IVEC_TO_INUM(INT_SRC_DVCODEC_ERRINT)
#define INT_VEC_DVCODEC_MON0		IVEC_TO_INUM(INT_SRC_DVCODEC_MON0)
#define INT_VEC_DVCODEC_MON1		IVEC_TO_INUM(INT_SRC_DVCODEC_MON1)
#define INT_VEC_DVCODEC_MON2		IVEC_TO_INUM(INT_SRC_DVCODEC_MON2)
#define INT_VEC_DVCODEC_MON3		IVEC_TO_INUM(INT_SRC_DVCODEC_MON3)
#define INT_VEC_DVCODEC_MON4		IVEC_TO_INUM(INT_SRC_DVCODEC_MON4)
#define INT_VEC_DVCODEC_MON5		IVEC_TO_INUM(INT_SRC_DVCODEC_MON5)
#define INT_VEC_DVCODEC_MON6		IVEC_TO_INUM(INT_SRC_DVCODEC_MON6)
#define INT_VEC_HFDMA_DMA_CH0		IVEC_TO_INUM(INT_SRC_HFDMA_DMA_CH0)
#define INT_VEC_HFDMA_DMA_CH1		IVEC_TO_INUM(INT_SRC_HFDMA_DMA_CH1)
#define INT_VEC_HFDMA_DMA_CH2		IVEC_TO_INUM(INT_SRC_HFDMA_DMA_CH2)
#define INT_VEC_HFDMA_DMA_CH3		IVEC_TO_INUM(INT_SRC_HFDMA_DMA_CH3)
#define INT_VEC_HFDMA_DMA_COM		IVEC_TO_INUM(INT_SRC_HFDMA_DMA_COM)
#define INT_VEC_SFMEMC_INT		IVEC_TO_INUM(INT_SRC_SFMEMC_INT)
#define INT_VEC_IOB_GPINT0		IVEC_TO_INUM(INT_SRC_IOB_GPINT0)
#define INT_VEC_IOB_GPINT1		IVEC_TO_INUM(INT_SRC_IOB_GPINT1)
#define INT_VEC_IOB_GPINT2		IVEC_TO_INUM(INT_SRC_IOB_GPINT2)
#define INT_VEC_IOB_GPINT3		IVEC_TO_INUM(INT_SRC_IOB_GPINT3)
#define INT_VEC_IOB_GPINT4		IVEC_TO_INUM(INT_SRC_IOB_GPINT4)
#define INT_VEC_IOB_GPINT5		IVEC_TO_INUM(INT_SRC_IOB_GPINT5)
#define INT_VEC_IOB_GPINT6		IVEC_TO_INUM(INT_SRC_IOB_GPINT6)
#define INT_VEC_IOB_GPINT7		IVEC_TO_INUM(INT_SRC_IOB_GPINT7)
#define INT_VEC_IOB_GPINT8		IVEC_TO_INUM(INT_SRC_IOB_GPINT8)
#define INT_VEC_IOB_GPINT9		IVEC_TO_INUM(INT_SRC_IOB_GPINT9)
#define INT_VEC_IOB_GPINT10		IVEC_TO_INUM(INT_SRC_IOB_GPINT10)
#define INT_VEC_IOB_GPINT11		IVEC_TO_INUM(INT_SRC_IOB_GPINT11)
#define INT_VEC_IOB_GPINT12		IVEC_TO_INUM(INT_SRC_IOB_GPINT12)
#define INT_VEC_IOB_GPINT13		IVEC_TO_INUM(INT_SRC_IOB_GPINT13)
#define INT_VEC_IOB_GPINT14		IVEC_TO_INUM(INT_SRC_IOB_GPINT14)
#define INT_VEC_IOB_GPINT15		IVEC_TO_INUM(INT_SRC_IOB_GPINT15)
#define INT_VEC_IOB_GPINT16		IVEC_TO_INUM(INT_SRC_IOB_GPINT16)
#define INT_VEC_IOB_GPINT17		IVEC_TO_INUM(INT_SRC_IOB_GPINT17)
#define INT_VEC_IOB_GPINT18		IVEC_TO_INUM(INT_SRC_IOB_GPINT18)
#define INT_VEC_IOB_GPINT19		IVEC_TO_INUM(INT_SRC_IOB_GPINT19)
#define INT_VEC_MTCC_INT		IVEC_TO_INUM(INT_SRC_MTCC_INT)


/******************************************************************************
 *
 * Interrupt priority
 *
 * NOTE: Maximum number is INT_PRI_MAX
 */

/* Interrupt priority levels */
#define INT_PRI_LVL0		0
#define INT_PRI_LVL1		1
#define INT_PRI_LVL2		2
#define INT_PRI_LVL3		3
#define INT_PRI_LVL4		4
#define INT_PRI_LVL5		5
#define INT_PRI_LVL6		6
#define INT_PRI_LVL7		7
#define INT_PRI_LVL8		8
#define INT_PRI_LVL9		9
#define INT_PRI_LVL10		10
#define INT_PRI_LVL11		11
#define INT_PRI_LVL12		12
#define INT_PRI_LVL13		13
#define INT_PRI_LVL14		14
#define INT_PRI_LVL15		15

#define INT_PRI_MAX		15


/******************************************************************************
 *
 * Interrupt detect type definitions for internal INTC
 */
#define INT_TYPE_LEVEL		0
#define INT_TYPE_EDGE		1

/******************************************************************************
 *
 * Level interrupt definitions
 */
#define INT_LVLC_HIGH		1
#define INT_LVLC_LOW		2

/******************************************************************************
 *
 * Edge interrupt definitions
 */
#define INT_EDGC_RISING		1
#define INT_EDGC_FALLING	2
#define INT_EDGC_BOTH		3


  /* functions in cxd9225gg_Int.c */
#ifndef _ASMLANGUAGE
STATUS cxd9225ggBspIntcInit (void);
STATUS cxd9225ggBspIntLibInit (void);
void cxd9225ggBspIntHandler (void);
void cxd9225ggBspIntAck (void);
STATUS cxd9225ggBspIntConnect (int ch, VOIDFUNCPTR routine, int arg);
STATUS cxd9225ggBspIntDisconnect (int ch, VOIDFUNCPTR routine);
STATUS cxd9225ggBspIntEnable (int ch);
STATUS cxd9225ggBspIntDisable (int ch);
STATUS cxd9225ggBspSwIntGenerate (int ch);
STATUS cxd9225ggBspSwIntCancel (int ch);
STATUS cxd9225ggBspIntDetectTypeSelect (int ch, int dType);
STATUS cxd9225ggBspEdgeIntClear (int ch);
STATUS cxd9225ggBspEdgeIntControl (int ch, int effect);
STATUS cxd9225ggBspLevelIntControl (int ch, int effect);
STATUS cxd9225ggBspIntPrioritySet (int ch, int pri);
STATUS cxd9225ggBspIntPriorityMask (int pri);
#endif

#ifdef __cplusplus
}
#endif

#endif /* __INCcxd9225ggInterrupth */
