/*
 *Copyright 2012 Sony Corporation
 *This program is free software; you can redistribute it and/or modify
 *it under the terms of the GNU General Public License, version 2, as
 *published by the Free Software Foundation.
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *GNU General Public License for more details.
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#if !defined(CXD9225GGTYPES_H)
#define CXD9225GGTYPES_H


#include <asm/byteorder.h>


#if defined(__cplusplus) /* __cplusplus */
extern "C" {
#endif                   /* __cplusplus */

typedef signed long long INT64;
typedef unsigned long long UINT64;

#define IN
#define OUT
#define LOCAL
#define SEM_ID 		struct mutex
#define MSG_Q_ID	kmsg_que_id_t

typedef signed char           INT8;
typedef signed short          INT16;
typedef signed long           INT32;

typedef unsigned int    UINT;
typedef unsigned char         UINT8;
typedef unsigned short        UINT16;
typedef unsigned int         UINT32;



typedef INT8           			CXD9225GG_INT8;
typedef INT16          			CXD9225GG_INT16;
typedef INT32           		CXD9225GG_INT32;

typedef UINT8			         CXD9225GG_UINT8;
typedef UINT16						CXD9225GG_UINT16;
typedef UINT32						CXD9225GG_UINT32;

typedef INT64						CXD9225GG_LONG64;
typedef UINT64						CXD9225GG_ULONG64;

typedef void                  VOID;
typedef void                  CXD9225GG_VOID;
typedef void *                PCXD9225GG_VOID;
typedef void *             	CXD9225GG_PTR;
typedef void (*VOIDFUNCPTR)(void);
typedef void (*FUNCPTR)(int);


typedef union CXD9225GG_LONGLONG_t
{
	struct CXD9225GG_LONGLONGPARTS_t
	{
#if defined(__LITTLE_ENDIAN)
	CXD9225GG_UINT32  loData;
	CXD9225GG_INT32   hiData;
#else                            /**< ARCH_LITTLE_ENDIAN */
	CXD9225GG_INT32   hiData;
	CXD9225GG_UINT32  loData;
#endif                           /**< ARCH_LITTLE_ENDIAN */
	} i32;
	CXD9225GG_LONG64 i64;
}CXD9225GG_LONGLONG;

typedef CXD9225GG_LONGLONG CXD9225GG_INT64ST;


typedef union CXD9225GG_ULONGLONG_t
{
	struct CXD9225GG_ULONGLONGPARTS_t
	{
#if defined(__LITTLE_ENDIAN)
	CXD9225GG_UINT32  loData;
	CXD9225GG_UINT32   hiData;
#else                            /**< ARCH_LITTLE_ENDIAN */
	CXD9225GG_UINT32   hiData;
	CXD9225GG_UINT32  loData;
#endif                           /**< ARCH_LITTLE_ENDIAN */
	} i32;
	CXD9225GG_ULONG64 ui64;
}CXD9225GG_ULONGLONG;


typedef CXD9225GG_ULONGLONG CXD9225GG_UINT64ST;

typedef CXD9225GG_LONGLONG  CXD9225GG_INT64;
typedef CXD9225GG_ULONGLONG CXD9225GG_UINT64;


typedef int  CXD9225GG_BOOL;
#define CXD9225GG_FALSE (0)
#define CXD9225GG_TRUE  (1)

typedef CXD9225GG_INT8   CXD9225GG_BYTE;
typedef CXD9225GG_INT16  CXD9225GG_WORD;
typedef CXD9225GG_INT32  CXD9225GG_DWORD;
typedef CXD9225GG_INT64  CXD9225GG_QWORD;




#ifdef STATUS
#undef STATUS
#endif
typedef int STATUS;

#ifdef OK
#undef OK
#endif
#define OK      0


#ifdef ERROR
#undef ERROR
#endif
#define ERROR   -1


#ifdef NO_WAIT
#undef NO_WAIT
#endif
#define NO_WAIT   0


#ifndef BOOL
typedef unsigned int BOOL;
#endif

#ifndef TRUE
#define TRUE    1
#endif

#ifndef FALSE
#define FALSE   0
#endif


#if defined(__cplusplus) /* __cplusplus */
}
#endif /* __cplusplus */

#endif /* CXD9225GGTYPES_H */
