/* 2014-08-28: File changed by Sony Corporation */
/*
 *  Copyright 2010 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef __ASM_ARCH_HARDWARE_H
#define __ASM_ARCH_HARDWARE_H

#include <asm/sizes.h>


/*
 * Device Major ID
 */
 #define CXD9225GG_MAJOR_ID_DEBUG			(237)


//for char devices
#define CXD9225GG_MAJOR_ID_GPIO			(243)
#define CXD9225GG_MAJOR_ID_HFDMA			(244)
#define CXD9225GG_MAJOR_ID_HI_MEM			(245)
#define CXD9225GG_MAJOR_ID_SYNC			(246)
#define CXD9225GG_MAJOR_ID_CMN_DEBUG		(247)
#define CXD9225GG_MAJOR_ID_EXPCD 			(249)
#define CXD9225GG_MAJOR_ID_SFMEM			(200)
#define CXD9225GG_MAJOR_ID_UMSC 			(260)

#define CXD9225GG_MAJOR_ID_CSI             (256)

//for sytmtime device
#define CXD9225GG_MAJOR_ID_SYTMTIME		(268)


//add by IA-chengmao for LCtty
#define CXD9225GG_MAJOR_ID_LCTTY			(300)

/*
 * Physical and Fixed Virtual Addresses
 */
#define CXD9225GG_DDR2_PHYS_BASE		0x40000000
#define CXD9225GG_DDR2_VIRT_BASE		0xC0000000
#define CXD9225GG_DDR2_SIZE_MAX		SZ_512M

#define CXD9225GG_PCIE_4X_PHYS_BASE     0x60000000
#define CXD9225GG_PCIE_4X_VIRT_BASE     0xFDEE0000
#define CXD9225GG_PCIE_4X_SIZE          SZ_8K

#define CXD9225GG_PCIE_1X_0_PHYS_BASE	0x80000000
#define CXD9225GG_PCIE_1X_0_VIRT_BASE	0xFDEE2000
#define CXD9225GG_PCIE_1X_0_SIZE		SZ_8K

#define CXD9225GG_PCIE_1X_1_PHYS_BASE	0x90000000
#define CXD9225GG_PCIE_1X_1_VIRT_BASE	0xFDEE4000
#define CXD9225GG_PCIE_1X_1_SIZE		SZ_8K

/* PCIE AXI BR */
#define CXD9225GG_PCIE_BUSC_REG_PHYS_BASE	0xBFED0000
#define CXD9225GG_PCIE_BUSC_REG_VIRT_BASE	0xFDEE6000
#define CXD9225GG_PCIE_BUSC_REG_SIZE	(SZ_8K + SZ_4K)
#define CXD9225GG_PCIE_1X_0_BUSC_REG_PHYS_BASE	CXD9225GG_PCIE_BUSC_REG_PHYS_BASE
#define CXD9225GG_PCIE_1X_0_BUSC_REG_VIRT_BASE	CXD9225GG_PCIE_BUSC_REG_VIRT_BASE
#define CXD9225GG_PCIE_1X_1_BUSC_REG_PHYS_BASE	0xBFED1000
#define CXD9225GG_PCIE_1X_1_BUSC_REG_VIRT_BASE	0xFDEE7000
#define CXD9225GG_PCIE_4X_BUSC_REG_PHYS_BASE	0xBFED2000
#define CXD9225GG_PCIE_4X_BUSC_REG_VIRT_BASE	0xFDEE8000


/* AXI */
#define CXD9225GG_AXI_REG_PHYS_BASE	0xA0000000
#define CXD9225GG_AXI_REG_VIRT_BASE	0xFDC00000

/* AXI area is mapped in two sections (2M) */
#define CXD9225GG_1M_MAP_2_PHYS_BASE	CXD9225GG_AXI_REG_PHYS_BASE
#define CXD9225GG_1M_MAP_2_VIRT_BASE	CXD9225GG_AXI_REG_VIRT_BASE
#define CXD9225GG_1M_MAP_2_SIZE		SZ_1M

#define CXD9225GG_1M_MAP_1_PHYS_BASE	(CXD9225GG_AXI_REG_PHYS_BASE + SZ_1M)
#define CXD9225GG_1M_MAP_1_VIRT_BASE	(CXD9225GG_AXI_REG_VIRT_BASE + SZ_1M)
#define CXD9225GG_1M_MAP_1_SIZE		SZ_1M

/* Work RAM */
#define CXD9225GG_WORKRAM_PHYS_BASE	0xBFF00000
#define CXD9225GG_WORKRAM_VIRT_BASE	0xFDEEE000
#define CXD9225GG_WORKRAM_SIZE		SZ_8K

/* 1M section #0 */
#define CXD9225GG_1M_MAP_0_PHYS_BASE	0xEFF00000
#define CXD9225GG_1M_MAP_0_VIRT_BASE	0xFDF00000
#define CXD9225GG_1M_MAP_0_SIZE		SZ_1M

/* AHB */
#define CXD9225GG_AHB_REG_PHYS_BASE	0xE0010000

/* APB */
#define CXD9225GG_APB_REG_PHYS_BASE	0xEFFF0000
#define CXD9225GG_APB_REG_VIRT_BASE	(CXD9225GG_APB_REG_PHYS_BASE - \
					 CXD9225GG_1M_MAP_0_PHYS_BASE + \
					 CXD9225GG_1M_MAP_0_VIRT_BASE)
#define CXD9225GG_APB_REG_SIZE		SZ_64K

/*
 * Devices in AXI areas
 */
/* SYSC */
#define CXD9225GG_SYSC_REG_OFFSET		0x00030000
#define CXD9225GG_SYSC_REG_SIZE		SZ_4K
#define CXD9225GG_SYSC_REG_PHYS_BASE	(CXD9225GG_AXI_REG_PHYS_BASE + \
					 CXD9225GG_SYSC_REG_OFFSET)
#define CXD9225GG_SYSC_REG_VIRT_BASE	(CXD9225GG_AXI_REG_VIRT_BASE + \
					 CXD9225GG_SYSC_REG_OFFSET)

/* HW reset 1 */
#define CXD9225GG_SYSC_HWRST1_OFFSET	0x00C4
#define CXD9225GG_SYSC_HWRST1_VIRT		(CXD9225GG_SYSC_REG_VIRT_BASE + \
					 CXD9225GG_SYSC_HWRST1_OFFSET)

#define CXD9225GG_SYSC_HWRST2_VIRT		(CXD9225GG_SYSC_REG_VIRT_BASE + \
					 CXD9225GG_SYSC_HWRST2_OFFSET)

#define CXD9225GG_SYSCON_REG_OFFSET		0x00000800
#define CXD9225GG_SYSCON_REG_SIZE			0x0000037D
#define CXD9225GG_SYSCON_REG_PHYS_BASE	(CXD9225GG_AXI_REG_PHYS_BASE + \
					 CXD9225GG_SYSCON_REG_OFFSET)
#define CXD9225GG_SYSCON_REG_VIRT_BASE	(CXD9225GG_AXI_REG_VIRT_BASE + \
					 CXD9225GG_SYSCON_REG_OFFSET)

#define CXD9225GG_SYSC_HWRST1_PCI		(1 << 8)
#define CXD9225GG_HFDMA_REG_OFFSET		0x00020000
#define CXD9225GG_HFDMA_REG_VIRT_BASE	(CXD9225GG_AXI_REG_VIRT_BASE + \
					 CXD9225GG_HFDMA_REG_OFFSET)

/*
 * Devices in AHB areas
 */

/* the physical base address of usb target controller. */
#define CXD9225GG_USBFUNCC_REG_PHY_BASE   0xEF840000

/* attention: it maybe overlap with other memory area.
 * the virtual base address of usb target controller.
 */
#define CXD9225GG_USBFUNCC_REG_VIRT_BASE  0xFDB00000

/* attention: the size maybe NOT enough.
 * the total size of the registers of usb target controller.
 */
#define CXD9225GG_USBFUNCC_REG_SIZE       SZ_8K


/*
 * PCI controller, SF MEMC and USB Function contoller are mapped indivisually.
 * DDR2 and INTC are mapped by CXD9225GG_1M_MAP_0
 */
#include <mach/pci.h>
#include <mach/vic.h>

/*
 * Devices in APB area
 */
#include <mach/timer.h>
#include <mach/uart.h>


/* SPI NOR Flash ROM */
#define CXD9225GG_NOR_PHYS_BASE		0xFF000000
#define CXD9225GG_NOR_VIRT_BASE		0xFE000000
#define CXD9225GG_NOR_SIZE			SZ_16M

/*
 * Clock frequency
 */
#ifdef CXD9225GG_BOARD_ISYS_CLK
#define CXD9225GG_ISYS_CLK		(CXD9225GG_BOARD_ISYS_CLK)
#else
#define CXD9225GG_ISYS_CLK		(33333000)
#endif


#define CXD9225GG_APB_CLK		(CXD9225GG_ISYS_CLK * 2)
#define CXD9225GG_UART_CLK		(CXD9225GG_ISYS_CLK / 2)
#define CXD9225GG_TIMER_CLK	CXD9225GG_APB_CLK


#endif
