/*
 *  Copyright 2010 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef __ASM_ARM_ARCH_CXD9225GG_IRQS_H
#define __ASM_ARM_ARCH_CXD9225GG_IRQS_H

#define INT_IRQ_0		0
#define INT_IRQ_1		1
#define INT_IRQ_2		2
#define INT_IRQ_3		3
#define INT_IRQ_4		4
#define INT_IRQ_5		5
#define INT_IRQ_6		6
#define INT_IRQ_7		7
#define INT_IRQ_8		8
#define INT_IRQ_9		9
#define INT_IRQ_10		10
#define INT_IRQ_11		11
#define INT_IRQ_12		12
#define INT_IRQ_13		13
#define INT_IRQ_14		14
#define INT_IRQ_15		15
#define INT_IRQ_16		16
#define INT_IRQ_17		17
#define INT_IRQ_18		18
#define INT_IRQ_19		19
#define INT_IRQ_20		20
#define INT_IRQ_21		21
#define INT_IRQ_22		22
#define INT_IRQ_23		23
#define INT_IRQ_24		24
#define INT_IRQ_25		25
#define INT_IRQ_26		26
#define INT_IRQ_27		27
#define INT_IRQ_28		28
#define INT_IRQ_29		29
#define INT_IRQ_30		30
#define INT_IRQ_31		31
#define INT_IRQ_32		32
#define INT_IRQ_33		33
#define INT_IRQ_34		34
#define INT_IRQ_35		35
#define INT_IRQ_36		36
#define INT_IRQ_37		37
#define INT_IRQ_38		38
#define INT_IRQ_39		39
#define INT_IRQ_40		40
#define INT_IRQ_41		41
#define INT_IRQ_42		42
#define INT_IRQ_43		43
#define INT_IRQ_44		44
#define INT_IRQ_45		45
#define INT_IRQ_46		46
#define INT_IRQ_47		47
#define INT_IRQ_48		48
#define INT_IRQ_49		49
#define INT_IRQ_50		50
#define INT_IRQ_51		51
#define INT_IRQ_52		52
#define INT_IRQ_53		53
#define INT_IRQ_54		54
#define INT_IRQ_55		55
#define INT_IRQ_56		56
#define INT_IRQ_57		57
#define INT_IRQ_58		58
#define INT_IRQ_59		59
#define INT_IRQ_60		60
#define INT_IRQ_61		61
#define INT_IRQ_62		62
#define INT_IRQ_63		63
#define INT_IRQ_64		64
#define INT_IRQ_65		65
#define INT_IRQ_66		66
#define INT_IRQ_67		67
#define INT_IRQ_68		68
#define INT_IRQ_69		69
#define INT_IRQ_70		70
#define INT_IRQ_71		71
#define INT_IRQ_72		72
#define INT_IRQ_73		73
#define INT_IRQ_74		74
#define INT_IRQ_75		75
#define INT_IRQ_76		76
#define INT_IRQ_77		77
#define INT_IRQ_78		78
#define INT_IRQ_79		79
#define INT_IRQ_80		80
#define INT_IRQ_81		81
#define INT_IRQ_82		82
#define INT_IRQ_83		83
#define INT_IRQ_84		84
#define INT_IRQ_85		85
#define INT_IRQ_86		86
#define INT_IRQ_87		87
#define INT_IRQ_88		88
#define INT_IRQ_89		89
#define INT_IRQ_90		90
#define INT_IRQ_91		91
#define INT_IRQ_92		92
#define INT_IRQ_93		93
#define INT_IRQ_94		94
#define INT_IRQ_95		95
#define INT_IRQ_96		96
#define INT_IRQ_97		97
#define INT_IRQ_98		98
#define INT_IRQ_99		99
#define INT_IRQ_100		100
#define INT_IRQ_101		101
#define INT_IRQ_102		102
#define INT_IRQ_103		103
#define INT_IRQ_104		104
#define INT_IRQ_105		105
#define INT_IRQ_106		106
#define INT_IRQ_107		107
#define INT_IRQ_108		108
#define INT_IRQ_109		109
#define INT_IRQ_110		110
#define INT_IRQ_111		111
#define INT_IRQ_112		112
#define INT_IRQ_113		113
#define INT_IRQ_114		114
#define INT_IRQ_115		115
#define INT_IRQ_116		116
#define INT_IRQ_117		117
#define INT_IRQ_118		118
#define INT_IRQ_119		119
#define INT_IRQ_120		120

#define INT_LAST		INT_IRQ_120

#define NR_IRQS			(INT_LAST + 1)

#define INT_TIMER0		INT_IRQ_0
#define INT_TIMER1		INT_IRQ_1
#define INT_TIMER2		INT_IRQ_2
#define INT_TIMER3		INT_IRQ_3
#define INT_TIMER4		INT_IRQ_4
#define INT_TIMER5		INT_IRQ_5
#define INT_TIMER6		INT_IRQ_6
#define INT_TIMER7		INT_IRQ_7
#define INT_TIMER8		INT_IRQ_8
/* UART */
#define INT_UART0		INT_IRQ_9
#define INT_UART1		INT_IRQ_10
#define INT_CSI			INT_IRQ_11
#define INT_IIC			INT_IRQ_12
/* Debug */
#define INT_CPU0_COMMRX		INT_IRQ_13
#define INT_CPU0_COMMTX		INT_IRQ_14
#define INT_CPU0_PMUIRQ		INT_IRQ_15
#define INT_CPU1_COMMRX		INT_IRQ_16
#define INT_CPU1_COMMTX		INT_IRQ_17
#define INT_CPU1_PMUIRQ		INT_IRQ_18
/* AXI to AHB bridge */
#define INT_X2H_ERRINT		INT_IRQ_19
#define INT_H2H_ERRINT		INT_IRQ_20
#define INT_H2X_ERRINT		INT_IRQ_21
/* PCIExpress 1x #0 */
#define INT_PCIEX0_INTA		INT_IRQ_22
#define INT_PCIEX0_INTB		INT_IRQ_23
#define INT_PCIEX0_INTC		INT_IRQ_24
#define INT_PCIEX0_INTD		INT_IRQ_25
#define INT_PCIEX0_MSI		INT_IRQ_26
#define INT_PCIEX0_MSG		INT_IRQ_27
#define INT_PCIEX0_ERR		INT_IRQ_28
#define INT_PCIEX0_AXIERR	INT_IRQ_29
#define INT_PCIEX0_ALL		INT_IRQ_30
/* PCIExpress 1x #1 */
#define INT_PCIEX1_INTA		INT_IRQ_31
#define INT_PCIEX1_INTB		INT_IRQ_32
#define INT_PCIEX1_INTC		INT_IRQ_33
#define INT_PCIEX1_INTD		INT_IRQ_34
#define INT_PCIEX1_MSI		INT_IRQ_35
#define INT_PCIEX1_MSG		INT_IRQ_36
#define INT_PCIEX1_ERR		INT_IRQ_37
#define INT_PCIEX1_AXIERR	INT_IRQ_38
#define INT_PCIEX1_ALL		INT_IRQ_39
/* PCIExpress 4x */
#define INT_PCIEX2_INTA		INT_IRQ_40
#define INT_PCIEX2_INTB		INT_IRQ_41
#define INT_PCIEX2_INTC		INT_IRQ_42
#define INT_PCIEX2_INTD		INT_IRQ_43
#define INT_PCIEX2_MSI		INT_IRQ_44
#define INT_PCIEX2_MSG		INT_IRQ_45
#define INT_PCIEX2_ERR		INT_IRQ_46
#define INT_PCIEX2_AXIERR	INT_IRQ_47
#define INT_PCIEX2_ALL		INT_IRQ_48
#define INT_PCIEX2_ALL		INT_IRQ_48
/* USB function */
#define INT_USBDEV		INT_IRQ_49
#define INT_USBDEV_EPC		INT_IRQ_50
/* SYSC cross interrupts */
#define INT_CROSS_INT0		INT_IRQ_51
#define INT_CROSS_INT1		INT_IRQ_52
#define INT_CROSS_INT2		INT_IRQ_53
#define INT_CROSS_INT3		INT_IRQ_54
#define INT_CROSS_INT4		INT_IRQ_55
#define INT_CROSS_INT5		INT_IRQ_56
#define INT_CROSS_INT6		INT_IRQ_57
#define INT_CROSS_INT7		INT_IRQ_58
#define INT_CROSS_INT8		INT_IRQ_59
#define INT_CROSS_INT9		INT_IRQ_60
#define INT_CROSS_INT10		INT_IRQ_61
#define INT_CROSS_INT11		INT_IRQ_62
#define INT_CROSS_INT12		INT_IRQ_63
#define INT_CROSS_INT13		INT_IRQ_64
#define INT_CROSS_INT14		INT_IRQ_65
#define INT_CROSS_INT15		INT_IRQ_66
/* PCI */
#define INT_PCI_INTA		INT_IRQ_67
#define INT_PCI_INTB		INT_IRQ_68
#define INT_PCI_INTC		INT_IRQ_69
#define INT_PCI_INTD		INT_IRQ_70
#define INT_PCI_UNIT		INT_IRQ_71
/* BSIF */
#define INT_BSIF		INT_IRQ_72
#define INT_BSIF_ERR		INT_IRQ_73
/* SYSCON */
#define INT_SYSCON		INT_IRQ_74
#define INT_SYSCON_ERR		INT_IRQ_75
#define INT_STCC		INT_IRQ_76
#define INT_LBIF		INT_IRQ_77
/* AXI to NCI bridge */
#define INT_AXI2NCI_ERR		INT_IRQ_78
#define INT_NCI2AXI_ERR		INT_IRQ_79
/* BSSN */
#define INT_BSSN_INT0		INT_IRQ_80
#define INT_BSSN_INT1		INT_IRQ_81
#define INT_BSSN_ERR		INT_IRQ_82
/* DV */
#define INT_DVC_INT0		INT_IRQ_83
#define INT_DVC_INT1		INT_IRQ_84
#define INT_DVC_INT2		INT_IRQ_85
#define INT_DVC_ERR		INT_IRQ_86
/* 87 ~ 93 reserved */
/* HFDMA */
#define INT_HFDMA_CH0		INT_IRQ_94
#define INT_HFDMA_CH1		INT_IRQ_95
#define INT_HFDMA_CH2		INT_IRQ_96
#define INT_HFDMA_CH3		INT_IRQ_97
/* GPIO */
#define INT_GPIO0		INT_IRQ_100
#define INT_GPIO1		INT_IRQ_101
#define INT_GPIO2		INT_IRQ_102
#define INT_GPIO3		INT_IRQ_103
#define INT_GPIO4		INT_IRQ_104
#define INT_GPIO5		INT_IRQ_105
#define INT_GPIO6		INT_IRQ_106
#define INT_GPIO7		INT_IRQ_107
#define INT_GPIO8		INT_IRQ_108
#define INT_GPIO9		INT_IRQ_109
#define INT_GPIO10		INT_IRQ_110
#define INT_GPIO11		INT_IRQ_111
#define INT_GPIO12		INT_IRQ_112
#define INT_GPIO13		INT_IRQ_113
#define INT_GPIO14		INT_IRQ_111
#define INT_GPIO15		INT_IRQ_115
#define INT_GPIO16		INT_IRQ_116
#define INT_GPIO17		INT_IRQ_117
#define INT_GPIO18		INT_IRQ_118
#define INT_GPIO19		INT_IRQ_119
/* MTCC */
#define INT_MTCC		INT_IRQ_120


#define	CXD9225GG_IRQDETECT_LEVEL_LOW	0
#define	CXD9225GG_IRQDETECT_LEVEL_HIGH	1
#define	CXD9225GG_IRQDETECT_EDGE_FALLING	2
#define	CXD9225GG_IRQDETECT_EDGE_RISING	3
#define	CXD9225GG_IRQDETECT_EDGE_BOTH	4



#endif /* __ASM_ARM_ARCH_CXD9225GG_IRQS_H */
