/*
 * Copyright (C) 2012 Sony Corporation 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License, version 2, as 
 * published by the Free Software Foundation. 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __INCusbExth
#define __INCusbExth


#include "cxd9225gg_usbEvalLib.h"


/** self-diagnosis function */
#define USB_DIAGNOSE_REGISTER_RW   (0x00000006)
#define USB_DIAGNOSE_POWERSW       (0x00000014)

/** function declaration */

extern int usbHwInitialize(void);
extern int usbHwReInit(void); 
extern int usbReInit(PUSBTARGET       pTarget);

void usbHwTerminate(void);
extern struct usbTarget *usbInitialize(void);
void usbTerminate(void);
extern unsigned long usbVersionGet(void);
extern unsigned int usbConnectStatusGet(void); 
extern unsigned int usbEnableFlgGet(void);  

extern int usbSelfDiagnose(int SDFlg);

extern void usbBulkOutRemainSizeGet(int *dmaResult,
                                               unsigned long *dmaRemainSize);
extern void usbBulkInRemainSizeGet(int *dmaResult,
                                              unsigned long *dmaRemainSize);

#endif    /* __INCusbExth */
