/* 2014-08-28: File changed by Sony Corporation */
/*
 * Copyright 2012 Sony Corporation
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/**
 * @file cxd9225gg_Chipset.h
 * @note
 * Defined I/O address and Macro of CXD9225GG internal devices.
 */

#ifndef	INCcxd9225ggChipseth
#define	INCcxd9225ggChipseth

#ifdef __cplusplus
extern "C" {
#endif

#include <mach/hardware.h>  /*for virt address*/

/* memory map */

/* All Device Base Address */
#define CXD9225GG_SDRAM_MIRROR_BASE	0x00000000
#define CXD9225GG_SDRAM_REAL_BASE		0x40000000
#define CXD9225GG_PCIEX4L_MEM_SPACE_BASE	0x60000000
#define CXD9225GG_PCIEX1L0_MEM_SPACE_BASE	0x80000000
#define CXD9225GG_PCIEX1L1_MEM_SPACE_BASE	0x90000000
#define CXD9225GG_AXI64_BASE		0xA0000000
#define CXD9225GG_BUSPM_BASE		0xA0000000
/* #define CXD9225GG_SYSCONIF_BASE		0xA0000800 */
#define CXD9225GG_SYSCONIF_BASE     CXD9225GG_SYSCON_REG_VIRT_BASE
#define CXD9225GG_LBIF_BCUMTC_BASE		0xA0001000
#define CXD9225GG_LBIF_STCC_BASE		0xA0001600
#define CXD9225GG_AXI2NCI_BASE		0xA0001800
#define CXD9225GG_NCI2AXI_BASE		0xA0001880
#define CXD9225GG_BSIF_BASE		0xA0002000
#define CXD9225GG_DVCODECC_BASE		0xA0010000

#define CXD9225GG_HFDMAC_BASE  CXD9225GG_HFDMA_REG_VIRT_BASE

#define CXD9225GG_SYSC_BASE		(CXD9225GG_1M_MAP_2_VIRT_BASE + 0x30000)
#define CXD9225GG_PCIEX1L0_AXIBR_BASE	0xBFED0000
#define CXD9225GG_PCIEX1L1_AXIBR_BASE	0xBFED1000
#define CXD9225GG_PCIEX4L_AXIBR_BASE	0xBFED2000
#define CXD9225GG_WKRAM_BASE		0xBFF00000
#define CXD9225GG_PCI_MEM_SPACE_BASE	0xD0000000
#define CXD9225GG_PCI_CFG_SPACE_BASE	0xE0000000
#define CXD9225GG_PCI_BUSC_BASE		0xE0010000
#define CXD9225GG_AHB_BASE			0xE0010000
#define CXD9225GG_SFMEMC_BASE		0xE0020000


#define CXD9225GG_USBFUNCC_BASE   CXD9225GG_USBFUNCC_REG_VIRT_BASE

#define CXD9225GG_DDR2_MEMC_BASE		0xEFF40000
#define CXD9225GG_CPU0_INTC_BASE		0xEFFD0000
#define CXD9225GG_CPU1_INTC_BASE		0xEFFE0000

#define CXD9225GG_APBSS_BASE   CXD9225GG_APB_REG_VIRT_BASE
#define CXD9225GG_FLASH_BASE		0xFF000000

#define CXD9225GG_SDRAM_SIZE		0x20000000
#define CXD9225GG_PCIEX4L_MEM_SPACE_SIZE	0x20000000
#define CXD9225GG_PCIEX1L0_MEM_SPACE_SIZE	0x10000000
#define CXD9225GG_PCIEX1L1_MEM_SPACE_SIZE	0x10000000
#define CXD9225GG_AXI64_SIZE		0x00040000
#define CXD9225GG_BUSPM_SIZE		0x00000800
#define CXD9225GG_SYSCONIF_SIZE		0x00000800
#define CXD9225GG_LBIF_BCUMTC_SIZE		0x00000200
#define CXD9225GG_LBIF_STCC_SIZE		0x00000100
#define CXD9225GG_AXI2NCI_SIZE		0x00000080
#define CXD9225GG_NCI2AXI_SIZE		0x00000080
#define CXD9225GG_BSIF_SIZE		0x00003000
#define CXD9225GG_DVCODECC_SIZE		0x00010000
#define CXD9225GG_HFDMAC_SIZE		0x00001000
#define CXD9225GG_SYSC_SIZE		0x00001000
#define CXD9225GG_PCIEX1L0_AXIBR_SIZE	0x00001000
#define CXD9225GG_PCIEX1L1_AXIBR_SIZE	0x00001000
#define CXD9225GG_PCIEX4L_AXIBR_SIZE	0x00001000
#define CXD9225GG_WKRAM_SIZE		0x00002000
#define CXD9225GG_PCI_MEM_SPACE_SIZE	0x10000000
#define CXD9225GG_PCI_CFG_SPACE_SIZE	0x00010000
#define CXD9225GG_PCI_BUSC_SIZE		0x00000400
#define CXD9225GG_AHB_SIZE			0x0FFF0000
#define CXD9225GG_SFMEMC_SIZE		0x00000400
#define CXD9225GG_USBFUNCC_SIZE		0x00002000
#define CXD9225GG_DDR2_MEMC_SIZE		0x00000400
#define CXD9225GG_CPU0_INTC_SIZE		0x00010000
#define CXD9225GG_CPU1_INTC_SIZE		0x00010000
#define CXD9225GG_APBSS_SIZE		0x00010000
#define CXD9225GG_FLASH_SIZE		0x01000000	/* Flash Erea Size */


/* HFDMA Control Register */

#define CXD9225GG_HFDMAC_SRST_OFFSET	0x0000
#define CXD9225GG_HFDMAC_CLKG_OFFSET	0x0004
#define CXD9225GG_HFDMAC_INTS_OFFSET	0x0008
#define CXD9225GG_HFDMAC_INTM_OFFSET	0x000C
#define CXD9225GG_HFDMAC_CSTS_OFFSET	0x0010
#define CXD9225GG_HFDMAC_ACNT_OFFSET	0x0018
#define CXD9225GG_HFDMAC_AP0S_OFFSET	0x0020
#define CXD9225GG_HFDMAC_AP0E_OFFSET	0x0024
#define CXD9225GG_HFDMAC_AP1S_OFFSET	0x0028
#define CXD9225GG_HFDMAC_AP1E_OFFSET	0x002C
#define CXD9225GG_HFDMAC_ADSA_OFFSET	0x0030
#define CXD9225GG_HFDMAC_ADEA_OFFSET	0x0034
#define CXD9225GG_HFDMAC_DSCD_OFFSET	0x0038
#define CXD9225GG_HFDMAC_AXIS_OFFSET	0x003C

#define CXD9225GG_HFDMAC_SRST	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_SRST_OFFSET)
#define   CXD9225GG_HFDMAC_SRST_ALLRESET		0x0000000F
#define   CXD9225GG_HFDMAC_SRST_ALLUNRESET		0x00000000
#define CXD9225GG_HFDMAC_CLKG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_CLKG_OFFSET)
#define   CXD9225GG_HFDMAC_CLKG_ALLON		0x0000000F
#define   CXD9225GG_HFDMAC_CLKG_ALLOFF		0x00000000
#define CXD9225GG_HFDMAC_INTS	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_INTS_OFFSET)
#define   CXD9225GG_HFDMAC_INTS_ALLCLEAR		0xFFFFFFFF
#define   CXD9225GG_HFDMAC_INTS_DSC_FIN		0x00000001
#define   CXD9225GG_HFDMAC_INTS_DSC_STP		0x00000002
#define   CXD9225GG_HFDMAC_INTS_LST_FIN		0x00000004
#define   CXD9225GG_HFDMAC_INTS_LST_STP		0x00000008
#define   CXD9225GG_HFDMAC_INTS_LST_QUE		0x00000010
#define   CXD9225GG_HFDMAC_INTS_QUE_EMP		0x00000020
#define   CXD9225GG_HFDMAC_INTS_SCH_STP		0x00000040
#define   CXD9225GG_HFDMAC_INTS_EXC_STP		0x00000080
#define   CXD9225GG_HFDMAC_INTS_DSC_FMT_ERR	0x00010000
#define   CXD9225GG_HFDMAC_INTS_DMA_PHB0_ERR	0x00020000
#define   CXD9225GG_HFDMAC_INTS_DMA_PHB1_ERR	0x00040000
#define   CXD9225GG_HFDMAC_INTS_DSC_AREA_ERR	0x00080000
#define   CXD9225GG_HFDMAC_INTS_QUE_WR_ERR		0x00100000
#define   CXD9225GG_HFDMAC_INTS_AM_BRESP_ERR	0x00200000
#define   CXD9225GG_HFDMAC_INTS_AM_RRESP_ERR	0x00400000
#define   CXD9225GG_HFDMAC_INTS_AM_RLEN_ERR	0x00800000
#define CXD9225GG_HFDMAC_INTM	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_INTM_OFFSET)
#define   CXD9225GG_HFDMAC_INTM_ALLMASK		0x000F000F
#define CXD9225GG_HFDMAC_CSTS	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_CSTS_OFFSET)
#define CXD9225GG_HFDMAC_ACNT	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_ACNT_OFFSET)
#define CXD9225GG_HFDMAC_AP0S	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_AP0S_OFFSET)
#define CXD9225GG_HFDMAC_AP0E	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_AP0E_OFFSET)
#define CXD9225GG_HFDMAC_AP1S	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_AP1S_OFFSET)
#define CXD9225GG_HFDMAC_AP1E	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_AP1E_OFFSET)
#define CXD9225GG_HFDMAC_ADSA	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_ADSA_OFFSET)
#define CXD9225GG_HFDMAC_ADEA	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_ADEA_OFFSET)
#define CXD9225GG_HFDMAC_DSCD	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_DSCD_OFFSET)
#define CXD9225GG_HFDMAC_AXIS	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_AXIS_OFFSET)

#define CXD9225GG_HFDMAC_CTRL_CHREG_OFFSET		0x0100
#define CXD9225GG_HFDMAC_AXMS_CHREG_OFFSET		0x0104
#define CXD9225GG_HFDMAC_INTS_CHREG_OFFSET		0x0108
#define CXD9225GG_HFDMAC_INTM_CHREG_OFFSET		0x010C
#define CXD9225GG_HFDMAC_QENT_LID_CHREG_OFFSET	0x0110
#define CXD9225GG_HFDMAC_QENT_DSA_CHREG_OFFSET	0x0114
#define CXD9225GG_HFDMAC_QENT_SBA_CHREG_OFFSET	0x0118
#define CXD9225GG_HFDMAC_QENT_DBA_CHREG_OFFSET	0x011C
#define CXD9225GG_HFDMAC_QNUM_CHREG_OFFSET		0x0120
#define CXD9225GG_HFDMAC_DSTS_CHREG_OFFSET		0x0128
#define CXD9225GG_HFDMAC_DBGS_CHREG_OFFSET		0x012C
#define CXD9225GG_HFDMAC_AMSA_CHREG_OFFSET		0x0130
#define CXD9225GG_HFDMAC_AMDA_CHREG_OFFSET		0x0134
#define CXD9225GG_HFDMAC_DLST_CHREG_OFFSET		0x0138
#define CXD9225GG_HFDMAC_DSCR_CHREG_OFFSET		0x0148
#define CXD9225GG_HFDMAC_DSCA_CHREG_OFFSET		0x019C
#define CXD9225GG_HFDMAC_SCHC_CHREG_OFFSET		0x01A0
#define CXD9225GG_HFDMAC_SCHA_CHREG_OFFSET		0x01A8
#define CXD9225GG_HFDMAC_SCHD_CHREG_OFFSET		0x01AC
#define CXD9225GG_HFDMAC_CSMD_CHREG_OFFSET		0x01B0
#define CXD9225GG_HFDMAC_CSRT_CHREG_OFFSET		0x01B8

#define CXD9225GG_HFDMAC_CHREG_OFFSET	0x0100

#define CXD9225GG_HFDMAC_CTRL_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_CTRL_CHREG_OFFSET)
#define   CXD9225GG_HFDMAC_CTRL_DMA_EN		0x00000001
#define   CXD9225GG_HFDMAC_CTRL_DSC_STOP		0x00000002
#define   CXD9225GG_HFDMAC_CTRL_DSC_RESTART	0x00000004
#define   CXD9225GG_HFDMAC_CTRL_LST_CLR		0x00000008
#define   CXD9225GG_HFDMAC_CTRL_LST_STOP		0x00000010
#define   CXD9225GG_HFDMAC_CTRL_LST_RESTART	0x00000020
#define   CXD9225GG_HFDMAC_CTRL_SCH_COUNT_CLR	0x00000040
#define   CXD9225GG_HFDMAC_CTRL_CHK_SUM_CLR	0x00000080
#define   CXD9225GG_HFDMAC_CTRL_QUE_CLR		0x00000100
#define CXD9225GG_HFDMAC_AXMS_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_AXMS_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_INTS_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_INTS_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_INTM_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_INTM_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_QENT_LID_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_QENT_LID_CHREG_OFFSET)
#define   CXD9225GG_HFDMAC_QENT_LID_MASK		0x0000FFFF
#define   CXD9225GG_HFDMAC_QENT_LCNT_I		0x01000000
#define   CXD9225GG_HFDMAC_QENT_LCNT_S		0x02000000
#define CXD9225GG_HFDMAC_QENT_DSA_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_QENT_DSA_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_QENT_SBA_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_QENT_SBA_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_QENT_DBA_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_QENT_DBA_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_QNUM_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_QNUM_CHREG_OFFSET)
#define   CXD9225GG_HFDMAC_QNUM_QUE_NUM_MASK	0x0000000F
#define   CXD9225GG_HFDMAC_QNUM_QUE_NUM_SHIFT	(0)
#define   CXD9225GG_HFDMAC_QNUM_QUE_EMP_NUM_MASK	0x000F0000
#define   CXD9225GG_HFDMAC_QNUM_QUE_EMP_NUM_SHIFT	(16)
#define CXD9225GG_HFDMAC_DSTS_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_DSTS_CHREG_OFFSET)
#define   CXD9225GG_HFDMAC_DSTS_AM_SRC		0x00000001
#define   CXD9225GG_HFDMAC_DSTS_AM_DST		0x00000002
#define   CXD9225GG_HFDMAC_DSTS_DSC_MASK		0x00000700
#define   CXD9225GG_HFDMAC_DSTS_DSC_IDLE		0x00000000
#define   CXD9225GG_HFDMAC_DSTS_DSC_BUSY		0x00000100
#define   CXD9225GG_HFDMAC_DSTS_DSC_PAUSE1		0x00000200
#define   CXD9225GG_HFDMAC_DSTS_DSC_RDERR		0x00000300
#define   CXD9225GG_HFDMAC_DSTS_DSC_RUN		0x00000400
#define   CXD9225GG_HFDMAC_DSTS_DSC_PAUSE2		0x00000500
#define   CXD9225GG_HFDMAC_DSTS_DSC_PAUSE3		0x00000600
#define   CXD9225GG_HFDMAC_DSTS_DSC_ERROR		0x00000700
#define   CXD9225GG_HFDMAC_DSTS_LST_MASK		0x00007000
#define   CXD9225GG_HFDMAC_DSTS_LST_IDLE		0x00000000
#define   CXD9225GG_HFDMAC_DSTS_LST_READ		0x00001000
#define   CXD9225GG_HFDMAC_DSTS_LST_RUN		0x00004000
#define   CXD9225GG_HFDMAC_DSTS_LST_PAUSE		0x00006000
#define   CXD9225GG_HFDMAC_DSTS_AM_BRESP_MASK	0x00030000
#define   CXD9225GG_HFDMAC_DSTS_AM_BRESP_OKAY	0x00000000
#define   CXD9225GG_HFDMAC_DSTS_AM_BRESP_EXOKAY	0x00010000
#define   CXD9225GG_HFDMAC_DSTS_AM_BRESP_SLVERR	0x00020000
#define   CXD9225GG_HFDMAC_DSTS_AM_BRESP_DECERR	0x00030000
#define   CXD9225GG_HFDMAC_DSTS_AM_RRESP_MASK	0x000C0000
#define   CXD9225GG_HFDMAC_DSTS_AM_RRESP_OKAY	0x00000000
#define   CXD9225GG_HFDMAC_DSTS_AM_RRESP_EXOKAY	0x00040000
#define   CXD9225GG_HFDMAC_DSTS_AM_RRESP_SLVERR	0x00080000
#define   CXD9225GG_HFDMAC_DSTS_AM_RRESP_DECERR	0x000C0000
#define CXD9225GG_HFDMAC_DBGS_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_DBGS_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_AMSA_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_AMSA_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_AMDA_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_AMDA_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_DLST_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_DLST_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_DSCR_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_DSCR_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_DSCA_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_DSCA_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_SCHC_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_SCHC_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_SCHA_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_SCHA_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_SCHD_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_SCHD_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_CSMD_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_CSMD_CHREG_OFFSET)
#define CXD9225GG_HFDMAC_CSRT_CHREG	(CXD9225GG_HFDMAC_BASE + CXD9225GG_HFDMAC_CSRT_CHREG_OFFSET)


/* System Control Register */

#define CXD9225GG_SYSC_GENX_OFFSET		0x0000
#define CXD9225GG_SYSC_INT_OFFSET		0x0080
#define CXD9225GG_SYSC_EXX_OFFSET		0x0084
#define CXD9225GG_SYSC_CPUREC_OFFSET	0x00A4
#define CXD9225GG_SYSC_GCTS0_OFFSET	0x00A8
#define CXD9225GG_SYSC_GCTS1_OFFSET	0x00AC
#define CXD9225GG_SYSC_GCTS2_OFFSET	0x00B0
#define CXD9225GG_SYSC_GCTS3_OFFSET	0x00B4
#define CXD9225GG_SYSC_GCTS4_OFFSET	0x00B8
#define CXD9225GG_SYSC_GCTS5_OFFSET	0x00BC
#define CXD9225GG_SYSC_HWRST0_OFFSET	0x00C0
#define CXD9225GG_SYSC_HWRST1_OFFSET	0x00C4
#define CXD9225GG_SYSC_HWRST2_OFFSET	0x00C8
#define CXD9225GG_SYSC_HWRST3_OFFSET	0x00CC
#define CXD9225GG_SYSC_HWRST4_OFFSET	0x00D0
#define CXD9225GG_SYSC_HWRST5_OFFSET	0x00D4
#define CXD9225GG_SYSC_CLKCNT_OFFSET	0x00D8
#define CXD9225GG_SYSC_VERX_OFFSET		0x00DC
#define CXD9225GG_SYSC_CLKDET_OFFSET	0x011C
#define CXD9225GG_SYSC_CLKDETSTART_OFFSET	0x0120
#define CXD9225GG_SYSC_DRPOUT_OFFSET	0x0124
#define CXD9225GG_SYSC_DRPCLKDIV_OFFSET	0x0128
#define CXD9225GG_SYSC_CPU0CLKDIV1_OFFSET	0x012C
#define CXD9225GG_SYSC_CPU0CLKDIV2_OFFSET	0x0130
#define CXD9225GG_SYSC_CPU1CLKDIV1_OFFSET	0x0134
#define CXD9225GG_SYSC_CPU1CLKDIV2_OFFSET	0x0138
#define CXD9225GG_SYSC_CPU0CLKDIV_MONI_OFFSET 0x013C
#define CXD9225GG_SYSC_CPU1CLKDIV_MONI_OFFSET 0x0140
#define CXD9225GG_SYSC_TEST_OFFSET		0x0144
#define CXD9225GG_SYSC_MACRO_CTL0_OFFSET	0x0160
#define CXD9225GG_SYSC_MACRO_CTL1_OFFSET	0x0164
#define CXD9225GG_SYSC_MACRO_CTL2_OFFSET	0x0168
#define CXD9225GG_SYSC_MACRO_CTL3_OFFSET	0x016C
#define CXD9225GG_SYSC_MACRO_CTL4_OFFSET	0x0170
#define CXD9225GG_SYSC_MACRO_CTL5_OFFSET	0x0174
#define CXD9225GG_SYSC_MACRO_CTL6_OFFSET	0x0178
#define CXD9225GG_SYSC_MACRO_CTL7_OFFSET	0x017C
#define CXD9225GG_SYSC_MACRO_CTL8_OFFSET	0x0180
#define CXD9225GG_SYSC_MACRO_CTL9_OFFSET	0x0184
#define CXD9225GG_SYSC_MACRO_CTL10_OFFSET	0x0188
#define CXD9225GG_SYSC_MACRO_CTL11_OFFSET	0x018C
#define CXD9225GG_SYSC_MACRO_CTL12_OFFSET	0x0190
#define CXD9225GG_SYSC_MACRO_CTL13_OFFSET	0x0194
#define CXD9225GG_SYSC_MACRO_CTL14_OFFSET	0x0198
#define CXD9225GG_SYSC_MACRO_CTL15_OFFSET	0x019C
#define CXD9225GG_SYSC_MACRO_CTL16_OFFSET	0x01A0
#define CXD9225GG_SYSC_MACRO_CTL17_OFFSET	0x01A4
#define CXD9225GG_SYSC_MACRO_CTL18_OFFSET	0x01A8
#define CXD9225GG_SYSC_MACRO_CTL19_OFFSET	0x01AC
#define CXD9225GG_SYSC_MACRO_CTL20_OFFSET	0x01B0
#define CXD9225GG_SYSC_MACRO_CTL21_OFFSET	0x01B4
#define CXD9225GG_SYSC_MACRO_CTL22_OFFSET	0x01B8
#define CXD9225GG_SYSC_MACRO_CTL23_OFFSET	0x01BC
#define CXD9225GG_SYSC_MACRO_CTL24_OFFSET	0x01C0
#define CXD9225GG_SYSC_MACRO_CTL25_OFFSET	0x01C4
#define CXD9225GG_SYSC_MACRO_CTL26_OFFSET	0x01C8
#define CXD9225GG_SYSC_MACRO_CTL27_OFFSET	0x01CC
#define CXD9225GG_SYSC_MACRO_CTL28_OFFSET	0x01D0
#define CXD9225GG_SYSC_MACRO_CTL29_OFFSET	0x01D4
#define CXD9225GG_SYSC_MACRO_CTL30_OFFSET	0x01D8
#define CXD9225GG_SYSC_MACRO_CTL31_OFFSET	0x01DC
#define CXD9225GG_SYSC_MACRO_STS0_OFFSET	0x01E0
#define CXD9225GG_SYSC_MACRO_STS1_OFFSET	0x01E4
#define CXD9225GG_SYSC_MACRO_STS2_OFFSET	0x01E8
#define CXD9225GG_SYSC_MACRO_STS3_OFFSET	0x01EC
#define CXD9225GG_SYSC_MACRO_STS4_OFFSET	0x01F0
#define CXD9225GG_SYSC_MACRO_STS5_OFFSET	0x01F4
#define CXD9225GG_SYSC_MACRO_STS6_OFFSET	0x01F8
#define CXD9225GG_SYSC_MACRO_STS7_OFFSET	0x01FC
#define CXD9225GG_SYSC_MACRO_STS8_OFFSET	0x0200
#define CXD9225GG_SYSC_MACRO_STS9_OFFSET	0x0204
#define CXD9225GG_SYSC_MACRO_STS10_OFFSET	0x0208
#define CXD9225GG_SYSC_MACRO_STS11_OFFSET	0x020C
#define CXD9225GG_SYSC_MACRO_STS12_OFFSET	0x0210
#define CXD9225GG_SYSC_MACRO_STS13_OFFSET	0x0214
#define CXD9225GG_SYSC_MACRO_STS14_OFFSET	0x0218
#define CXD9225GG_SYSC_MACRO_STS15_OFFSET	0x021C
#define CXD9225GG_SYSC_MACRO_STS16_OFFSET	0x0220
#define CXD9225GG_SYSC_MACRO_STS17_OFFSET	0x0224
#define CXD9225GG_SYSC_MACRO_STS18_OFFSET	0x0228
#define CXD9225GG_SYSC_MACRO_STS19_OFFSET	0x022C
#define CXD9225GG_SYSC_MACRO_STS20_OFFSET	0x0230
#define CXD9225GG_SYSC_MACRO_STS21_OFFSET	0x0234
#define CXD9225GG_SYSC_MACRO_STS22_OFFSET	0x0238
#define CXD9225GG_SYSC_MACRO_STS23_OFFSET	0x023C
#define CXD9225GG_SYSC_MACRO_STS24_OFFSET	0x0240
#define CXD9225GG_SYSC_MACRO_STS25_OFFSET	0x0244
#define CXD9225GG_SYSC_MACRO_STS26_OFFSET	0x0248
#define CXD9225GG_SYSC_MACRO_STS27_OFFSET	0x024C
#define CXD9225GG_SYSC_MACRO_STS28_OFFSET	0x0250
#define CXD9225GG_SYSC_MACRO_STS29_OFFSET	0x0254
#define CXD9225GG_SYSC_MACRO_STS30_OFFSET	0x0258
#define CXD9225GG_SYSC_MACRO_STS31_OFFSET	0x025C
#define CXD9225GG_SYSC_MACRO_PGN0_OFFSET	0x0260
#define CXD9225GG_SYSC_MACRO_PGN1_OFFSET	0x0264
#define CXD9225GG_SYSC_MACRO_PGN2_OFFSET	0x0268
#define CXD9225GG_SYSC_MACRO_PGN3_OFFSET	0x026C
#define CXD9225GG_SYSC_MACRO_PGN4_OFFSET	0x0270
#define CXD9225GG_SYSC_MACRO_PGN5_OFFSET	0x0274
#define CXD9225GG_SYSC_MACRO_PGN6_OFFSET	0x0278
#define CXD9225GG_SYSC_MACRO_PGN7_OFFSET	0x027C
#define CXD9225GG_SYSC_MACRO_PGN8_OFFSET	0x0280
#define CXD9225GG_SYSC_MACRO_PGN9_OFFSET	0x0284
#define CXD9225GG_SYSC_MACRO_PGN10_OFFSET	0x0288
#define CXD9225GG_SYSC_MACRO_PGN11_OFFSET	0x028C
#define CXD9225GG_SYSC_MACRO_PGN12_OFFSET	0x0290
#define CXD9225GG_SYSC_MACRO_PGN13_OFFSET	0x0294
#define CXD9225GG_SYSC_MACRO_PGN14_OFFSET	0x0298
#define CXD9225GG_SYSC_MACRO_PGN15_OFFSET	0x029C
#define CXD9225GG_SYSC_MACRO_PGN16_OFFSET	0x02A0
#define CXD9225GG_SYSC_MACRO_PGN17_OFFSET	0x02A4
#define CXD9225GG_SYSC_MACRO_PGN18_OFFSET	0x02A8
#define CXD9225GG_SYSC_MACRO_PGN19_OFFSET	0x02AC
#define CXD9225GG_SYSC_MACRO_PGN20_OFFSET	0x02B0
#define CXD9225GG_SYSC_MACRO_PGN21_OFFSET	0x02B4
#define CXD9225GG_SYSC_MACRO_PGN22_OFFSET	0x02B8
#define CXD9225GG_SYSC_MACRO_PGN23_OFFSET	0x02BC
#define CXD9225GG_SYSC_MACRO_PGN24_OFFSET	0x02C0
#define CXD9225GG_SYSC_MACRO_PGN25_OFFSET	0x02C4
#define CXD9225GG_SYSC_MACRO_PGN26_OFFSET	0x02C8
#define CXD9225GG_SYSC_MACRO_PGN27_OFFSET	0x02CC
#define CXD9225GG_SYSC_MACRO_PGN28_OFFSET	0x02D0
#define CXD9225GG_SYSC_MACRO_PGN29_OFFSET	0x02D4
#define CXD9225GG_SYSC_MACRO_PGN30_OFFSET	0x02D8
#define CXD9225GG_SYSC_MACRO_PGN31_OFFSET	0x02DC

#define CXD9225GG_SYSC_GENX		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_GENX_OFFSET)
#define CXD9225GG_SYSC_INT			(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_INT_OFFSET)
#define CXD9225GG_SYSC_EXX			(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_EXX_OFFSET)
#define CXD9225GG_SYSC_CPUREC		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CPUREC_OFFSET)
#define   CXD9225GG_SYSC_CPUREC_ARID_CPU0	0x00000001
#define   CXD9225GG_SYSC_CPUREC_ARID_CPU1	0x00000009
#define CXD9225GG_SYSC_GCTS0		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_GCTS0_OFFSET)
#define CXD9225GG_SYSC_GCTS1		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_GCTS1_OFFSET)
#define CXD9225GG_SYSC_GCTS2		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_GCTS2_OFFSET)
#define CXD9225GG_SYSC_GCTS3		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_GCTS3_OFFSET)
#define CXD9225GG_SYSC_GCTS4		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_GCTS4_OFFSET)
#define CXD9225GG_SYSC_GCTS5		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_GCTS5_OFFSET)
#define CXD9225GG_SYSC_HWRST0		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_HWRST0_OFFSET)
#define   CXD9225GG_SYSC_HWRST0_CPU0_ASRT		0x00000001
#define   CXD9225GG_SYSC_HWRST0_CPU0_DASRT		0x00000000
#define   CXD9225GG_SYSC_HWRST0_CPU1_ASRT		0x00000100
#define   CXD9225GG_SYSC_HWRST0_CPU1_DASRT		0x00000000
#define CXD9225GG_SYSC_HWRST1		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_HWRST1_OFFSET)
#define   CXD9225GG_SYSC_HWRST1_PCI_ASRT		0x00000100
#define   CXD9225GG_SYSC_HWRST1_PCI_DASRT		0x00000000
#define   CXD9225GG_SYSC_HWRST1_PCIEX1L0_ASRT	0x00010000
#define   CXD9225GG_SYSC_HWRST1_PCIEX1L0_DASRT	0x00000000
#define   CXD9225GG_SYSC_HWRST1_PCIEX1L1_ASRT	0x01000000
#define   CXD9225GG_SYSC_HWRST1_PCIEX1L1_DASRT	0x00000000
#define CXD9225GG_SYSC_HWRST2		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_HWRST2_OFFSET)
#define   CXD9225GG_SYSC_HWRST2_PCIEX4L_ASRT	0x00000001
#define   CXD9225GG_SYSC_HWRST2_PCIEX4L_DASRT	0x00000000
#define CXD9225GG_SYSC_HWRST3		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_HWRST3_OFFSET)
#define CXD9225GG_SYSC_HWRST4		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_HWRST4_OFFSET)
#define CXD9225GG_SYSC_HWRST5		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_HWRST5_OFFSET)
#define CXD9225GG_SYSC_CLKCNT		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CLKCNT_OFFSET)
#define CXD9225GG_SYSC_VERX		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_VERX_OFFSET)
#define   CXD9225GG_SYSC_VERX_ORIGINAL_SHIFT	(8)
#define   CXD9225GG_SYSC_VERX_MAJOR_SHIFT		(4)
#define   CXD9225GG_SYSC_VERX_MINOR_SHIFT		(0)
#define CXD9225GG_SYSC_CLKDET		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CLKDET_OFFSET)
#define   CXD9225GG_SYSC_CLKDET_CLK0_SYSCON	0x00000001
#define   CXD9225GG_SYSC_CLKDET_CLK1_HOSTIF	0x00000002
#define   CXD9225GG_SYSC_CLKDET_CLK2_STCC		0x00000004
#define   CXD9225GG_SYSC_CLKDET_CLK3_IBCK1		0x00000008
#define   CXD9225GG_SYSC_CLKDET_CLK4_IBCK2		0x00000010
#define   CXD9225GG_SYSC_CLKDET_CLK5_IBCK3		0x00000020
#define   CXD9225GG_SYSC_CLKDET_CLK6_IBCK4		0x00000040
#define   CXD9225GG_SYSC_CLKDET_CLK7_ABS		0x00000080
#define   CXD9225GG_SYSC_CLKDET_CLK8_LPCM		0x00000100
#define   CXD9225GG_SYSC_CLKDET_CLK9_GDIF		0x00000200
#define   CXD9225GG_SYSC_CLKDET_CLK10_PCI		0x00000400
#define   CXD9225GG_SYSC_CLKDET_CLK11_UART		0x00000800
#define CXD9225GG_SYSC_CLKDETSTART		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CLKDETSTART_OFFSET)
#define   CXD9225GG_SYSC_CLKDETSTART_CLK0_SYSCON	0x00000001
#define   CXD9225GG_SYSC_CLKDETSTART_CLK1_HOSTIF	0x00000002
#define   CXD9225GG_SYSC_CLKDETSTART_CLK2_STCC	0x00000004
#define   CXD9225GG_SYSC_CLKDETSTART_CLK3_IBCK1	0x00000008
#define   CXD9225GG_SYSC_CLKDETSTART_CLK4_IBCK2	0x00000010
#define   CXD9225GG_SYSC_CLKDETSTART_CLK5_IBCK3	0x00000020
#define   CXD9225GG_SYSC_CLKDETSTART_CLK6_IBCK4	0x00000040
#define   CXD9225GG_SYSC_CLKDETSTART_CLK7_ABS	0x00000080
#define   CXD9225GG_SYSC_CLKDETSTART_CLK8_LPCM	0x00000100
#define   CXD9225GG_SYSC_CLKDETSTART_CLK9_GDIF	0x00000200
#define   CXD9225GG_SYSC_CLKDETSTART_CLK10_PCI	0x00000400
#define   CXD9225GG_SYSC_CLKDETSTART_CLK11_UART	0x00000800
#define CXD9225GG_SYSC_DRPOUT		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_DRPOUT_OFFSET)
#define CXD9225GG_SYSC_DRPCLKDIV		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_DRPCLKDIV_OFFSET)
#define CXD9225GG_SYSC_CPU0CLKDIV1		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CPU0CLKDIV1_OFFSET)
#define CXD9225GG_SYSC_CPU0CLKDIV2		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CPU0CLKDIV2_OFFSET)
#define   CXD9225GG_SYSC_CPU0CLKDIV2_DIS		0x00000000
#define   CXD9225GG_SYSC_CPU0CLKDIV2_ENA		0x00000001
#define CXD9225GG_SYSC_CPU1CLKDIV1		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CPU1CLKDIV1_OFFSET)
#define CXD9225GG_SYSC_CPU1CLKDIV2		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CPU1CLKDIV2_OFFSET)
#define   CXD9225GG_SYSC_CPU1CLKDIV2_DIS		0x00000000
#define   CXD9225GG_SYSC_CPU1CLKDIV2_ENA		0x00000001
#define CXD9225GG_SYSC_CPU0CLKDIV_MONI	(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CPU0CLKDIV_MONI_OFFSET)
#define CXD9225GG_SYSC_CPU1CLKDIV_MONI	(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_CPU1CLKDIV_MONI_OFFSET)
#define CXD9225GG_SYSC_TEST		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_TEST_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL0		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL0_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL0_VINITHI_LOW	0x00000000
#define   CXD9225GG_SYSC_MACRO_CTL0_VINITHI_HIGH	0x00000001
#define CXD9225GG_SYSC_MACRO_CTL1		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL1_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL1_VINITHI_LOW	0x00000000
#define   CXD9225GG_SYSC_MACRO_CTL1_VINITHI_HIGH	0x00000001
#define CXD9225GG_SYSC_MACRO_CTL2		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL2_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL3		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL3_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL4		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL4_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL4_PORT_DISABLE	0x00000001
#define   CXD9225GG_SYSC_MACRO_CTL4_TX_DRV_EN	0x00000002
#define   CXD9225GG_SYSC_MACRO_CTL4_PME_STATUS	0x00000040
#define   CXD9225GG_SYSC_MACRO_CTL4_INTA_EP	0x00000100
#define   CXD9225GG_SYSC_MACRO_CTL4_INTB_EP	0x00000200
#define   CXD9225GG_SYSC_MACRO_CTL4_INTC_EP	0x00000400
#define   CXD9225GG_SYSC_MACRO_CTL4_INTD_EP	0x00000800
#define CXD9225GG_SYSC_MACRO_CTL5		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL5_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL5_PORT_DISABLE	0x00000001
#define   CXD9225GG_SYSC_MACRO_CTL5_TX_DRV_EN	0x00000002
#define   CXD9225GG_SYSC_MACRO_CTL5_PME_STATUS	0x00000040
#define   CXD9225GG_SYSC_MACRO_CTL5_INTA_EP	0x00000100
#define   CXD9225GG_SYSC_MACRO_CTL5_INTB_EP	0x00000200
#define   CXD9225GG_SYSC_MACRO_CTL5_INTC_EP	0x00000400
#define   CXD9225GG_SYSC_MACRO_CTL5_INTD_EP	0x00000800
#define CXD9225GG_SYSC_MACRO_CTL6		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL6_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL6_PORT_DISABLE	0x00000001
#define   CXD9225GG_SYSC_MACRO_CTL6_TX_DRV_EN	0x00000002
#define   CXD9225GG_SYSC_MACRO_CTL6_PME_STATUS	0x00000040
#define   CXD9225GG_SYSC_MACRO_CTL6_INTA_EP	0x00000100
#define   CXD9225GG_SYSC_MACRO_CTL6_INTB_EP	0x00000200
#define   CXD9225GG_SYSC_MACRO_CTL6_INTC_EP	0x00000400
#define   CXD9225GG_SYSC_MACRO_CTL6_INTD_EP	0x00000800
#define CXD9225GG_SYSC_MACRO_CTL7		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL7_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL8		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL8_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL9		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL9_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL9_URCKSEL	0x00000001
#define CXD9225GG_SYSC_MACRO_CTL10		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL10_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL11		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL11_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL12		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL12_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL13		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL13_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL14		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL14_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL15		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL15_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL16		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL16_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL17		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL17_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL17_STCCKDIV	0x00000001
#define CXD9225GG_SYSC_MACRO_CTL18		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL18_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL19		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL19_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL20		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL20_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL21		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL21_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL21_REMAP_EN	0x00000001
#define CXD9225GG_SYSC_MACRO_CTL22		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL22_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL23		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL23_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL24		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL24_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL25		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL25_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL25_CNTEN		0x00000001
#define CXD9225GG_SYSC_MACRO_CTL26		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL26_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL27		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL27_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL28		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL28_OFFSET)
#define CXD9225GG_SYSC_MACRO_CTL29		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL29_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL29_RSTINT_MSK	0x00000001
#define   CXD9225GG_SYSC_MACRO_CTL29_CNTINT_MSK	0x00000002
#define CXD9225GG_SYSC_MACRO_CTL30		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL30_OFFSET)
#define   CXD9225GG_SYSC_MACRO_CTL30_RSTINT_PLS	0x00000001
#define   CXD9225GG_SYSC_MACRO_CTL30_RSTINT_LVLNON	0x00000000
#define   CXD9225GG_SYSC_MACRO_CTL30_RSTINT_LVLHI	0x00000100
#define   CXD9225GG_SYSC_MACRO_CTL30_RSTINT_LVLLOW	0x00000200
#define   CXD9225GG_SYSC_MACRO_CTL30_RSTINT_LVLBTH	0x00000300
#define CXD9225GG_SYSC_MACRO_CTL31		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_CTL31_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS0		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS0_OFFSET)
#define   CXD9225GG_SYSC_MACRO_STS0_STANDBYWFI	0x00000001
#define   CXD9225GG_SYSC_MACRO_STS0_DBGNOPOWRRDWN	0x00000002
#define CXD9225GG_SYSC_MACRO_STS1		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS1_OFFSET)
#define   CXD9225GG_SYSC_MACRO_STS1_STANDBYWFI	0x00000001
#define   CXD9225GG_SYSC_MACRO_STS1_DBGNOPOWRRDWN	0x00000002
#define CXD9225GG_SYSC_MACRO_STS2		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS2_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS3		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS3_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS4		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS4_OFFSET)
#define   CXD9225GG_SYSC_MACRO_STS4_PLL_LOCK	0x00000001
#define   CXD9225GG_SYSC_MACRO_STS4_TURN_OFF_EVENT	0x00000010
#define   CXD9225GG_SYSC_MACRO_STS4_D3_EVENT	0x00000020
#define   CXD9225GG_SYSC_MACRO_STS4_PME_STATUS	0x00000040
#define CXD9225GG_SYSC_MACRO_STS5		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS5_OFFSET)
#define   CXD9225GG_SYSC_MACRO_STS5_PLL_LOCK	0x00000001
#define   CXD9225GG_SYSC_MACRO_STS5_TURN_OFF_EVENT	0x00000010
#define   CXD9225GG_SYSC_MACRO_STS5_D3_EVENT	0x00000020
#define   CXD9225GG_SYSC_MACRO_STS5_PME_STATUS	0x00000040
#define CXD9225GG_SYSC_MACRO_STS6		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS6_OFFSET)
#define   CXD9225GG_SYSC_MACRO_STS6_PLL_LOCK	0x00000001
#define   CXD9225GG_SYSC_MACRO_STS6_TURN_OFF_EVENT	0x00000010
#define   CXD9225GG_SYSC_MACRO_STS6_D3_EVENT	0x00000020
#define   CXD9225GG_SYSC_MACRO_STS6_PME_STATUS	0x00000040
#define CXD9225GG_SYSC_MACRO_STS7		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS7_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS8		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS8_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS9		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS9_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS10		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS10_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS11		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS11_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS12		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS12_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS13		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS13_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS14		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS14_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS15		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS15_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS16		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS16_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS17		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS17_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS18		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS18_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS19		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS19_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS20		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS20_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS21		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS21_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS22		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS22_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS23		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS23_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS24		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS24_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS25		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS25_OFFSET)
#define   CXD9225GG_SYSC_MACRO_STS25_CNTEN_STS	0x00000001
#define   CXD9225GG_SYSC_MACRO_STS25_RST_STS	0x00000002
#define CXD9225GG_SYSC_MACRO_STS26		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS26_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS27		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS27_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS28		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS28_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS29		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS29_OFFSET)
#define   CXD9225GG_SYSC_MACRO_STS25_RSTINT_STS	0x00000001
#define   CXD9225GG_SYSC_MACRO_STS25_CNTINT_STS	0x00000002
#define CXD9225GG_SYSC_MACRO_STS30		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS30_OFFSET)
#define CXD9225GG_SYSC_MACRO_STS31		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_STS31_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN0		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN0_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN1		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN1_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN2		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN2_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN3		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN3_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN4		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN4_OFFSET)
#define   CXD9225GG_SYSC_MACRO_PGN4_TURN_OFF_EVENT_ACK	0x00000010
#define   CXD9225GG_SYSC_MACRO_PGN4_D3_EVENT_ACK		0x00000020
#define CXD9225GG_SYSC_MACRO_PGN5		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN5_OFFSET)
#define   CXD9225GG_SYSC_MACRO_PGN5_TURN_OFF_EVENT_ACK	0x00000010
#define   CXD9225GG_SYSC_MACRO_PGN5_D3_EVENT_ACK		0x00000020
#define CXD9225GG_SYSC_MACRO_PGN6		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN6_OFFSET)
#define   CXD9225GG_SYSC_MACRO_PGN6_TURN_OFF_EVENT_ACK	0x00000010
#define   CXD9225GG_SYSC_MACRO_PGN6_D3_EVENT_ACK		0x00000020
#define CXD9225GG_SYSC_MACRO_PGN7		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN7_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN8		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN8_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN9		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN9_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN10		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN10_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN11		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN11_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN12		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN12_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN13		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN13_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN14		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN14_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN15		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN15_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN16		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN16_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN17		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN17_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN18		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN18_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN19		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN19_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN20		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN20_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN21		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN21_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN22		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN22_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN23		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN23_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN24		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN24_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN25		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN25_OFFSET)
#define   CXD9225GG_SYSC_MACRO_PGN25_LOAD_EXE	0x00000001
#define CXD9225GG_SYSC_MACRO_PGN26		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN26_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN27		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN27_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN28		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN28_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN29		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN29_OFFSET)
#define   CXD9225GG_SYSC_MACRO_PGN29_RSTINT_CLR	0x00000001
#define   CXD9225GG_SYSC_MACRO_PGN29_CNTINT_CLR	0x00000002
#define CXD9225GG_SYSC_MACRO_PGN30		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN30_OFFSET)
#define CXD9225GG_SYSC_MACRO_PGN31		(CXD9225GG_SYSC_BASE + CXD9225GG_SYSC_MACRO_PGN31_OFFSET)



/* PCI-Express AXI-Bridge */
#define CXD9225GG_PCIEX_AXI_WINDOW0_BASE		0x0000
#define CXD9225GG_PCIEX_AXI_WINDOW1_BASE		0x0010
#define CXD9225GG_PCIEX_AXI_WINDOW2_BASE		0x0020
#define CXD9225GG_PCIEX_AXI_WINDOW3_BASE		0x0030
#define   CXD9225GG_PCIEX_AXI_WINDOW_BASE_AXI_WND_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_WINDOW_BASE_AXI_WND_EN	0x00000001
#define   CXD9225GG_PCIEX_AXI_WINDOW_BASE_AXI_MSTR_SZ64	0x00000000
#define   CXD9225GG_PCIEX_AXI_WINDOW_BASE_AXI_MSTR_SZ32	0x00000002
#define   CXD9225GG_PCIEX_AXI_WINDOW_BASE_AWBASE_MASK	0xFFFFF000
#define CXD9225GG_PCIEX_AXI_WINDOW0_MASK		0x0004
#define CXD9225GG_PCIEX_AXI_WINDOW1_MASK		0x0014
#define CXD9225GG_PCIEX_AXI_WINDOW2_MASK		0x0024
#define CXD9225GG_PCIEX_AXI_WINDOW3_MASK		0x0034
#define   CXD9225GG_PCIEX_AXI_WINDOW_MASK_AWMASK_MASK	0xFFFFF000
#define CXD9225GG_PCIEX_AXI_DESTINATION0		0x0008
#define CXD9225GG_PCIEX_AXI_DESTINATION1		0x0018
#define CXD9225GG_PCIEX_AXI_DESTINATION2		0x0028
#define CXD9225GG_PCIEX_AXI_DESTINATION3		0x0038
#define   CXD9225GG_PCIEX_AXI_DESTINATION_ADEST_MASK	0xFFFFF000
#define CXD9225GG_PCIEX_PCIE_WINDOW0_BASE		0x0040
#define CXD9225GG_PCIEX_PCIE_WINDOW1_BASE		0x0050
#define CXD9225GG_PCIEX_PCIE_WINDOW2_BASE		0x0060
#define CXD9225GG_PCIEX_PCIE_WINDOW3_BASE		0x0070
#define   CXD9225GG_PCIEX_PCIE_WINDOW_BASE_PCIE_WND_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCIE_WINDOW_BASE_PCIE_WND_EN	0x00000001
#define   CXD9225GG_PCIEX_PCIE_WINDOW_BASE_NORMAL_READ	0x00000000
#define   CXD9225GG_PCIEX_PCIE_WINDOW_BASE_0LENGTH_READ	0x00000002
#define   CXD9225GG_PCIEX_PCIE_WINDOW_BASE_PWBASE_MASK	0xFFFFF000
#define CXD9225GG_PCIEX_PCIE_WINDOW0_MASK		0x0044
#define CXD9225GG_PCIEX_PCIE_WINDOW1_MASK		0x0054
#define CXD9225GG_PCIEX_PCIE_WINDOW2_MASK		0x0064
#define CXD9225GG_PCIEX_PCIE_WINDOW3_MASK		0x0074
#define   CXD9225GG_PCIEX_PCIE_WINDOW_MASK_PWMASK_MASK	0xFFFFF000
#define CXD9225GG_PCIEX_PCIE_DESTINATION_LOW0	0x0048
#define CXD9225GG_PCIEX_PCIE_DESTINATION_LOW1	0x0058
#define CXD9225GG_PCIEX_PCIE_DESTINATION_LOW2	0x0068
#define CXD9225GG_PCIEX_PCIE_DESTINATION_LOW3	0x0078
#define   CXD9225GG_PCIEX_PCIE_DESTINATION_LOW_PDEST_MASK	0xFFFFF000
#define CXD9225GG_PCIEX_PCIE_DESTINATION_UP0	0x004C
#define CXD9225GG_PCIEX_PCIE_DESTINATION_UP1	0x005C
#define CXD9225GG_PCIEX_PCIE_DESTINATION_UP2	0x006C
#define CXD9225GG_PCIEX_PCIE_DESTINATION_UP3	0x007C
#define   CXD9225GG_PCIEX_PCIE_DESTINATION_UP_PDEST_MASK	0x00000000
#define CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_DATA	0x0080
#define CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR	0x0088
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_CFGTYPE0	0x00000000
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_CFGTYPE1	0x00000001
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_EXTERNAL	0x00000000
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_INTERNAL	0x00000002
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_REG_MASK	0x000000FC
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_EXREG_MASK	0x00000FFC
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_ISSUE_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_ISSUE_EN	0x00001000
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_CFGHWINIT_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_CFGHWINIT_EN	0x00002000
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_FNCNUM_SHIFT	(16)
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_DEVNUM_SHIFT	(19)
#define   CXD9225GG_PCIEX_PCIE_CONFIG_ISSUE_ADR_BUSNUM_SHIFT	(24)
#define CXD9225GG_PCIEX_PCIE_IO_ISSUE_DATA		0x0090
#define CXD9225GG_PCIEX_PCIE_IO_ISSUE_ADR		0x0098
#define   CXD9225GG_PCIEX_PCIE_IO_ISSUE_ADR_IDX_IO_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCIE_IO_ISSUE_ADR_IDX_IO_EN	0x00000001
#define CXD9225GG_PCIEX_READ_BYTE_ENABLE		0x009C
#define   CXD9225GG_PCIEX_READ_BYTE_ENABLE_ALL_DIS		0x00000000
#define   CXD9225GG_PCIEX_READ_BYTE_ENABLE_ALL_EN		0x0000000F
#define CXD9225GG_PCIEX_MSG_ISSUE_DATA		0x00A0
#define CXD9225GG_PCIEX_MSG_ISSUE_HEADER		0x00A4
#define   CXD9225GG_PCIEX_MSG_ISSUE_HEADER_MSG_CODE_SHIFT	(0)
#define   CXD9225GG_PCIEX_MSG_ISSUE_HEADER_MSG_NOPAYLOAD	0x00000000
#define   CXD9225GG_PCIEX_MSG_ISSUE_HEADER_MSG_PAYLOAD	0x00010000
#define   CXD9225GG_PCIEX_MSG_ISSUE_HEADER_IDX_MSG_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_ISSUE_HEADER_IDX_MSG_EN	0x00020000
#define   CXD9225GG_PCIEX_MSG_ISSUE_HEADER_ROUTING_SHIFT	(29)
#define CXD9225GG_PCIEX_MSG_ISSUE_3RDDW_HEADER	0x00A8
#define CXD9225GG_PCIEX_MSG_ISSUE_4THDW_HEADER	0x00AC
#define CXD9225GG_PCIEX_MSI_RCV_WINDOW_ADR_LOW	0x0100
#define   CXD9225GG_PCIEX_MSI_RCV_WINDOW_ADR_MSIRCVWND_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSI_RCV_WINDOW_ADR_MSIRCVWND_EN	0x00000001
#define   CXD9225GG_PCIEX_MSI_RCV_WINDOW_ADR_MSIRCVWND_MSK	0xFFFFFFF8
#define CXD9225GG_PCIEX_MSI_RCV_WINDOW_ADR_UP	0x0104
#define CXD9225GG_PCIEX_MSI_RCV_WINDOW_MASK	0x0108
#define CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE	0x0110
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_INTA_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_INTA_EN	0x00000001
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_INTB_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_INTB_EN	0x00000002
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_INTC_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_INTC_EN	0x00000004
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_INTD_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_INTD_EN	0x00000008
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_MSI_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_ENABLE_MSI_EN	0x00000010
#define CXD9225GG_PCIEX_PCI_INTX_RCV_INT_STATUS	0x0114
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_STATUS_INTA	0x00000001
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_STATUS_INTB	0x00000002
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_STATUS_INTC	0x00000004
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_STATUS_INTD	0x00000008
#define   CXD9225GG_PCIEX_PCI_INTX_RCV_INT_STATUS_MSI	0x00000010
#define CXD9225GG_PCIEX_PCI_INTX_OUT_STATUS	0x0118
#define   CXD9225GG_PCIEX_PCI_INTX_OUT_STATUS_INTA		0x00000001
#define   CXD9225GG_PCIEX_PCI_INTX_OUT_STATUS_INTB		0x00000002
#define   CXD9225GG_PCIEX_PCI_INTX_OUT_STATUS_INTC		0x00000004
#define   CXD9225GG_PCIEX_PCI_INTX_OUT_STATUS_INTD		0x00000008
#define CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE		0x0120
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_ABPRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_ABPRIE_EN	0x00000001
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PIOFRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PIOFRIE_EN	0x00000002
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PIBRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PIBRIE_EN	0x00000004
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PIONRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PIONRIE_EN	0x00000008
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_AIOFRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_AIOFRIE_EN	0x00000010
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_AIBRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_AIBRIE_EN	0x00000020
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_AIONRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_AIONRIE_EN	0x00000040
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_VDT0RIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_VDT0RIE_EN	0x00000100
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_VDT1RIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_VDT1RIE_EN	0x00000200
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_SSPLRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_SSPLRIE_EN	0x00000400
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_URIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_URIE_EN	0x00000800
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PTARIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PTARIE_EN	0x00010000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PTORIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PTORIE_EN	0x00020000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PPRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PPRIE_EN	0x00040000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PASNRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_PASNRIE_EN	0x00080000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_MRIE_DIS	0x00000000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_ENABLE_MRIE_EN	0x01000000
#define CXD9225GG_PCIEX_MSG_RCV_INT_STATUS		0x0124
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_ABPRIE	0x00000001
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_PIOFRIE	0x00000002
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_PIBRIE	0x00000004
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_PIONRIE	0x00000008
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_AIOFRIE	0x00000010
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_AIBRIE	0x00000020
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_AIONRIE	0x00000040
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_VDT0RIE	0x00000100
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_VDT1RIE	0x00000200
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_SSPLRIE	0x00000400
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_URIE		0x00000800
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_PTARIE	0x00010000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_PTORIE	0x00020000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_PPRIE		0x00040000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_PASNRIE	0x00080000
#define   CXD9225GG_PCIEX_MSG_RCV_INT_STATUS_MRIE		0x01000000
#define CXD9225GG_PCIEX_MSG_CODE			0x0130
#define   CXD9225GG_PCIEX_MSG_CODE_MSG_WITHOUT_PAYLOAD	0x00000000
#define   CXD9225GG_PCIEX_MSG_CODE_MSG_WITH_PAYLOAD	0x00000001
#define   CXD9225GG_PCIEX_MSG_CODE_ROUTING_SHIFT		(5)
#define   CXD9225GG_PCIEX_MSG_CODE_MSG_CODE_SHIFT		(8)
#define CXD9225GG_PCIEX_MSG_DATA			0x0134
#define CXD9225GG_PCIEX_MSG_HEADER_3RDDW		0x0138
#define CXD9225GG_PCIEX_MSG_HEADER_4THDW		0x013C
#define CXD9225GG_PCIEX_INT_TABLE			0x0140
#define   CXD9225GG_PCIEX_INT_TABLE_INTA_RC		0x00000001
#define   CXD9225GG_PCIEX_INT_TABLE_INTB_RC		0x00000002
#define   CXD9225GG_PCIEX_INT_TABLE_INTC_RC		0x00000004
#define   CXD9225GG_PCIEX_INT_TABLE_INTD_RC		0x00000008
#define   CXD9225GG_PCIEX_INT_TABLE_INTMSI_RC		0x00000010
#define   CXD9225GG_PCIEX_INT_TABLE_MSG_INT		0x00000100
#define   CXD9225GG_PCIEX_INT_TABLE_PCIE_ERR_INT		0x00000200
#define   CXD9225GG_PCIEX_INT_TABLE_AXI_ERR_INT		0x00000400
#define   CXD9225GG_PCIEX_INT_TABLE_INT_LINK_BANDWIDTH	0x00010000
#define   CXD9225GG_PCIEX_INT_TABLE_INT_HOT_PLUG		0x00020000
#define   CXD9225GG_PCIEX_INT_TABLE_INT_PM_PME		0x00040000
#define   CXD9225GG_PCIEX_INT_TABLE_INT_CRS		0x00080000
#define   CXD9225GG_PCIEX_INT_TABLE_INT_SERR		0x00100000
#define   CXD9225GG_PCIEX_INT_TABLE_INT_SERR_COR		0x00200000
#define   CXD9225GG_PCIEX_INT_TABLE_INT_SERR_NONFATAL	0x00400000
#define   CXD9225GG_PCIEX_INT_TABLE_INT_SERR_FATAL		0x00800000
#define CXD9225GG_PCIEX_PCIE_ERRINT_ENABLE		0x0200
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_LNKDN_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_LNKDN_EN		0x00000200
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_ASPML1REJ_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_ASPML1REJ_EN	0x00000400
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_RXDLLPPML23_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_RXDLLPPML23_EN	0x00008000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_CA_DIS		0x00000000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_CA_EN		0x01000000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_UR_DIS		0x00000000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_UR_EN		0x02000000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_CFGPOWSTATE_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_ENA_CFGPOWSTATE_EN	0x10000000
#define CXD9225GG_PCIEX_PCIE_ERRINT_STATUS		0x0204
#define   CXD9225GG_PCIEX_PCIE_ERRINT_STS_LNKDN		0x00000200
#define   CXD9225GG_PCIEX_PCIE_ERRINT_STS_ASPML1REJ	0x00000400
#define   CXD9225GG_PCIEX_PCIE_ERRINT_STS_CA		0x01000000
#define   CXD9225GG_PCIEX_PCIE_ERRINT_STS_UR		0x02000000
#define CXD9225GG_PCIEX_AXI_MASTER_ERRINT_ENABLE	0x0210
#define   CXD9225GG_PCIEX_AXI_MASTER_ERRINT_ENA_RDERES_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_MASTER_ERRINT_ENA_RDERES_EN	0x00000001
#define   CXD9225GG_PCIEX_AXI_MASTER_ERRINT_ENA_WRERES_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_MASTER_ERRINT_ENA_WRERES_EN	0x00000100
#define CXD9225GG_PCIEX_AXI_MASTER_ERRINT_STATUS	0x0214
#define   CXD9225GG_PCIEX_AXI_MASTER_ERRINT_STS_RDERES	0x00000001
#define   CXD9225GG_PCIEX_AXI_MASTER_ERRINT_STS_WRERES	0x00000100
#define   CXD9225GG_PCIEX_AXI_MASTER_ERRINT_STS_ERID_SHIFT	(16)
#define CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENABLE	0x0218
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_PCIERDE_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_PCIERDE_EN	0x00000001
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_IRDDS_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_IRDDS_EN	0x00000002
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_IRDBT_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_IRDBT_EN	0x00000004
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_PCIEWRE_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_PCIEWRE_EN	0x00000010
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_IWRDS_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_IWRDS_EN	0x00000020
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_IWRBT_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_IWRBT_EN	0x00000040
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_MISWRID_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_MISWRID_EN	0x00000080
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_MISWRL_DIS	0x00000000
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_ENA_MISWRL_EN	0x00000100
#define CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_STATUS	0x021C
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_STS_PCIERDE	0x00000001
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_STS_IRDDS	0x00000002
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_STS_IRDBT	0x00000004
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_STS_PCIEWRE	0x00000010
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_STS_IWRDS	0x00000020
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_STS_IWRBT	0x00000040
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_STS_MISWRID	0x00000080
#define   CXD9225GG_PCIEX_AXI_SLAVE_ERRINT_STS_MISWRL	0x00000100
#define CXD9225GG_PCIEX_STEALTH			0x0300
#define   CXD9225GG_PCIEX_STEALTH_DIS			0x00000000
#define   CXD9225GG_PCIEX_STEALTH_EN			0x00000001
#define CXD9225GG_PCIEX_RESET			0x0310
#define   CXD9225GG_PCIEX_RESET_RST_B_RESET		0x00000000
#define   CXD9225GG_PCIEX_RESET_RST_B_UNRESET		0x00000001
#define   CXD9225GG_PCIEX_RESET_RST_GP_B_RESET		0x00000000
#define   CXD9225GG_PCIEX_RESET_RST_GP_B_UNRESET		0x00000002
#define   CXD9225GG_PCIEX_RESET_RST_RSM_B_RESET		0x00000000
#define   CXD9225GG_PCIEX_RESET_RST_RSM_B_UNRESET		0x00000004
#define   CXD9225GG_PCIEX_RESET_RST_CFG_B_RESET		0x00000000
#define   CXD9225GG_PCIEX_RESET_RST_CFG_B_UNRESET		0x00000008
#define   CXD9225GG_PCIEX_RESET_RST_LOAD_B_RESET		0x00000000
#define   CXD9225GG_PCIEX_RESET_RST_LOAD_B_UNRESET		0x00000010
#define   CXD9225GG_PCIEX_RESET_RST_PS_B_RESET		0x00000000
#define   CXD9225GG_PCIEX_RESET_RST_PS_B_UNRESET		0x00000020
#define   CXD9225GG_PCIEX_RESET_RST_OUT_B_RESET		0x00000000
#define   CXD9225GG_PCIEX_RESET_RST_OUT_B_UNRESET		0x00000040
#define   CXD9225GG_PCIEX_RESET_RST_DEFAULT		0x00000000
#define CXD9225GG_PCIEX_MODE_SET0			0x0314
#define   CXD9225GG_PCIEX_MODE_SET0_AXI_MAX_ISSUE_WR_SHIFT	(0)
#define   CXD9225GG_PCIEX_MODE_SET0_AWLOCK_SHIFT		(4)
#define   CXD9225GG_PCIEX_MODE_SET0_AWCACHE_SHIFT		(8)
#define   CXD9225GG_PCIEX_MODE_SET0_AWPROT_SHIFT		(12)
#define   CXD9225GG_PCIEX_MODE_SET0_AXI_MAX_ISSUE_RD_SHIFT	(16)
#define   CXD9225GG_PCIEX_MODE_SET0_ARLOCK_SHIFT		(20)
#define   CXD9225GG_PCIEX_MODE_SET0_ARCACHE_SHIFT		(24)
#define   CXD9225GG_PCIEX_MODE_SET0_ARPROT_SHIFT		(28)
#define CXD9225GG_PCIEX_MODE_SET1			0x0318
#define   CXD9225GG_PCIEX_MODE_SET1_WRAPPING_SPLIT_DIS	0x00000000
#define   CXD9225GG_PCIEX_MODE_SET1_WRAPPING_SPLIT_EN	0x00000001
#define   CXD9225GG_PCIEX_MODE_SET1_PCIEREQ_ORDER_DIS	0x00000000
#define   CXD9225GG_PCIEX_MODE_SET1_PCIEREQ_ORDER_EN	0x00000002
#define   CXD9225GG_PCIEX_MODE_SET1_RAM_PARITY_DIS		0x00000000
#define   CXD9225GG_PCIEX_MODE_SET1_RAM_PARITY_EN		0x00000004
#define   CXD9225GG_PCIEX_MODE_SET1_AXIMSTR_MAXBRST_SHIFT	(4)
#define CXD9225GG_PCIEX_BRIDGE_BLOCK_REVISION	0x031C
#define   CXD9225GG_PCIEX_BRIDGE_BLOCK_REVISION_MASK	0x0000FFFF
#define CXD9225GG_PCIEX_PCIE_CORE_CONTROL_STATUS	0x0400
#define   CXD9225GG_PCIEX_PCIE_CORE_CTL_STS_LINKDN		0x00000001
#define   CXD9225GG_PCIEX_PCIE_CORE_CTL_STS_LTSSM_MASK	0x000000FE
#define   CXD9225GG_PCIEX_PCIE_CORE_CTL_STS_APMASNAK_DIS	0x00000000
#define   CXD9225GG_PCIEX_PCIE_CORE_CTL_STS_APMASNAK_EN	0x00020000
#define CXD9225GG_PCIEX_MODE_INTERFACE		0x0404
#define   CXD9225GG_PCIEX_MODE_INTERFACE_MODCLKACT_L1STOP	0x00000000
#define   CXD9225GG_PCIEX_MODE_INTERFACE_MODCLKACT_L1RUN	0x00000001
#define   CXD9225GG_PCIEX_MODE_INTERFACE_MODCLKACT_DISSTOP	0x00000000
#define   CXD9225GG_PCIEX_MODE_INTERFACE_MODCLKACT_DISRUN	0x00000002
#define   CXD9225GG_PCIEX_MODE_INTERFACE_MODE_PORT_EP	0x00000000
#define   CXD9225GG_PCIEX_MODE_INTERFACE_MODE_PORT_RC	0x00000004
#define   CXD9225GG_PCIEX_MODE_INTERFACE_MODE_PORT_CLKON	0x00000000
#define   CXD9225GG_PCIEX_MODE_INTERFACE_MODE_PORT_CLKOFF	0x00000008
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_OUTPUT0	0x0500
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_OUTPUT1	0x0504
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_OUTPUT2	0x0508
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_OUTPUT3	0x050C
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_ENABLE0	0x0510
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_ENABLE1	0x0514
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_ENABLE2	0x0518
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_ENABLE3	0x051C
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_INPUT0	0x0520
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_INPUT1	0x0524
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_INPUT2	0x0528
#define CXD9225GG_PCIEX_GENERAL_PURPOSE_INPUT3	0x052C
#define CXD9225GG_PCIEX_DEBUG0			0x0600
#define CXD9225GG_PCIEX_DEBUG1			0x0604
#define CXD9225GG_PCIEX_DEBUG2			0x0608
#define CXD9225GG_PCIEX_DEBUG3			0x060C
#define CXD9225GG_PCIEX_DEBUG4			0x0610
#define CXD9225GG_PCIEX_DEBUG5			0x0614
#define CXD9225GG_PCIEX_DEBUG6			0x0618
#define CXD9225GG_PCIEX_DEBUG7			0x061C



/* PCI-Express Endpoint Configuration Register */
#define CXD9225GG_PCIECFG_EP_VEND_AND_DEV_ID	0x0000
#define CXD9225GG_PCIECFG_EP_CMD_AND_STS		0x0004
#define   CXD9225GG_PCIECFG_EP_COMMAND_IO_SPACE_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_COMMAND_IO_SPACE_EN		0x00000001
#define   CXD9225GG_PCIECFG_EP_COMMAND_MEM_SPACE_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_COMMAND_MEM_SPACE_EN	0x00000002
#define   CXD9225GG_PCIECFG_EP_COMMAND_BUS_MASTER_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_COMMAND_BUS_MASTER_EN	0x00000004
#define   CXD9225GG_PCIECFG_EP_COMMAND_PARITY_ERR_RES_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_COMMAND_PARITY_ERR_RES_EN	0x00000040
#define   CXD9225GG_PCIECFG_EP_COMMAND_SERR_DIS		0x00000000
#define   CXD9225GG_PCIECFG_EP_COMMAND_SERR_EN		0x00000100
#define   CXD9225GG_PCIECFG_EP_COMMAND_INT_DIS		0x00000000
#define   CXD9225GG_PCIECFG_EP_COMMAND_INT_EN		0x00000400
#define   CXD9225GG_PCIECFG_EP_STATUS_INT_STATUS		0x00080000
#define   CXD9225GG_PCIECFG_EP_STATUS_CAPABILITIES_LIST	0x00100000
#define   CXD9225GG_PCIECFG_EP_STATUS_MASTERDATA_PARITYERR	0x01000000
#define   CXD9225GG_PCIECFG_EP_STATUS_SIGNALED_TGT_ABT	0x40000000
#define   CXD9225GG_PCIECFG_EP_STATUS_RECEIVED_TGT_ABT	0x80000000
#define CXD9225GG_PCIECFG_EP_REVID_AND_CLASS	0x0008
#define   CXD9225GG_PCIECFG_EP_CLASS_CODE_SHIFT		(8)
#define CXD9225GG_PCIECFG_EP_CLINE_AND_HTYPE	0x000C
#define   CXD9225GG_PCIECFG_EP_CACHE_LINE_SIZE_MASK	0x000000FF
#define   CXD9225GG_PCIECFG_EP_HEADER_TYPE_MASK		0x00FF0000
#define   CXD9225GG_PCIECFG_EP_HEADER_TYPE_SHIFT		(16)
#define CXD9225GG_PCIECFG_EP_BASE_ADDRESS_0	0x0010
#define CXD9225GG_PCIECFG_EP_BASE_ADDRESS_1	0x0014
#define CXD9225GG_PCIECFG_EP_BASE_ADDRESS_2	0x0018
#define CXD9225GG_PCIECFG_EP_BASE_ADDRESS_3	0x001C
#define CXD9225GG_PCIECFG_EP_BASE_ADDRESS_4	0x0020
#define CXD9225GG_PCIECFG_EP_BASE_ADDRESS_5	0x0024
#define   CXD9225GG_PCIECFG_EP_BASE_ADDRESS_MEM_SPACE_MEM	0x00000000
#define   CXD9225GG_PCIECFG_EP_BASE_ADDRESS_MEM_SPACE_IO	0x00000001
#define   CXD9225GG_PCIECFG_EP_BASE_ADDRESS_TYPE_32BIT	0x00000000
#define   CXD9225GG_PCIECFG_EP_BASE_ADDRESS_TYPE_64BIT	0x00000004
#define   CXD9225GG_PCIECFG_EP_BASE_ADDRESS_PREFETCH_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_BASE_ADDRESS_PREFETCH_EN	0x00000008
#define   CXD9225GG_PCIECFG_EP_BASE_ADDRESS_MASK		0xFFFFFFF0
#define CXD9225GG_PCIECFG_EP_CARDBUS_CIS_PTR	0x0028
#define CXD9225GG_PCIECFG_EP_SUBSYSTEM_ID		0x002C
#define   CXD9225GG_PCIECFG_EP_SUBSYSTEM_ID_SHIFT		(16)
#define   CXD9225GG_PCIECFG_EP_SUBSYSTEM_ID_MASK		0xFFFF0000
#define   CXD9225GG_PCIECFG_EP_SUBSYSTEM_VENDOR_ID_MASK	0x0000FFFF
#define CXD9225GG_PCIECFG_EP_EXP_ROM_BASE		0x0030
#define CXD9225GG_PCIECFG_EP_CAPABILITY_PTR	0x0034
#define   CXD9225GG_PCIECFG_EP_CAPABILITY_PTR_MASK		0x000000FF
#define CXD9225GG_PCIECFG_EP_INTERRUPT		0x003C
#define   CXD9225GG_PCIECFG_EP_INTERRUPT_LINE_MASK		0x000000FF
#define   CXD9225GG_PCIECFG_EP_INTERRUPT_PIN_MASK		0x0000FF00
#define CXD9225GG_PCIECFG_EP_PM_CAPABILITY		0x0040
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_ID_MASK	0x000000FF
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_NEXTPTR_MASK	0x0000FF00
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_NEXTPTR_SHIFT	(8)
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_VER_MASK	0x00070000
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_VER_SHIFT	(16)
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_DEV_INIT	0x00200000
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_AUX_CUR_MASK	0x01C00000
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_AUX_CUR_SHIFT	(22)
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_D1_SUPPORT	0x02000000
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_D2_SUPPORT	0x04000000
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_PME_D0	0x08000000
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_PME_D1	0x10000000
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_PME_D2	0x20000000
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_PME_D3HOT	0x40000000
#define   CXD9225GG_PCIECFG_EP_PM_CAPABILITY_PME_D3COLD	0x80000000
#define CXD9225GG_PCIECFG_EP_PM_STS_CTL		0x0044
#define   CXD9225GG_PCIECFG_EP_PM_CONTROL_POWSTATE_D0	0x00000000
#define   CXD9225GG_PCIECFG_EP_PM_CONTROL_POWSTATE_D1	0x00000001
#define   CXD9225GG_PCIECFG_EP_PM_CONTROL_POWSTATE_D2	0x00000002
#define   CXD9225GG_PCIECFG_EP_PM_CONTROL_POWSTATE_D3HOT	0x00000003
#define   CXD9225GG_PCIECFG_EP_PM_STATUS_NO_SOFT_RESET	0x00000008
#define   CXD9225GG_PCIECFG_EP_PM_CONTROL_PME_DISABLE	0x00000000
#define   CXD9225GG_PCIECFG_EP_PM_CONTROL_PME_ENABLE	0x00000100
#define   CXD9225GG_PCIECFG_EP_PM_STATUS_PME_STATUS	0x00008000
#define CXD9225GG_PCIECFG_EP_MSI_CAPABILITY	0x0050
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_ID_MASK	0x000000FF
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_NEXTPTR_MASK	0x0000FF00
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_NEXTPTR_SHFT	(8)
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSI_DISABLE	0x00000000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSI_ENABLE	0x00010000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGCAPA_MASK	0x000E0000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGCAPA_1	0x00000000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGCAPA_2	0x00020000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGCAPA_4	0x00040000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGCAPA_8	0x00060000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGCAPA_16	0x00080000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGCAPA_32	0x000A0000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGENA_1	0x00000000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGENA_2	0x00100000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGENA_4	0x00200000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGENA_8	0x00300000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGENA_16	0x00400000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_MSGENA_32	0x00500000
#define   CXD9225GG_PCIECFG_EP_MSI_CAPABILITY_64BITADR_CAP	0x00800000
#define CXD9225GG_PCIECFG_EP_MESSAGE_ADDRESS_L	0x0054
#define   CXD9225GG_PCIECFG_EP_MESSAGE_ADDRESS_L_MASK	0xFFFFFFFC
#define CXD9225GG_PCIECFG_EP_MESSAGE_ADDRESS_U	0x0058
#define CXD9225GG_PCIECFG_EP_MESSAGE_DATA		0x005C
#define   CXD9225GG_PCIECFG_EP_MESSAGE_DATA_MASK		0x0000FFFF
#define CXD9225GG_PCIECFG_EP_PCIEX_CAPABILITY	0x0060
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_ID_MASK		0x000000FF
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_NEXTPTR_MASK	0x0000FF00
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_NEXTPTR_SHIFT	(8)
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_VER_MASK		0x000F0000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_VER_SHIFT	(16)
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_MASK	0x00F00000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_EP	0x00000000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_LEP	0x00100000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_RC_RP	0x00400000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_SW_UP	0x00500000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_SW_DP	0x00600000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_EX2LBR	0x00700000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_L2EXBR	0x00800000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_RC_IEP	0x00900000
#define   CXD9225GG_PCIECFG_EP_PCIEX_CAPA_DEV_TYPE_RC_EC	0x00A00000
#define CXD9225GG_PCIECFG_EP_DEVICE_CAPABILITY	0x0064
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_MAXPAYLOAD_128	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_MAXPAYLOAD_256	0x00000001
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_MAXPAYLOAD_512	0x00000002
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_MAXPAYLOAD_1024	0x00000003
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_MAXPAYLOAD_2048	0x00000004
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_MAXPAYLOAD_4096	0x00000005
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL0_LTNCY_64N	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL0_LTNCY_128N	0x00000040
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL0_LTNCY_256N	0x00000080
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL0_LTNCY_512N	0x000000C0
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL0_LTNCY_1U	0x00000100
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL0_LTNCY_2U	0x00000140
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL0_LTNCY_4U	0x00000180
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL0_LTNCY_NO	0x000001C0
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL1_LTNCY_64N	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL1_LTNCY_128N	0x00000200
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL1_LTNCY_256N	0x00000400
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL1_LTNCY_512N	0x00000600
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL1_LTNCY_1U	0x00000800
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL1_LTNCY_2U	0x00000A00
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL1_LTNCY_4U	0x00000C00
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_EPL1_LTNCY_NO	0x00000E00
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_ERR_REPORTING	0x00008000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_SLOTPOWLIM_MASK	0x03FC0000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA_SLOTPOWLIMS_MSK	0x0C000000
#define CXD9225GG_PCIECFG_EP_DEVICE_CTL_STS	0x0068
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_ERR_COR_MSG_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_ERR_COR_MSG_EN	0x00000001
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_ERR_NF_MSG_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_ERR_NF_MSG_EN	0x00000002
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_ERR_F_MSG_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_ERR_F_MSG_EN	0x00000004
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_UNSPTRQ_REPT_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_UNSPTRQ_REPT_EN	0x00000008
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_RELAX_ORDER_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_RELAX_ORDER_EN	0x00000010
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXPAYLOAD_128	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXPAYLOAD_256	0x00000020
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXPAYLOAD_512	0x00000040
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXPAYLOAD_1024	0x00000060
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXPAYLOAD_2048	0x00000080
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXPAYLOAD_4096	0x000000A0
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_AUX_POWPM_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_AUX_POWPM_EN	0x00000400
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_NO_SNOOP_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_NO_SNOOP_EN	0x00000800
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXREADREQ_128	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXREADREQ_256	0x00001000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXREADREQ_512	0x00002000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXREADREQ_1024	0x00003000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXREADREQ_2048	0x00004000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_MAXREADREQ_4096	0x00005000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_FNCLVLRESET_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_FNCLVLRESET_EN	0x00008000
#define   CXD9225GG_PCIECFG_EP_DEVICE_STS_ERR_COR		0x00010000
#define   CXD9225GG_PCIECFG_EP_DEVICE_STS_ERR_NONFATAL	0x00020000
#define   CXD9225GG_PCIECFG_EP_DEVICE_STS_ERR_FATAL	0x00040000
#define   CXD9225GG_PCIECFG_EP_DEVICE_STS_ERR_UNSUPREQ	0x00080000
#define   CXD9225GG_PCIECFG_EP_DEVICE_STS_ERR_AUXPOWER	0x00100000
#define   CXD9225GG_PCIECFG_EP_DEVICE_STS_ERR_TRANSPEND	0x00200000
#define CXD9225GG_PCIECFG_EP_LINK_CAPABILITY	0x006C
#define   CXD9225GG_PCIECFG_EP_LINK_CAPA_SPRTLNKSPD_MASK	0x0000000F
#define   CXD9225GG_PCIECFG_EP_LINK_CAPA_MAXLNKWIDTH_MASK	0x000003F0
#define   CXD9225GG_PCIECFG_EP_LINK_CAPA_ASPMSPRT_MASK	0x00000C00
#define   CXD9225GG_PCIECFG_EP_LINK_CAPA_L0EXITLTNCY_MASK	0x00007000
#define   CXD9225GG_PCIECFG_EP_LINK_CAPA_L1EXITLTNCY_MASK	0x00038000
#define   CXD9225GG_PCIECFG_EP_LINK_CAPA_CLKPOWMANAGE	0x00040000
#define   CXD9225GG_PCIECFG_EP_LINK_CAPA_PORTNUM_MASK	0xFF000000
#define CXD9225GG_PCIECFG_EP_LINK_CTL_STS		0x0070
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_ASPM_CTL_DISABLE	0x00000000
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_ASPM_CTL_L0ENTRY	0x00000001
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_ASPM_CTL_L0L1ENTRY	0x00000003
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_READCMP_BUNDRY_64	0x00000000
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_READCMP_BUNDRY_128	0x00000008
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_CMNCLKCFG_NON	0x00000000
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_CMNCLKCFG_PRV	0x00000040
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_EXTEND_SYNCH_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_EXTEND_SYNCH_EN	0x00000080
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_CLKPM_DIS		0x00000000
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_CLKPM_EN		0x00000100
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_HWAUTOWIDTH_EN	0x00000000
#define   CXD9225GG_PCIECFG_EP_LINK_CTL_HWAUTOWIDTH_DIS	0x00000200
#define   CXD9225GG_PCIECFG_EP_LINK_STS_CURLNKSPD_MASK	0x000F0000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_CURLNKSPD_25GTS	0x00010000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_CURLNKSPD_50GTS	0x00020000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_NEGOLNKWIDTH_MASK	0x03F00000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_NEGOLNKWIDTH_X1	0x00100000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_NEGOLNKWIDTH_X2	0x00200000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_NEGOLNKWIDTH_X4	0x00400000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_NEGOLNKWIDTH_X8	0x00800000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_NEGOLNKWIDTH_X12	0x00C00000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_NEGOLNKWIDTH_X16	0x01000000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_NEGOLNKWIDTH_X32	0x02000000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_SLOTCLKCFG_CNREFCK	0x10000000
#define   CXD9225GG_PCIECFG_EP_LINK_STS_DTLNKLAYER_LNKACT	0x20000000
#define CXD9225GG_PCIECFG_EP_SLOT_CAPABILITY	0x0074
#define CXD9225GG_PCIECFG_EP_SLOT_CTL_STS		0x0078
#define CXD9225GG_PCIECFG_EP_ROOT_CTL_CAPA		0x007C
#define CXD9225GG_PCIECFG_EP_ROOT_STATUS		0x0080
#define CXD9225GG_PCIECFG_EP_DEVICE_CAPABILITY2	0x0084
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTORANG_MASK	0x0000000F
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTORANG_A	0x00000001
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTORANG_B	0x00000002
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTORANG_AB	0x00000003
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTORANG_BC	0x00000006
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTORANG_ABC	0x00000007
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTORANG_BCD	0x0000000E
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTORANG_ABCD	0x0000000F
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTODIS_DIS	0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CAPA2_CMPTODIS_EN	0x00000010
#define CXD9225GG_PCIECFG_EP_DEVICE_CTL_STS_2	0x0088
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_CMPTO_MASK	0x0000000F
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_CMPTO_EN		0x00000000
#define   CXD9225GG_PCIECFG_EP_DEVICE_CTL_CMPTO_DIS	0x00000010
#define CXD9225GG_PCIECFG_EP_LINK_CAPABILITY2	0x008C
#define CXD9225GG_PCIECFG_EP_LINK_CTL_STS_2	0x0090
#define CXD9225GG_PCIECFG_EP_SLOT_CAPABILITY2	0x0094
#define CXD9225GG_PCIECFG_EP_SLOT_CTL_STS_2	0x0098
#define CXD9225GG_PCIECFG_EP_BASE_ADR_MASK0_L	0x00A0
#define CXD9225GG_PCIECFG_EP_BASE_ADR_MASK0_U	0x00A4
#define CXD9225GG_PCIECFG_EP_BASE_ADR_MASK1_L	0x00A8
#define CXD9225GG_PCIECFG_EP_BASE_ADR_MASK1_U	0x00AC
#define CXD9225GG_PCIECFG_EP_BASE_ADR_MASK2_L	0x00B0
#define CXD9225GG_PCIECFG_EP_BASE_ADR_MASK2_U	0x00B4
#define CXD9225GG_PCIECFG_EP_BASE_SIZE0		0x00C0
#define CXD9225GG_PCIECFG_EP_BASE_SIZE1		0x00C4
#define CXD9225GG_PCIECFG_EP_BASE_SIZE2		0x00C8
#define   CXD9225GG_PCIECFG_EP_BASE_SIZE_MASK		0x000003FF
#define CXD9225GG_PCIECFG_EP_TYPE_SUPPORTED	0x00D0
#define   CXD9225GG_PCIECFG_EP_TYPE_SUPPORTED_00_MASK	0x000000FF
#define   CXD9225GG_PCIECFG_EP_TYPE_SUPPORTED_01_MASK	0x0000FF00
#define   CXD9225GG_PCIECFG_EP_TYPE_SUPPORTED_02_MASK	0x00FF0000
#define CXD9225GG_PCIECFG_EP_PCIEX_ENCAPAHEADER	0x0100
#define   CXD9225GG_PCIECFG_EP_PCIEX_ECH_AERRREPCAPA_MASK	0x0000FFFF
#define   CXD9225GG_PCIECFG_EP_PCIEX_ECH_CAPAVER_MASK	0x000F0000
#define   CXD9225GG_PCIECFG_EP_PCIEX_ECH_NEXTCAPAOFF_MASK	0xFFF00000
#define CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS	0x0104
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS_DLNKERR	0x00000010
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS_PTLP	0x00001000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS_CMPTO	0x00004000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS_CMPABT	0x00008000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS_UNEXPCMP	0x00010000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS_RCVOF	0x00020000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS_MTLP	0x00040000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS_ECRCERR	0x00080000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_STS_UNSUPRQER	0x00100000
#define CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK	0x0108
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK_DLNKERR	0x00000010
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK_PTLP	0x00001000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK_CMPTO	0x00004000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK_CMPABT	0x00008000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK_UNEXPCMP	0x00010000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK_RCVOF	0x00020000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK_MTLP	0x00040000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK_ECRCERR	0x00080000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_MSK_UNSUPRQER	0x00100000
#define CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVRTY	0x010C
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVR_DLNKERR	0x00000010
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVR_PTLP	0x00001000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVR_CMPTO	0x00004000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVR_CMPABT	0x00008000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVR_UNEXPCMP	0x00010000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVR_RCVOF	0x00020000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVR_MTLP	0x00040000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVR_ECRCERR	0x00080000
#define   CXD9225GG_PCIECFG_EP_UNCORRECT_ERR_SVR_UNSUPRQER	0x00100000
#define CXD9225GG_PCIECFG_EP_CORRECT_ERR_STS	0x0110
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_STS_RCVERR	0x00000001
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_STS_BADTLP	0x00000040
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_STS_BADDLLP	0x00000080
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_STS_REPLYNUMRO	0x00000100
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_STS_REPLYTO	0x00001000
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_STS_ANFATALERR	0x00002000
#define CXD9225GG_PCIECFG_EP_CORRECT_ERR_MSK	0x0114
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_MSK_RCVERR	0x00000001
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_MSK_BADTLP	0x00000040
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_MSK_BADDLLP	0x00000080
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_MSK_REPLYNUMRO	0x00000100
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_MSK_REPLYTO	0x00001000
#define   CXD9225GG_PCIECFG_EP_CORRECT_ERR_MSK_ANFATALERR	0x00002000
#define CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL	0x0118
#define   CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL_1STERP_MSK	0x0000001F
#define   CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL_ECRCGEN_NO	0x00000000
#define   CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL_ECRCGEN	0x00000020
#define   CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL_ECRCGEN_DIS 0x00000000
#define   CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL_ECRCGEN_EN	0x00000040
#define   CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL_ECRCCHK_NO	0x00000000
#define   CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL_ECRCCHK	0x00000080
#define   CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL_ECRCCHK_DIS 0x00000000
#define   CXD9225GG_PCIECFG_EP_ADV_ERR_CAPA_CTL_ECRCCHK_EN	0x00000100
#define CXD9225GG_PCIECFG_EP_HEADER_LOG0		0x011C
#define CXD9225GG_PCIECFG_EP_HEADER_LOG1		0x0120
#define CXD9225GG_PCIECFG_EP_HEADER_LOG2		0x0124
#define CXD9225GG_PCIECFG_EP_HEADER_LOG3		0x0128
#define CXD9225GG_PCIECFG_EP_ROOT_ERR_CMD		0x012C
#define CXD9225GG_PCIECFG_EP_ROOT_ERR_STS		0x0130
#define CXD9225GG_PCIECFG_EP_ERR_SRC_ID		0x0134
#define CXD9225GG_PCIECFG_EP_DEV_SER_NUM_ENCAPA	0x0140
#define   CXD9225GG_PCIECFG_EP_DEVSERNUM_EC_AERREPCAPA_MSK	0x0000FFFF
#define   CXD9225GG_PCIECFG_EP_DEVSERNUM_EC_CAPAVER_MASK	0x000F0000
#define   CXD9225GG_PCIECFG_EP_DEVSERNUM_EC_NXTCAPAOFF_MSK	0xFFF00000
#define CXD9225GG_PCIECFG_EP_SER_NUM_L		0x0144
#define CXD9225GG_PCIECFG_EP_SER_NUM_U		0x0148



/* PCI-Express Root Complex Configuration Register */
#define CXD9225GG_PCIECFG_RC_VEND_AND_DEV_ID	0x0000
#define CXD9225GG_PCIECFG_RC_CMD_AND_STS		0x0004
#define   CXD9225GG_PCIECFG_RC_COMMAND_IO_SPACE_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_COMMAND_IO_SPACE_EN		0x00000001
#define   CXD9225GG_PCIECFG_RC_COMMAND_MEM_SPACE_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_COMMAND_MEM_SPACE_EN	0x00000002
#define   CXD9225GG_PCIECFG_RC_COMMAND_BUS_MASTER_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_COMMAND_BUS_MASTER_EN	0x00000004
#define   CXD9225GG_PCIECFG_RC_COMMAND_PARITY_ERR_RES_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_COMMAND_PARITY_ERR_RES_EN	0x00000040
#define   CXD9225GG_PCIECFG_RC_COMMAND_SERR_DIS		0x00000000
#define   CXD9225GG_PCIECFG_RC_COMMAND_SERR_EN		0x00000100
#define   CXD9225GG_PCIECFG_RC_COMMAND_INT_DIS		0x00000000
#define   CXD9225GG_PCIECFG_RC_COMMAND_INT_EN		0x00000400
#define   CXD9225GG_PCIECFG_RC_STATUS_INT_STATUS		0x00080000
#define   CXD9225GG_PCIECFG_RC_STATUS_CAPABILITIES_LIST	0x00100000
#define   CXD9225GG_PCIECFG_RC_STATUS_MASTERDATA_PARITYERR	0x01000000
#define   CXD9225GG_PCIECFG_RC_STATUS_SIGNALED_SYSTEMERR	0x40000000
#define CXD9225GG_PCIECFG_RC_REVID_AND_CLASS	0x0008
#define   CXD9225GG_PCIECFG_RC_CLASS_CODE_SHIFT		(8)
#define CXD9225GG_PCIECFG_RC_CLINE_AND_HTYPE	0x000C
#define   CXD9225GG_PCIECFG_RC_CACHE_LINE_SIZE_MASK	0x000000FF
#define   CXD9225GG_PCIECFG_RC_HEADER_TYPE_MASK		0x00FF0000
#define   CXD9225GG_PCIECFG_RC_HEADER_TYPE_SHIFT		(16)
#define CXD9225GG_PCIECFG_RC_BASE_ADDRESS_0	0x0010
#define   CXD9225GG_PCIECFG_RC_BASE_ADDRESS0_MEM_SPACE_MEM	0x00000000
#define   CXD9225GG_PCIECFG_RC_BASE_ADDRESS0_MEM_SPACE_IO	0x00000001
#define   CXD9225GG_PCIECFG_RC_BASE_ADDRESS0_TYPE_32BIT	0x00000000
#define   CXD9225GG_PCIECFG_RC_BASE_ADDRESS0_TYPE_64BIT	0x00000004
#define   CXD9225GG_PCIECFG_RC_BASE_ADDRESS0_PREFETCH_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_BASE_ADDRESS0_PREFETCH_EN	0x00000008
#define   CXD9225GG_PCIECFG_RC_BASE_ADDRESS0_MASK		0xFFFFFFF0
#define CXD9225GG_PCIECFG_RC_BASE_ADDRESS_1	0x0014
#define CXD9225GG_PCIECFG_RC_BUS_NUMBER		0x0018
#define   CXD9225GG_PCIECFG_RC_BUS_NUMBER_PRIBUS_NUM_MASK	0x000000FF
#define   CXD9225GG_PCIECFG_RC_BUS_NUMBER_2NDBUS_NUM_MASK	0x0000FF00
#define   CXD9225GG_PCIECFG_RC_BUS_NUMBER_SUBBUS_NUM_MASK	0x00FF0000
#define CXD9225GG_PCIECFG_RC_IOBASE_LIMIT_2NDSTS	0x001C
#define   CXD9225GG_PCIECFG_RC_IOBASE_MASK			0x000000FF
#define   CXD9225GG_PCIECFG_RC_IOLIMIT_MASK		0x0000FF00
#define   CXD9225GG_PCIECFG_RC_2NDSTS_MASTERDATA_PERR	0x01000000
#define   CXD9225GG_PCIECFG_RC_2NDSTS_SIGNALED_TGT_ABT	0x08000000
#define   CXD9225GG_PCIECFG_RC_2NDSTS_RECEIVED_TGT_ABT	0x10000000
#define   CXD9225GG_PCIECFG_RC_2NDSTS_RECEIVED_MSTR_ABT	0x20000000
#define   CXD9225GG_PCIECFG_RC_2NDSTS_RECEIVED_SYS_ERR	0x40000000
#define   CXD9225GG_PCIECFG_RC_2NDSTS_DETECTED_PERR	0x80000000
#define CXD9225GG_PCIECFG_RC_MEMBASE_LIMIT		0x0020
#define   CXD9225GG_PCIECFG_RC_MEMBASE_MASK		0x0000FFFF
#define   CXD9225GG_PCIECFG_RC_MEMLIMIT_MASK		0xFFFF0000
#define   CXD9225GG_PCIECFG_RC_MEMBASE_SHIFT		(16)
#define   CXD9225GG_PCIECFG_RC_MEMLIMIT_SHIFT		(0)
#define CXD9225GG_PCIECFG_RC_PREF_MEMBASE_LIMIT	0x0024
#define CXD9225GG_PCIECFG_RC_PREF_BASE_U		0x0028
#define CXD9225GG_PCIECFG_RC_PREF_BASE_LIMIT_U	0x002C
#define CXD9225GG_PCIECFG_RC_IOBASE_LIMIT_U	0x0030
#define   CXD9225GG_PCIECFG_RC_IOBASE_U_MASK		0x0000FFFF
#define   CXD9225GG_PCIECFG_RC_IOLIMIT_U_MASK		0xFFFF0000
#define CXD9225GG_PCIECFG_RC_CAPABILITY_PTR	0x0034
#define   CXD9225GG_PCIECFG_RC_CAPABILITY_PTR_MASK		0x000000FF
#define CXD9225GG_PCIECFG_RC_EXP_ROM_BASE		0x0038
#define CXD9225GG_PCIECFG_RC_BR_CTL_INT		0x003C
#define   CXD9225GG_PCIECFG_RC_INTERRUPT_LINE_MASK		0x000000FF
#define   CXD9225GG_PCIECFG_RC_INTERRUPT_PIN_MASK		0x0000FF00
#define   CXD9225GG_PCIECFG_RC_BR_CTL_PERR_RES_DIS		0x00000000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_PERR_RES_EN		0x00010000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_SERR_DIS		0x00000000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_SERR_EN		0x00020000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_ISA_DIS		0x00000000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_ISA_EN		0x00040000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_VGA_DIS		0x00000000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_VGA_EN		0x00080000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_VGA16BIT_DIS		0x00000000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_VGA16BIT_EN		0x00100000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_2NDBUS_RESET_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_BR_CTL_2NDBUS_RESET_EN	0x00400000
#define CXD9225GG_PCIECFG_RC_PM_CAPABILITIES	0x0040
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_ID_MASK	0x000000FF
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_NEXTPTR_MASK	0x0000FF00
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_NEXTPTR_SHIFT	(8)
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_VER_MASK	0x00070000
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_VER_SHIFT	(16)
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_DEV_INIT	0x00200000
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_AUX_CUR_MASK	0x01C00000
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_AUX_CUR_SHIFT	(22)
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_D1_SUPPORT	0x02000000
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_D2_SUPPORT	0x04000000
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_PME_D0	0x08000000
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_PME_D1	0x10000000
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_PME_D2	0x20000000
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_PME_D3HOT	0x40000000
#define   CXD9225GG_PCIECFG_RC_PM_CAPABILITY_PME_D3COLD	0x80000000
#define CXD9225GG_PCIECFG_RC_PM_STS_CTL		0x0044
#define   CXD9225GG_PCIECFG_RC_PM_CONTROL_POWSTATE_D0	0x00000000
#define   CXD9225GG_PCIECFG_RC_PM_CONTROL_POWSTATE_D1	0x00000001
#define   CXD9225GG_PCIECFG_RC_PM_CONTROL_POWSTATE_D2	0x00000002
#define   CXD9225GG_PCIECFG_RC_PM_CONTROL_POWSTATE_D3HOT	0x00000003
#define   CXD9225GG_PCIECFG_RC_PM_STATUS_NO_SOFT_RESET	0x00000008
#define   CXD9225GG_PCIECFG_RC_PM_CONTROL_PME_DISABLE	0x00000000
#define   CXD9225GG_PCIECFG_RC_PM_CONTROL_PME_ENABLE	0x00000100
#define   CXD9225GG_PCIECFG_RC_PM_STATUS_PME_STATUS	0x00008000
#define CXD9225GG_PCIECFG_RC_MSI_CAPABILITY	0x0050
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_ID_MASK	0x000000FF
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_NEXTPTR_MASK	0x0000FF00
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_NEXTPTR_SHFT	(8)
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSI_DISABLE	0x00000000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSI_ENABLE	0x00010000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGCAPA_MASK	0x000E0000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGCAPA_1	0x00000000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGCAPA_2	0x00020000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGCAPA_4	0x00040000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGCAPA_8	0x00060000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGCAPA_16	0x00080000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGCAPA_32	0x000A0000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGENA_1	0x00000000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGENA_2	0x00100000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGENA_4	0x00200000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGENA_8	0x00300000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGENA_16	0x00400000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_MSGENA_32	0x00500000
#define   CXD9225GG_PCIECFG_RC_MSI_CAPABILITY_64BITADR_CAP	0x00800000
#define CXD9225GG_PCIECFG_RC_MESSAGE_ADDRESS_L	0x0054
#define   CXD9225GG_PCIECFG_RC_MESSAGE_ADDRESS_L_MASK	0xFFFFFFFC
#define CXD9225GG_PCIECFG_RC_MESSAGE_ADDRESS_U	0x0058
#define CXD9225GG_PCIECFG_RC_MESSAGE_DATA		0x005C
#define   CXD9225GG_PCIECFG_RC_MESSAGE_DATA_MASK		0x0000FFFF
#define CXD9225GG_PCIECFG_RC_PCIEX_CAPABILITY	0x0060
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_ID_MASK		0x000000FF
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_NEXTPTR_MASK	0x0000FF00
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_NEXTPTR_SHIFT	(8)
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_VER_MASK		0x000F0000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_VER_SHIFT	(16)
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_MASK	0x00F00000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_EP	0x00000000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_LEP	0x00100000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_RC_RP	0x00400000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_SW_UP	0x00500000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_SW_DP	0x00600000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_EX2LBR	0x00700000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_L2EXBR	0x00800000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_RC_IEP	0x00900000
#define   CXD9225GG_PCIECFG_RC_PCIEX_CAPA_DEV_TYPE_RC_EC	0x00A00000
#define CXD9225GG_PCIECFG_RC_DEVICE_CAPABILITY	0x0064
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA_MAXPAYLOAD_128	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA_MAXPAYLOAD_256	0x00000001
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA_MAXPAYLOAD_512	0x00000002
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA_MAXPAYLOAD_1024	0x00000003
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA_MAXPAYLOAD_2048	0x00000004
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA_MAXPAYLOAD_4096	0x00000005
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA_ERR_REPORTING	0x00008000
#define CXD9225GG_PCIECFG_RC_DEVICE_CTL_STS	0x0068
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_ERR_COR_MSG_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_ERR_COR_MSG_EN	0x00000001
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_ERR_NF_MSG_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_ERR_NF_MSG_EN	0x00000002
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_ERR_F_MSG_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_ERR_F_MSG_EN	0x00000004
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_UNSPTRQ_REPT_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_UNSPTRQ_REPT_EN	0x00000008
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_RELAX_ORDER_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_RELAX_ORDER_EN	0x00000010
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXPAYLOAD_128	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXPAYLOAD_256	0x00000020
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXPAYLOAD_512	0x00000040
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXPAYLOAD_1024	0x00000060
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXPAYLOAD_2048	0x00000080
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXPAYLOAD_4096	0x000000A0
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_AUX_POWPM_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_AUX_POWPM_EN	0x00000400
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXREADREQ_128	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXREADREQ_256	0x00001000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXREADREQ_512	0x00002000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXREADREQ_1024	0x00003000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXREADREQ_2048	0x00004000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_MAXREADREQ_4096	0x00005000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_FNCLVLRESET_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL_FNCLVLRESET_EN	0x00008000
#define   CXD9225GG_PCIECFG_RC_DEVICE_STS_ERR_COR		0x00010000
#define   CXD9225GG_PCIECFG_RC_DEVICE_STS_ERR_NONFATAL	0x00020000
#define   CXD9225GG_PCIECFG_RC_DEVICE_STS_ERR_FATAL	0x00040000
#define   CXD9225GG_PCIECFG_RC_DEVICE_STS_ERR_UNSUPREQ	0x00080000
#define   CXD9225GG_PCIECFG_RC_DEVICE_STS_ERR_AUXPOWER	0x00100000
#define CXD9225GG_PCIECFG_RC_LINK_CAPABILITY	0x006C
#define   CXD9225GG_PCIECFG_RC_LINK_CAPA_SPRTLNKSPD_MASK	0x0000000F
#define   CXD9225GG_PCIECFG_RC_LINK_CAPA_MAXLNKWIDTH_MASK	0x000003F0
#define   CXD9225GG_PCIECFG_RC_LINK_CAPA_ASPMSPRT_MASK	0x00000C00
#define   CXD9225GG_PCIECFG_RC_LINK_CAPA_L0EXITLTNCY_MASK	0x00007000
#define   CXD9225GG_PCIECFG_RC_LINK_CAPA_L1EXITLTNCY_MASK	0x00038000
#define   CXD9225GG_PCIECFG_RC_LINK_CAPA_DATLNK_LNKACTREP	0x00100000
#define   CXD9225GG_PCIECFG_RC_LINK_CAPA_LNKBANDWDTHNOTIFY	0x00200000
#define   CXD9225GG_PCIECFG_RC_LINK_CAPA_PORTNUM_MASK	0xFF000000
#define CXD9225GG_PCIECFG_RC_LINK_CTL_STS		0x0070
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_ASPM_CTL_DISABLE	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_ASPM_CTL_L0ENTRY	0x00000001
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_ASPM_CTL_L0L1ENTRY	0x00000003
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_READCMP_BUNDRY_64	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_READCMP_BUNDRY_128	0x00000008
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_LINK_EN		0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_LINK_DIS		0x00000010
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_RETRAINLINK_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_RETRAINLINK_EN	0x00000020
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_CMNCLKCFG_NON	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_CMNCLKCFG_PRV	0x00000040
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_EXTEND_SYNCH_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_EXTEND_SYNCH_EN	0x00000080
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_HWAUTOWIDTH_EN	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_HWAUTOWIDTH_DIS	0x00000200
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_LBM_INT_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_LBM_INT_EN		0x00000400
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_LAB_INT_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL_LAB_INT_EN		0x00000800
#define   CXD9225GG_PCIECFG_RC_LINK_STS_CURLNKSPD_MASK	0x000F0000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_CURLNKSPD_25GTS	0x00010000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_CURLNKSPD_50GTS	0x00020000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_NEGOLNKWIDTH_MASK	0x03F00000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_NEGOLNKWIDTH_X1	0x00100000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_NEGOLNKWIDTH_X2	0x00200000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_NEGOLNKWIDTH_X4	0x00400000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_NEGOLNKWIDTH_X8	0x00800000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_NEGOLNKWIDTH_X12	0x00C00000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_NEGOLNKWIDTH_X16	0x01000000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_NEGOLNKWIDTH_X32	0x02000000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_SLOTCLKCFG_CNREFCK	0x10000000
#define   CXD9225GG_PCIECFG_RC_LINK_STS_DTLNKLAYER_LNKACT	0x20000000
#define CXD9225GG_PCIECFG_RC_SLOT_CAPABILITY	0x0074
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_ATENTIONBUTON	0x00000001
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_POWERCONTROL	0x00000002
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_MRLSENSOR		0x00000004
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_ATENTIONIND	0x00000008
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_POWERIND		0x00000010
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_HOTPLUGSURP	0x00000020
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_HOTPLUGCAPA	0x00000040
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMT_MASK	0x00007F80
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMT_SHIFT	(7)
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMT_250W	0xF0
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMT_275W	0xF1
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMT_300W	0xF2
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMTS_MASK	0x00018000
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMTS_10XXX	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMTS_01XXX	0x00008000
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMTS_001XX	0x00010000
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_SLOTPOWLMTS_0001X	0x00018000
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_ELEMECHINTERLOCK	0x00020000
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_NOCMDCMPSUPPRT	0x00040000
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_PHYSSLOTNUM_MASK	0xFFF80000
#define   CXD9225GG_PCIECFG_RC_SLOT_CAPA_PHYSSLOTNUM_SHIFT	(19)
#define CXD9225GG_PCIECFG_RC_SLOT_CTL_STS		0x0078
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_ATENTIONBUTON_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_ATENTIONBUTON_EN	0x00000001
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_POWERCONTROL_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_POWERCONTROL_EN	0x00000002
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_MRLSENSOR_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_MRLSENSOR_EN	0x00000004
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_ATENTIONIND_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_ATENTIONIND_EN	0x00000008
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_POWERIND_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_POWERIND_EN	0x00000010
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_HOTPLUGSURP_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_HOTPLUGSURP_EN	0x00000020
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_ATENTONINDCTL_ON	0x00000040
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_ATENTONINDCTL_BLNK	0x00000080
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_ATENTONINDCTL_OFF	0x000000C0
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_POWINDCTL_ON	0x00000100
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_POWINDCTL_BLNK	0x00000200
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_POWINDCTL_OFF	0x00000300
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_POWC_CTL_ON	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_POWC_CTL_OFF	0x00000400
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_ELEMECHINTRLCK_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_ELEMECHINTRLCK_EN	0x00000800
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_DATLNKSTATCHG_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_SLOT_CTL_DATLNKSTATCHG_EN	0x00001000
#define   CXD9225GG_PCIECFG_RC_SLOT_STS_ATENTIONBUTON_PRES	0x00010000
#define   CXD9225GG_PCIECFG_RC_SLOT_STS_POWFAULT		0x00020000
#define   CXD9225GG_PCIECFG_RC_SLOT_STS_MRLSENSOR_CHG	0x00040000
#define   CXD9225GG_PCIECFG_RC_SLOT_STS_PRESENCEDET_CHG	0x00080000
#define   CXD9225GG_PCIECFG_RC_SLOT_STS_CMDCMPLETE		0x00100000
#define   CXD9225GG_PCIECFG_RC_SLOT_STS_MRLSENSOR_OPEN	0x00200000
#define   CXD9225GG_PCIECFG_RC_SLOT_STS_PRESENCEDET_PRSNT	0x00400000
#define   CXD9225GG_PCIECFG_RC_SLOT_STS_ELEMECHINTRLCK_ENG	0x00800000
#define   CXD9225GG_PCIECFG_RC_SLOT_STS_DATLNKSTAT_LNKACT	0x01000000
#define CXD9225GG_PCIECFG_RC_ROOT_CTL_CAPA		0x007C
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_SYSERR_ERRCOR_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_SYSERR_ERRCOR_EN	0x00000001
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_SYSERR_ERRNFAT_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_SYSERR_ERRNFAT_EN	0x00000002
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_SYSERR_ERRFAT_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_SYSERR_ERRFAT_EN	0x00000004
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_PMEINT_DIS		0x00000000
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_PMEINT_EN		0x00000008
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_CRSSWVISI_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_ROOT_CTL_CRSSWVISI_EN	0x00000010
#define   CXD9225GG_PCIECFG_RC_ROOT_CAPA_CRSSWVISIBILITY	0x00010000
#define CXD9225GG_PCIECFG_RC_ROOT_STATUS		0x0080
#define   CXD9225GG_PCIECFG_RC_ROOT_STATUS_PMEREQID_MASK	0x0000FFFF
#define   CXD9225GG_PCIECFG_RC_ROOT_STATUS_PMESTATUS	0x00010000
#define   CXD9225GG_PCIECFG_RC_ROOT_STATUS_PMEPENDING	0x00020000
#define CXD9225GG_PCIECFG_RC_DEVICE_CAPABILITY2	0x0084
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA2_CMPTORANG_A	0x00000001
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA2_CMPTORANG_B	0x00000002
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA2_CMPTORANG_AB	0x00000003
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA2_CMPTORANG_BC	0x00000006
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA2_CMPTORANG_ABC	0x00000007
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA2_CMPTORANG_BCD	0x0000000E
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA2_CMPTORANG_ABCD	0x0000000F
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA2_CMPTO_DIS_NO	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CAPA2_CMPTO_DIS_SUP	0x00000010
#define CXD9225GG_PCIECFG_RC_DEVICE_CTL_STS_2	0x0088
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL2_CMPTORANG_A	0x00000001
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL2_CMPTORANG_B	0x00000002
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL2_CMPTORANG_AB	0x00000003
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL2_CMPTORANG_BC	0x00000006
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL2_CMPTORANG_ABC	0x00000007
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL2_CMPTORANG_BCD	0x0000000E
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL2_CMPTORANG_ABCD	0x0000000F
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL2_CMPTO_EN	0x00000000
#define   CXD9225GG_PCIECFG_RC_DEVICE_CTL2_CMPTO_DIS	0x00000010
#define CXD9225GG_PCIECFG_RC_LINK_CAPABILITY2	0x008C
#define CXD9225GG_PCIECFG_RC_LINK_CTL_STS_2	0x0090
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_TGTLNKSPEED_25GT	0x00000001
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_TGTLNKSPEED_50GT	0x00000002
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_ENTERCOMPMODE_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_ENTERCOMPMODE_EN	0x00000010
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_HWAUTOSPEED_EN	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_HWAUTOSPEED_DIS	0x00000020
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_SEL_DEEMPHA_6DB	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_SEL_DEEMPHA_35DB	0x00000040
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_TRANSMARGIN_MASK	0x00000380
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_TRANSMARGIN_SHIFT	(7)
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_ENTERMODCOMP_NO	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_ENTERMODCOMP_MOD	0x00000400
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_COMPSOS_SKPOS_NO	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_COMPSOS_SKPOS_SET	0x00000800
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_COMPDEEMPHA_6DB	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_CTL2_COMPDEEMPHA_35DB	0x00001000
#define   CXD9225GG_PCIECFG_RC_LINK_STS2_COMPDEEMPHA_6DB	0x00000000
#define   CXD9225GG_PCIECFG_RC_LINK_STS2_COMPDEEMPHA_35DB	0x00010000
#define CXD9225GG_PCIECFG_RC_SLOT_CAPABILITY2	0x0094
#define CXD9225GG_PCIECFG_RC_SLOT_CTL_STS_2	0x0098
#define CXD9225GG_PCIECFG_RC_BASE_ADR_MASK0_L	0x00A0
#define CXD9225GG_PCIECFG_RC_BASE_ADR_MASK0_U	0x00A4
#define CXD9225GG_PCIECFG_RC_BASE_ADR_MASK1_L	0x00A8
#define CXD9225GG_PCIECFG_RC_BASE_ADR_MASK1_U	0x00AC
#define CXD9225GG_PCIECFG_RC_BASE_ADR_MASK2_L	0x00B0
#define CXD9225GG_PCIECFG_RC_BASE_ADR_MASK2_U	0x00B4
#define CXD9225GG_PCIECFG_RC_BASE_SIZE0		0x00C0
#define CXD9225GG_PCIECFG_RC_BASE_SIZE1		0x00C4
#define CXD9225GG_PCIECFG_RC_BASE_SIZE2		0x00C8
#define   CXD9225GG_PCIECFG_RC_BASE_SIZE_MASK		0x000003FF
#define CXD9225GG_PCIECFG_RC_TYPE_SUPPORTED	0x00D0
#define   CXD9225GG_PCIECFG_RC_TYPE_SUPPORTED_00_MASK	0x000000FF
#define   CXD9225GG_PCIECFG_RC_TYPE_SUPPORTED_01_MASK	0x0000FF00
#define   CXD9225GG_PCIECFG_RC_TYPE_SUPPORTED_02_MASK	0x00FF0000
#define CXD9225GG_PCIECFG_SPIN_UP_DEVICE	0x00EC
#define CXD9225GG_PCIECFG_RC_PCIEX_ENCAPAHEADER	0x0100
#define   CXD9225GG_PCIECFG_RC_PCIEX_ECH_AERRREPCAPA_MASK	0x0000FFFF
#define   CXD9225GG_PCIECFG_RC_PCIEX_ECH_CAPAVER_MASK	0x000F0000
#define   CXD9225GG_PCIECFG_RC_PCIEX_ECH_NEXTCAPAOFF_MASK	0xFFF00000
#define CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS	0x0104
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS_DLNKERR	0x00000010
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS_PTLP	0x00001000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS_CMPTO	0x00004000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS_CMPABT	0x00008000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS_UNEXPCMP	0x00010000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS_RCVOF	0x00020000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS_MTLP	0x00040000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS_ECRCERR	0x00080000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_STS_UNSUPRQER	0x00100000
#define CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK	0x0108
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK_DLNKERR	0x00000010
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK_PTLP	0x00001000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK_CMPTO	0x00004000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK_CMPABT	0x00008000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK_UNEXPCMP	0x00010000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK_RCVOF	0x00020000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK_MTLP	0x00040000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK_ECRCERR	0x00080000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_MSK_UNSUPRQER	0x00100000
#define CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVRTY	0x010C
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVR_DLNKERR	0x00000010
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVR_PTLP	0x00001000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVR_CMPTO	0x00004000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVR_CMPABT	0x00008000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVR_UNEXPCMP	0x00010000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVR_RCVOF	0x00020000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVR_MTLP	0x00040000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVR_ECRCERR	0x00080000
#define   CXD9225GG_PCIECFG_RC_UNCORRECT_ERR_SVR_UNSUPRQER	0x00100000
#define CXD9225GG_PCIECFG_RC_CORRECT_ERR_STS	0x0110
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_STS_RCVERR	0x00000001
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_STS_BADTLP	0x00000040
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_STS_BADDLLP	0x00000080
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_STS_REPLYNUMRO	0x00000100
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_STS_REPLYTO	0x00001000
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_STS_ANFATALERR	0x00002000
#define CXD9225GG_PCIECFG_RC_CORRECT_ERR_MSK	0x0114
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_MSK_RCVERR	0x00000001
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_MSK_BADTLP	0x00000040
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_MSK_BADDLLP	0x00000080
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_MSK_REPLYNUMRO	0x00000100
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_MSK_REPLYTO	0x00001000
#define   CXD9225GG_PCIECFG_RC_CORRECT_ERR_MSK_ANFATALERR	0x00002000
#define CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL	0x0118
#define   CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL_1STERP_MSK	0x0000001F
#define   CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL_ECRCGEN_NO	0x00000000
#define   CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL_ECRCGEN	0x00000020
#define   CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL_ECRCGEN_DIS 0x00000000
#define   CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL_ECRCGEN_EN	0x00000040
#define   CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL_ECRCCHK_NO	0x00000000
#define   CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL_ECRCCHK	0x00000080
#define   CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL_ECRCCHK_DIS 0x00000000
#define   CXD9225GG_PCIECFG_RC_ADV_ERR_CAPA_CTL_ECRCCHK_EN	0x00000100
#define CXD9225GG_PCIECFG_RC_HEADER_LOG0		0x011C
#define CXD9225GG_PCIECFG_RC_HEADER_LOG1		0x0120
#define CXD9225GG_PCIECFG_RC_HEADER_LOG2		0x0124
#define CXD9225GG_PCIECFG_RC_HEADER_LOG3		0x0128
#define CXD9225GG_PCIECFG_RC_ROOT_ERR_CMD		0x012C
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_CMD_ERRCOR_RES_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_CMD_ERRCOR_RES_EN	0x00000001
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_CMD_ERRNF_RES_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_CMD_ERRNF_RES_EN	0x00000002
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_CMD_ERRFAT_RES_DIS	0x00000000
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_CMD_ERRFAT_RES_EN	0x00000004
#define CXD9225GG_PCIECFG_RC_ROOT_ERR_STS		0x0130
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_STS_ERRCOR		0x00000001
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_STS_MERROCR	0x00000002
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_STS_ERRFATAL	0x00000004
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_STS_MERRFATAL	0x00000008
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_STS_1STUNCORFAT	0x00000010
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_STS_NFATERRMSG	0x00000020
#define   CXD9225GG_PCIECFG_RC_ROOT_ERR_STS_FATERRMSG	0x00000040
#define CXD9225GG_PCIECFG_RC_ERR_SRC_ID		0x0134
#define   CXD9225GG_PCIECFG_RC_ERR_COR_SRC_ID_MASK		0x0000FFFF
#define   CXD9225GG_PCIECFG_RC_ERR_FATAL_SRC_ID_MASK	0xFFFF0000
#define CXD9225GG_PCIECFG_RC_DEV_SER_NUM_ENCAPA	0x0140
#define   CXD9225GG_PCIECFG_RC_DEVSNUMEC_AERRREPCAPA_MASK	0x0000FFFF
#define   CXD9225GG_PCIECFG_RC_DEVSNUMEC_CAPAVER_MASK	0x000F0000
#define   CXD9225GG_PCIECFG_RC_DEVSNUMEC_NEXTCAPAOFF_MASK	0xFFF00000
#define CXD9225GG_PCIECFG_RC_SER_NUM_L		0x0144
#define CXD9225GG_PCIECFG_RC_SER_NUM_U		0x0148



/* AHB-PCI Bridge Communication Register */
#define CXD9225GG_PCI_PCIAHB_WIN1_CTR	0x0000
#define CXD9225GG_PCI_PCIAHB_WIN2_CTR	0x0004
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_PREFECH_MASK	0x00000003
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_PREFECH_DISABLE	0x00000000
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_PREFECH_MAX4	0x00000001
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_PREFECH_MAX8	0x00000002
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_PREFECH_MAX16	0x00000003
//#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_ENDIAN_MASK		0x000001C0
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_ENDIAN_NOCHG	0x00000000
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_ENDIAN_ATDS		0x00000040
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_ENDIAN_BDS		0x00000080
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_ENDIAN_HWDS		0x000000C0
#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_ENDIAN_AC		0x00000100
//#define   CXD9225GG_PCI_PCIAHB_WIN_CTR_BASE_ADDR_MASK	0xFFFFF000
#define CXD9225GG_PCI_PCIAHB_DCT_CTR	0x0008
#define   CXD9225GG_PCI_PCIAHB_DCT_CTR_DISCARD_EN		0x00000001
#define   CXD9225GG_PCI_PCIAHB_DCT_CTR_DISCARD_TIM_MASK	0x0000FFF0
#define   CXD9225GG_PCI_PCIAHB_DCT_CTR_DISCARD_TIM_SHIFT	(4)
#define CXD9225GG_PCI_AHBPCI_WIN1_CTR	0x0010
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_PCICMD_MASK	0x0000000E
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_PCICMD_INTACK	0x00000000
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_PCICMD_IO		0x00000002
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_PCICMD_MEMORY	0x00000006
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_PCICMD_CONFIG	0x0000000A
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_PCICMD_MULTIPLE	0x0000000C
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_PCICMD_LINE	0x0000000E
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_CFGTYPE0		0x00000000
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_CFGTYPE1		0x00000010
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_ENDIAN_MASK	0x000001C0
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_ENDIAN_NOCHG	0x00000000
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_ENDIAN_ATDS	0x00000040
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_ENDIAN_BDS		0x00000080
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_ENDIAN_HWDS	0x000000C0
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_ENDIAN_AC		0x00000100
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_IDSEL_SHIFT	(11)
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_FNC_SHIFT		(8)
#define   CXD9225GG_PCI_AHBPCI_WIN1_CTR_REG_SHIFT		(0)
#define CXD9225GG_PCI_AHBPCI_WIN2_CTR	0x0014
#define CXD9225GG_PCI_AHBPCI_WIN3_CTR	0x0018
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_PREFECH_EN		0x00000001
//#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_PCICMD_MASK		0x0000000E
//#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_PCICMD_IO		0x00000002
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_PCICMD_MEMORY	0x00000006
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_PCICMD_MULTIPLE	0x0000000C
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_PCICMD_LINE		0x0000000E
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_BURST_EN		0x00000020
//#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_ENDIAN_MASK		0x000001C0
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_ENDIAN_NOCHG	0x00000000
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_ENDIAN_ATDS		0x00000040
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_ENDIAN_BDS		0x00000080
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_ENDIAN_HWDS		0x000000C0
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_ENDIAN_AC		0x00000100
#define   CXD9225GG_PCI_AHBPCI_WIN_CTR_BASE_ADDR_MASK	0xFFFF0000
#define CXD9225GG_PCI_AHBPCI_DCT_CTR	0x001C
#define   CXD9225GG_PCI_AHBPCI_DCT_CTR_DISCARD_EN		0x00000001
#define   CXD9225GG_PCI_AHBPCI_DCT_CTR_DISCARD_TIM_MASK	0x0000FFF0
#define   CXD9225GG_PCI_AHBPCI_DCT_CTR_DISCARD_TIM_SHIFT	(4)
#define CXD9225GG_PCI_INT_ENABLE		0x0020
#define   CXD9225GG_PCI_INT_ENABLE_ALL_DISABLE		0x00000000
#define   CXD9225GG_PCI_INT_ENABLE_SIGTABORT_EN		0x00000001
#define   CXD9225GG_PCI_INT_ENABLE_RETABORT_EN		0x00000002
#define   CXD9225GG_PCI_INT_ENABLE_REMABORT_EN		0x00000004
#define   CXD9225GG_PCI_INT_ENABLE_PERR_EN			0x00000008
#define   CXD9225GG_PCI_INT_ENABLE_SIGSERR_EN		0x00000010
#define   CXD9225GG_PCI_INT_ENABLE_RESERR_EN		0x00000020
#define   CXD9225GG_PCI_INT_ENABLE_PM_STATE_EN		0x00000040
#define   CXD9225GG_PCI_INT_ENABLE_CLKRUN_EN		0x00000080
#define   CXD9225GG_PCI_INT_ENABLE_DMA_PCIAHB_EN		0x00000100
#define   CXD9225GG_PCI_INT_ENABLE_DMA_AHBPCI_EN		0x00000200
#define   CXD9225GG_PCI_INT_ENABLE_PCIAHB_WIN1_EN		0x00001000
#define   CXD9225GG_PCI_INT_ENABLE_PCIAHB_WIN2_EN		0x00002000
#define   CXD9225GG_PCI_INT_ENABLE_AHBPCI_WIN_EN		0x00004000
#define   CXD9225GG_PCI_INT_ENABLE_PCIINT0_EN		0x00010000
#define   CXD9225GG_PCI_INT_ENABLE_PCIINT1_EN		0x00020000
#define   CXD9225GG_PCI_INT_ENABLE_PCIINT2_EN		0x00040000
#define   CXD9225GG_PCI_INT_ENABLE_PCIINT3_EN		0x00080000
#define   CXD9225GG_PCI_INT_ENABLE_PCIINT_MASK		0x000F0000
#define   CXD9225GG_PCI_INT_ENABLE_PCIINT_SHIFT		(16)
#define CXD9225GG_PCI_INT_STATUS		0x0024
#define   CXD9225GG_PCI_INT_STATUS_ALL_MASK		0x000F73FF
#define   CXD9225GG_PCI_INT_STATUS_SIGTABORT_INT		0x00000001
#define   CXD9225GG_PCI_INT_STATUS_RETABORT_INT		0x00000002
#define   CXD9225GG_PCI_INT_STATUS_REMABORT_INT		0x00000004
#define   CXD9225GG_PCI_INT_STATUS_PERR_INT		0x00000008
#define   CXD9225GG_PCI_INT_STATUS_SIGSERR_INT		0x00000010
#define   CXD9225GG_PCI_INT_STATUS_RESERR_INT		0x00000020
#define   CXD9225GG_PCI_INT_STATUS_PM_STATE_INT		0x00000040
#define   CXD9225GG_PCI_INT_STATUS_CLKRUN_INT		0x00000080
#define   CXD9225GG_PCI_INT_STATUS_DMA_PCIAHB_INT		0x00000100
#define   CXD9225GG_PCI_INT_STATUS_DMA_AHBPCI_INT		0x00000200
#define   CXD9225GG_PCI_INT_STATUS_PCIAHB_WIN1_INT		0x00001000
#define   CXD9225GG_PCI_INT_STATUS_PCIAHB_WIN2_INT		0x00002000
#define   CXD9225GG_PCI_INT_STATUS_AHBPCI_WIN_INT		0x00004000
#define   CXD9225GG_PCI_INT_STATUS_PCIINT0_INT		0x00010000
#define   CXD9225GG_PCI_INT_STATUS_PCIINT1_INT		0x00020000
#define   CXD9225GG_PCI_INT_STATUS_PCIINT2_INT		0x00040000
#define   CXD9225GG_PCI_INT_STATUS_PCIINT3_INT		0x00080000
#define   CXD9225GG_PCI_INT_STATUS_PCIINT_MASK		0x000F0000
#define   CXD9225GG_PCI_INT_STATUS_PCIERR_MASK		0x0000003F
#define   CXD9225GG_PCI_INT_STATUS_PCIINT_SHIFT		(16)
#define CXD9225GG_PCI_PCIERR_ADR		0x0028
#define CXD9225GG_PCI_AHBERR_ADR		0x002C
#define CXD9225GG_PCI_AHB_BUS_CTR		0x0030
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_HTRANS_HBUSREQ	0x00000001
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BYTE_BURST_EN	0x00000002
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_WR_INCR_4816	0x00000004
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BURST_W_MASK	0x00000018
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BURST_W_MAX16	0x00000000
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BURST_W_MAX8	0x00000008
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BURST_W_MAX4	0x00000010
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BURST_W_SINGLE	0x00000018
//#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BOUNDARY_MASK	0x00000060
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BOUNDARY_NON	0x00000000
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BOUNDARY_ADR3F	0x00000020
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BOUNDARY_ADR7F	0x00000040
#define   CXD9225GG_PCI_AHB_BUS_CTR_MMODE_BUSREQ_HGRHRDY	0x00000080
#define   CXD9225GG_PCI_AHB_BUS_CTR_SMODE_READ_BURST_CYC	0x00010000
#define   CXD9225GG_PCI_AHB_BUS_CTR_SMODE_READY_CTR_HRDY	0x00020000
#define CXD9225GG_PCI_ARBITER_CTR		0x0040
#define   CXD9225GG_PCI_ARBITER_CTR_PCIREQ0_EN		0x00000001
#define   CXD9225GG_PCI_ARBITER_CTR_PCIREQ1_EN		0x00000002
#define   CXD9225GG_PCI_ARBITER_CTR_PCIREQ2_EN		0x00000004
#define   CXD9225GG_PCI_ARBITER_CTR_PCIREQ3_EN		0x00000008
#define   CXD9225GG_PCI_ARBITER_CTR_PCIREQ4_EN		0x00000010
#define   CXD9225GG_PCI_ARBITER_CTR_PCIREQ5_EN		0x00000020
#define   CXD9225GG_PCI_ARBITER_CTR_PCIREQ6_EN		0x00000040
#define   CXD9225GG_PCI_ARBITER_CTR_PCIREQ7_EN		0x00000080
#define   CXD9225GG_PCI_ARBITER_CTR_PCIBP_MODE_LAST_AC	0x00001000
#define   CXD9225GG_PCI_ARBITER_CTR_PCIBP_TIMER_MASK	0x00FF0000
#define   CXD9225GG_PCI_ARBITER_CTR_PCIBP_TIMER_SHIFT	(16)
#define CXD9225GG_PCI_EXT_CTR		0x0044
#define   CXD9225GG_PCI_EXT_CTR_SUBWEN_EN			0x00000001
#define   CXD9225GG_PCI_EXT_CTR_COMREG_MSK_ACCESS_DIS	0x00000002
#define CXD9225GG_PCI_UNIT_REV_MINOR	0x0048
#define CXD9225GG_PCI_UNIT_REV_MAJOR	0x004A
#define CXD9225GG_PCI_UNIT_DEBUG_CTR	0x004C
#define CXD9225GG_PCI_PME_CTR		0x0050
#define   CXD9225GG_PCI_PME_CTR_PM_STATE_MASK		0x00000003
#define   CXD9225GG_PCI_PME_CTR_PM_STATE_SHIFT		(0)
#define   CXD9225GG_PCI_PME_CTR_PME_CTR_ASSERT		0x00000004
#define   CXD9225GG_PCI_PME_CTR_CLKRUN_STATE_CLKSTOP	0x00000010
#define   CXD9225GG_PCI_PME_CTR_CLKRUN_CTR_STOP_CTR_EN	0x00000020
#define CXD9225GG_PCI_DMA_AHBPCI_PCIADR	0x0060
#define   CXD9225GG_PCI_DMA_AHBPCI_PCIADR_MASK		0xFFFFFFFC
#define CXD9225GG_PCI_DMA_AHBPCI_AHBADR	0x0064
#define   CXD9225GG_PCI_DMA_AHBPCI_AHBADR_MASK		0xFFFFFFFC
#define CXD9225GG_PCI_DMA_AHBPCI_TSIZE	0x0068
#define   CXD9225GG_PCI_DMA_AHBPCI_TSIZE_MASK		0x03FFFFFC
#define CXD9225GG_PCI_DMA_AHBPCI_CTR	0x006C
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_START_EN		0x00000001
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_STOP_EN		0x00000002
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_STATUS_MASK		0x0000000C
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_STATUS_NOMAL	0x00000000
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_STATUS_PCI_ERR	0x00000004
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_STATUS_AHB_ERR	0x00000008
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_STATUS_TIMEOUT	0x0000000C
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_INTEN_EN		0x00000010
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_ENDIAN_CTR_MASK	0x000000C0
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_ENDIAN_CTR_NO	0x00000000
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_ENDIAN_CTR_BDS	0x00000080
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_ENDIAN_CTR_HWDS	0x000000C0
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_PCICMD_MASK		0x00000E00
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_PCICMD_SPECIAL	0x00000000
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_PCICMD_IO		0x00000200
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_PCICMD_MEMORY	0x00000600
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_ADR_MODE_FIXED	0x00001000
#define   CXD9225GG_PCI_DMA_AHBPCI_CTR_TRANS_MODE_SINGLE	0x00002000
#define CXD9225GG_PCI_DMA_AHBPCI_DCT	0x0070
#define   CXD9225GG_PCI_DMA_AHBPCI_DCT_DISCARD_EN		0x00000001
#define   CXD9225GG_PCI_DMA_AHBPCI_DCT_DISCARD_TIM_MASK	0x0000FFF0
#define   CXD9225GG_PCI_DMA_AHBPCI_DCT_DISCARD_TIM_SHIFT	(4)
#define CXD9225GG_PCI_DMA_PCIAHB_PCIADR	0x0080
#define   CXD9225GG_PCI_DMA_PCIAHB_PCIADR_MASK		0xFFFFFFFC
#define CXD9225GG_PCI_DMA_PCIAHB_AHBADR	0x0084
#define   CXD9225GG_PCI_DMA_PCIAHB_AHBADR_MASK		0xFFFFFFFC
#define CXD9225GG_PCI_DMA_PCIAHB_TSIZE	0x0088
#define   CXD9225GG_PCI_DMA_PCIAHB_TSIZE_MASK		0x3FFFFFFC
#define CXD9225GG_PCI_DMA_PCIAHB_CTR	0x008C
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_START_EN		0x00000001
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_STOP_EN		0x00000002
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_STATUS_MASK		0x0000000C
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_STATUS_NOMAL	0x00000000
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_STATUS_PCI_ERR	0x00000004
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_STATUS_AHB_ERR	0x00000008
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_STATUS_TIMEOUT	0x0000000C
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_INTEN_EN		0x00000010
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_ENDIAN_CTR_MASK	0x000000C0
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_ENDIAN_CTR_NO	0x00000000
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_ENDIAN_CTR_BDS	0x00000080
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_ENDIAN_CTR_HWDS	0x000000C0
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_PCICMD_MASK		0x00000E00
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_PCICMD_INTACK	0x00000000
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_PCICMD_IO		0x00000200
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_PCICMD_MEMORY	0x00000600
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_PCICMD_MULTIPLE	0x00000C00
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_PCICMD_LINE		0x00000E00
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_ADR_MODE_FIXED	0x00001000
#define   CXD9225GG_PCI_DMA_PCIAHB_CTR_TRANS_MODE_SINGLE	0x00002000
#define CXD9225GG_PCI_DMA_PCIAHB_DCT	0x0090
#define   CXD9225GG_PCI_DMA_PCIAHB_DCT_DISCARD_EN		0x00000001
#define   CXD9225GG_PCI_DMA_PCIAHB_DCT_DISCARD_TIM_MASK	0x0000FFF0
#define   CXD9225GG_PCI_DMA_PCIAHB_DCT_DISCARD_TIM_SHIFT	(4)



/* PCI Configuration Register */
#define CXD9225GG_PCI_PCICFG_VENDOR_ID	0x0000
#define CXD9225GG_PCI_PCICFG_DEVICE_ID	0x0002
#define CXD9225GG_PCI_PCICFG_STATUS_COM	0x0004
#define   CXD9225GG_PCI_PCICFG_COMMAND_IOEN		0x00000001
#define   CXD9225GG_PCI_PCICFG_COMMAND_MEMEN		0x00000002
#define   CXD9225GG_PCI_PCICFG_COMMAND_MASTEREN		0x00000004
#define   CXD9225GG_PCI_PCICFG_COMMAND_SPECIALC		0x00000008
#define   CXD9225GG_PCI_PCICFG_COMMAND_MWINVEN		0x00000010
#define   CXD9225GG_PCI_PCICFG_COMMAND_VGAPSNP		0x00000020
#define   CXD9225GG_PCI_PCICFG_COMMAND_PERREN		0x00000040
#define   CXD9225GG_PCI_PCICFG_COMMAND_STEPCTR		0x00000080
#define   CXD9225GG_PCI_PCICFG_COMMAND_SERREN		0x00000100
#define   CXD9225GG_PCI_PCICFG_COMMAND_FBTBEN		0x00000200
#define   CXD9225GG_PCI_PCICFG_COMMAND_INTDIS		0x00000400
#define   CXD9225GG_PCI_PCICFG_STATUS_INTSTATUS		0x00080000
#define   CXD9225GG_PCI_PCICFG_STATUS_CAPLIST		0x00100000
#define   CXD9225GG_PCI_PCICFG_STATUS_66MCAP		0x00200000
#define   CXD9225GG_PCI_PCICFG_STATUS_FBTBCAP		0x00800000
#define   CXD9225GG_PCI_PCICFG_STATUS_MDPERR		0x01000000
#define   CXD9225GG_PCI_PCICFG_STATUS_DEVTIM_MSK		0x06000000
#define   CXD9225GG_PCI_PCICFG_STATUS_DEVTIM_MID		0x02000000
#define   CXD9225GG_PCI_PCICFG_STATUS_SIGTABORT		0x08000000
#define   CXD9225GG_PCI_PCICFG_STATUS_RETABORT		0x10000000
#define   CXD9225GG_PCI_PCICFG_STATUS_REMABORT		0x20000000
#define   CXD9225GG_PCI_PCICFG_STATUS_SIGSERR		0x40000000
#define   CXD9225GG_PCI_PCICFG_STATUS_DETPERR		0x80000000
#define CXD9225GG_PCI_PCICFG_CLASS_REV	0x0008
#define   CXD9225GG_PCI_PCICFG_REVID_MASK			0x000000FF
#define   CXD9225GG_PCI_PCICFG_REVID_SHIFT			(0)
#define   CXD9225GG_PCI_PCICFG_CLASSCODE_MASK		0xFFFFFF00
#define   CXD9225GG_PCI_PCICFG_CLASSCODE_SHIFT		(8)
#define CXD9225GG_PCI_PCICFG_MISC0		0x000C
#define   CXD9225GG_PCI_PCICFG_CACLINSIZ_MASK		0x000000FF
#define   CXD9225GG_PCI_PCICFG_CACLINSIZ_SHIFT		(0)
#define   CXD9225GG_PCI_PCICFG_LATENCYTIM_MASK		0x0000FF00
#define   CXD9225GG_PCI_PCICFG_LATENCYTIM_SHIFT		(8)
#define   CXD9225GG_PCI_PCICFG_HEADERTYPE_MASK		0x00FF0000
#define   CXD9225GG_PCI_PCICFG_HEADERTYPE_SHIFT		(16)
#define   CXD9225GG_PCI_PCICFG_BIST_MASK			0xFF000000
#define   CXD9225GG_PCI_PCICFG_BIST_SHIFT			(24)
#define CXD9225GG_PCI_PCICFG_BAR0		0x0010
#define CXD9225GG_PCI_PCICFG_BAR1		0x0014
#define CXD9225GG_PCI_PCICFG_BAR2		0x0018
#define   CXD9225GG_PCI_PCICFG_BAR_MEM			0x00000001
#define   CXD9225GG_PCI_PCICFG_BAR_TYPE_MASK		0x00000006
#define   CXD9225GG_PCI_PCICFG_BAR_TYPE_32BIT		0x00000000
#define   CXD9225GG_PCI_PCICFG_BAR_TYPE_64BIT		0x00000004
#define   CXD9225GG_PCI_PCICFG_BAR_PREFECH			0x00000008
#define   CXD9225GG_PCI_PCICFG_BAR_MASK			0xFFFFFC00
#define CXD9225GG_PCI_PCICFG_SUBVEND_ID	0x002C
#define CXD9225GG_PCI_PCICFG_SUBSYS_ID	0x002E
#define CXD9225GG_PCI_PCICFG_EXT0		0x0034
#define   CXD9225GG_PCI_PCICFG_EXT0_CAP_POINTER_MASK	0x000000FF
#define CXD9225GG_PCI_PCICFG_MISC1	0x003C
#define   CXD9225GG_PCI_PCICFG_INT_LINE_SIZE_MASK		0x000000FF
#define   CXD9225GG_PCI_PCICFG_INT_LINE_SIZE_SHIFT		(0)
#define   CXD9225GG_PCI_PCICFG_INT_PIN_MASK		0x0000FF00
#define   CXD9225GG_PCI_PCICFG_INT_PIN_SHIFT		(8)
#define   CXD9225GG_PCI_PCICFG_MIN_GNT_MASK		0x00FF0000
#define   CXD9225GG_PCI_PCICFG_MIN_GNT_SHIFT		(16)
#define   CXD9225GG_PCI_PCICFG_MAX_LAT_MASK		0xFF000000
#define   CXD9225GG_PCI_PCICFG_MAX_LAT_SHIFT		(24)
#define CXD9225GG_PCI_PCICFG_PM0		0x0040
#define   CXD9225GG_PCI_PCICFG_PM0_CAP_IDENTIFER_MASK	0x000000FF
#define   CXD9225GG_PCI_PCICFG_PM0_CAP_IDENTIFER_SHIFT	(0)
#define   CXD9225GG_PCI_PCICFG_PM0_NEXT_ITEM_MASK		0x0000FF00
#define   CXD9225GG_PCI_PCICFG_PM0_NEXT_ITEM_SHIFT		(8)
#define   CXD9225GG_PCI_PCICFG_PM0_PM_CAP_MASK		0xFFFF0000
#define   CXD9225GG_PCI_PCICFG_PM0_PM_CAP_SHIFT		(16)
#define CXD9225GG_PCI_PCICFG_PM1		0x0044
#define   CXD9225GG_PCI_PCICFG_PM1_POWSTATE_MASK		0x00000003
#define   CXD9225GG_PCI_PCICFG_PM1_POWSTATE_D0		0x00000000
#define   CXD9225GG_PCI_PCICFG_PM1_POWSTATE_D1		0x00000001
#define   CXD9225GG_PCI_PCICFG_PM1_POWSTATE_D2		0x00000002
#define   CXD9225GG_PCI_PCICFG_PM1_POWSTATE_D3		0x00000003
#define   CXD9225GG_PCI_PCICFG_PM1_PME_ENABLE		0x00000100
#define   CXD9225GG_PCI_PCICFG_PM1_PME_ASSERT		0x00008000



/* SPI-Flash MEMC Register */
#define CXD9225GG_SFMEMC_SFMSMD_OFFSET		0x0000
#define CXD9225GG_SFMEMC_SFMSSC_OFFSET		0x0004
#define CXD9225GG_SFMEMC_SFMSKC_OFFSET		0x0008
#define CXD9225GG_SFMEMC_SFMSST_OFFSET		0x000C
#define CXD9225GG_SFMEMC_SFMCOM_OFFSET		0x0010
#define CXD9225GG_SFMEMC_SFMCMD_OFFSET		0x0014
#define CXD9225GG_SFMEMC_SFMCST_OFFSET		0x0018

#define CXD9225GG_SFMEMC_SFMSMD	(CXD9225GG_SFMEMC_BASE + CXD9225GG_SFMEMC_SFMSMD_OFFSET)
#define   CXD9225GG_SFMEMC_SFMSMD_SFMRM_MASK	0x0003
#define   CXD9225GG_SFMEMC_SFMSMD_SFMRM_STANDARD	0x0000
#define   CXD9225GG_SFMEMC_SFMSMD_SFMRM_FAST	0x0001
#define   CXD9225GG_SFMEMC_SFMSMD_SFMRM_FAST_DUAL	0x0002
#define   CXD9225GG_SFMEMC_SFMSMD_SFMRM_FAST_DIO	0x0003
#define   CXD9225GG_SFMEMC_SFMSMD_SFMSE_MASK	0x0030
#define   CXD9225GG_SFMEMC_SFMSMD_SFMSE_NON	0x0000
#define   CXD9225GG_SFMEMC_SFMSMD_SFMSE_32xSCK	0x0010
#define   CXD9225GG_SFMEMC_SFMSMD_SFMSE_128xSCK	0x0020
#define   CXD9225GG_SFMEMC_SFMSMD_SFMSE_ENDLESS	0x0030
#define   CXD9225GG_SFMEMC_SFMSMD_SFMPFE_EN	0x0040
#define   CXD9225GG_SFMEMC_SFMSMD_SFMPAE_EN	0x0080
#define   CXD9225GG_SFMEMC_SFMSMD_SFMMD3_EN	0x0100
#define   CXD9225GG_SFMEMC_SFMSMD_SFMOEX_EN	0x0200
#define   CXD9225GG_SFMEMC_SFMSMD_SFMOHW_EN	0x0400
#define   CXD9225GG_SFMEMC_SFMSMD_SFMOSW_EN	0x0800
#define CXD9225GG_SFMEMC_SFMSSC	(CXD9225GG_SFMEMC_BASE + CXD9225GG_SFMEMC_SFMSSC_OFFSET)
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_MASK	0x000F
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_1xSCK	0x0000
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_2xSCK	0x0001
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_3xSCK	0x0002
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_4xSCK	0x0003
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_5xSCK	0x0004
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_6xSCK	0x0005
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_7xSCK	0x0006
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_8xSCK	0x0007
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_9xSCK	0x0008
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_10xSCK	0x0009
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_11xSCK	0x000A
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_12xSCK	0x000B
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_13xSCK	0x000C
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_14xSCK	0x000D
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_15xSCK	0x000E
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSW_16xSCK	0x000F
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSHD_1_5xSCK	0x0010
#define   CXD9225GG_SFMEMC_SFMSSC_SFMSLD_1_5xSCK	0x0020
#define CXD9225GG_SFMEMC_SFMSKC	(CXD9225GG_SFMEMC_BASE + CXD9225GG_SFMEMC_SFMSKC_OFFSET)
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_MASK	0x001F
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_2xCLK	0x0000
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_3xCLK	0x0001
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_4xCLK	0x0002
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_5xCLK	0x0003
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_6xCLK	0x0004
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_7xCLK	0x0005
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_8xCLK	0x0006
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_9xCLK	0x0007
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_10xCLK	0x0008
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_11xCLK	0x0009
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_12xCLK	0x000A
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_13xCLK	0x000B
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_14xCLK	0x000C
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_15xCLK	0x000D
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_16xCLK	0x000E
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_17xCLK	0x000F
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_18xCLK	0x0010
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_20xCLK	0x0011
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_22xCLK	0x0012
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_24xCLK	0x0013
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_26xCLK	0x0014
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_28xCLK	0x0015
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_30xCLK	0x0016
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_32xCLK	0x0017
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_34xCLK	0x0018
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_36xCLK	0x0019
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_38xCLK	0x001A
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_40xCLK	0x001B
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_42xCLK	0x001C
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_44xCLK	0x001D
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_46xCLK	0x001E
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDV_48xCLK	0x001F
#define   CXD9225GG_SFMEMC_SFMSKC_SFMDTY_EN	0x0020
#define CXD9225GG_SFMEMC_SFMSST	(CXD9225GG_SFMEMC_BASE + CXD9225GG_SFMEMC_SFMSST_OFFSET)
#define   CXD9225GG_SFMEMC_SFMSST_SFMCNT_MASK	0x0007
#define   CXD9225GG_SFMEMC_SFMSST_SFMCNT_NON	0x0000
#define   CXD9225GG_SFMEMC_SFMSST_SFMCNT_1BYTE	0x0001
#define   CXD9225GG_SFMEMC_SFMSST_SFMCNT_2BYTE	0x0002
#define   CXD9225GG_SFMEMC_SFMSST_SFMCNT_3BYTE	0x0003
#define   CXD9225GG_SFMEMC_SFMSST_SFMCNT_4BYTE	0x0004
#define   CXD9225GG_SFMEMC_SFMSST_PFOFF_OFF	0x0008
#define CXD9225GG_SFMEMC_SFMCOM	(CXD9225GG_SFMEMC_BASE + CXD9225GG_SFMEMC_SFMCOM_OFFSET)
#define   CXD9225GG_SFMEMC_SFMCOM_WRITE_ENABLE	0x06
#define   CXD9225GG_SFMEMC_SFMCOM_WRITE_DISABLE	0x04
#define   CXD9225GG_SFMEMC_SFMCOM_READ_ID		0x9F
#define   CXD9225GG_SFMEMC_SFMCOM_READ_STS_REG	0x05
#define   CXD9225GG_SFMEMC_SFMCOM_WRITE_STS_REG	0x01
#define   CXD9225GG_SFMEMC_SFMCOM_READ_DATA	0x03
#define   CXD9225GG_SFMEMC_SFMCOM_FAST_READ	0x0B
#define   CXD9225GG_SFMEMC_SFMCOM_DUALOUT_FASTREAD	0x3B
#define   CXD9225GG_SFMEMC_SFMCOM_READ_OTP		0x4B
#define   CXD9225GG_SFMEMC_SFMCOM_PROGRAM_OTP	0x42
#define   CXD9225GG_SFMEMC_SFMCOM_PAGE_PROGRAM	0x02
#define   CXD9225GG_SFMEMC_SFMCOM_DUALIN_PAGEPROG	0xA2
#define   CXD9225GG_SFMEMC_SFMCOM_SUBSECTOR_ERASE	0x20
#define   CXD9225GG_SFMEMC_SFMCOM_SECTOR_ERASE	0xD8
#define   CXD9225GG_SFMEMC_SFMCOM_BULK_ERASE	0xC7
#define   CXD9225GG_SFMEMC_SFMCOM_READ_ELEC_SIG	0xAB
#define   CXD9225GG_SFMEMC_SFMCOM_STS_REG_WIP	0x01
#define   CXD9225GG_SFMEMC_SFMCOM_STS_REG_WEL	0x02
#define   CXD9225GG_SFMEMC_SFMCOM_STS_REG_BP0	0x04
#define   CXD9225GG_SFMEMC_SFMCOM_STS_REG_BP1	0x08
#define   CXD9225GG_SFMEMC_SFMCOM_STS_REG_BP2	0x10
#define   CXD9225GG_SFMEMC_SFMCOM_STS_REG_SRWD	0x80
#define CXD9225GG_SFMEMC_SFMCMD	(CXD9225GG_SFMEMC_BASE + CXD9225GG_SFMEMC_SFMCMD_OFFSET)
#define   CXD9225GG_SFMEMC_SFMCMD_DCOM_ROM_ACCESS	0x0000
#define   CXD9225GG_SFMEMC_SFMCMD_DCOM_DIRECT_CON	0x0001
#define CXD9225GG_SFMEMC_SFMCST	(CXD9225GG_SFMEMC_BASE + CXD9225GG_SFMEMC_SFMCST_OFFSET)
#define   CXD9225GG_SFMEMC_SFMCST_COMBSY_BUSY	0x0001
#define   CXD9225GG_SFMEMC_SFMCST_EROMR_ERR	0x0080



/* DDR2 Memory Control */
#define CXD9225GG_MEMC_MIF_CONFIG_OFFSET		0x0004
#define CXD9225GG_MEMC_MIF_INIT_OFFSET		0x0008
#define CXD9225GG_MEMC_MIF_REFCNT_OFFSET		0x000C
#define CXD9225GG_MEMC_MIF_CONFIG2_OFFSET		0x0010
#define CXD9225GG_MEMC_MIF_CONFIG3_OFFSET		0x0014
#define CXD9225GG_MEMC_MB0_CFG_OFFSET		0x0020
#define CXD9225GG_MEMC_MB1_CFG_OFFSET		0x0024
#define CXD9225GG_MEMC_MB2_CFG_OFFSET		0x0028
#define CXD9225GG_MEMC_MB3_CFG_OFFSET		0x002C
#define CXD9225GG_MEMC_MB4_CFG_OFFSET		0x0030
#define CXD9225GG_MEMC_MB5_CFG_OFFSET		0x0034
#define CXD9225GG_MEMC_MB6_CFG_OFFSET		0x0038
#define CXD9225GG_MEMC_MB7_CFG_OFFSET		0x003C
#define CXD9225GG_MEMC_MB8_CFG_OFFSET		0x0040
#define CXD9225GG_MEMC_MB9_CFG_OFFSET		0x0044
#define CXD9225GG_MEMC_MB10_CFG_OFFSET		0x0048
#define CXD9225GG_MEMC_MB11_CFG_OFFSET		0x004C
#define CXD9225GG_MEMC_MB12_CFG_OFFSET		0x0050
#define CXD9225GG_MEMC_MB13_CFG_OFFSET		0x0054
#define CXD9225GG_MEMC_MB14_CFG_OFFSET		0x0058
#define CXD9225GG_MEMC_MB15_CFG_OFFSET		0x005C
#define CXD9225GG_MEMC_MIF_CNT_CFG1_OFFSET		0x0074
#define CXD9225GG_MEMC_MIF_CNT_CFG2_OFFSET		0x0078
#define CXD9225GG_MEMC_MIF_REQCNT_OFFSET		0x007C
#define CXD9225GG_MEMC_MIF_INT_MASK_OFFSET		0x0084
#define CXD9225GG_MEMC_MIF_AERR_OFFSET		0x0088
#define CXD9225GG_MEMC_MIF_AERR_CFG_OFFSET		0x008C
#define CXD9225GG_MEMC_MIF_AERR_START_OFFSET	0x0090
#define CXD9225GG_MEMC_MIF_AERR_END_OFFSET		0x0094
#define CXD9225GG_DDR2TOP_MIF_RSTB_OFFSET		0x01B0
#define CXD9225GG_DDR2TOP_MIF_ODTSW_OFFSET		0x01B4
#define CXD9225GG_DDR2TOP_MIF_IOLHRSTB_OFFSET	0x01B8
#define CXD9225GG_DDR2TOP_MIF_IOLHCTRL_OFFSET	0x01BC
#define CXD9225GG_DDR2TOP_MIF_DLLSTBY_OFFSET	0x01C0
#define CXD9225GG_DDR2TOP_MIF_DLLCTRL_OFFSET	0x01C4
#define CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFFSET	0x01C8
#define CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFFSET	0x01CC
#define CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_OFFSET	0x01D0
#define CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFFSET	0x01DC
#define CXD9225GG_DDR2TOP_MIF_IOCTRL_OFFSET	0x01E0

#define CXD9225GG_MEMC_MIF_CONFIG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_CONFIG_OFFSET)
#define   CXD9225GG_MEMC_MIF_CONFIG_COL_8BIT_DQ0		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG_COL_9BIT_DQ0		0x00000001
#define   CXD9225GG_MEMC_MIF_CONFIG_COL_10BIT_DQ0		0x00000002
#define   CXD9225GG_MEMC_MIF_CONFIG_COL_11BIT_DQ0		0x00000003
#define   CXD9225GG_MEMC_MIF_CONFIG_COL_9BIT_DQ1		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG_COL_10BIT_DQ1		0x00000001
#define   CXD9225GG_MEMC_MIF_CONFIG_COL_11BIT_DQ1		0x00000002
#define   CXD9225GG_MEMC_MIF_CONFIG_ROW_12BIT		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG_ROW_13BIT		0x00000004
#define   CXD9225GG_MEMC_MIF_CONFIG_ROW_14BIT		0x00000008
#define   CXD9225GG_MEMC_MIF_CONFIG_ROW_15BIT		0x0000000C
#define   CXD9225GG_MEMC_MIF_CONFIG_TRCD_3MCLK		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG_TRCD_4MCLK		0x00000010
#define   CXD9225GG_MEMC_MIF_CONFIG_TRCD_5MCLK		0x00000020
#define   CXD9225GG_MEMC_MIF_CONFIG_TRCD_6MCLK		0x00000030
#define   CXD9225GG_MEMC_MIF_CONFIG_TRP_1MCLK		0x00000040
#define   CXD9225GG_MEMC_MIF_CONFIG_TRP_2MCLK		0x00000080
#define   CXD9225GG_MEMC_MIF_CONFIG_TRP_3MCLK		0x000000C0
#define   CXD9225GG_MEMC_MIF_CONFIG_TRP_4MCLK		0x00000100
#define   CXD9225GG_MEMC_MIF_CONFIG_TRP_5MCLK		0x00000140
#define   CXD9225GG_MEMC_MIF_CONFIG_TRP_6MCLK		0x00000180
#define   CXD9225GG_MEMC_MIF_CONFIG_TRP_7MCLK		0x000001C0
#define   CXD9225GG_MEMC_MIF_CONFIG_TWR_0MCLK		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG_TWR_1MCLK		0x00000200
#define   CXD9225GG_MEMC_MIF_CONFIG_TWR_2MCLK		0x00000400
#define   CXD9225GG_MEMC_MIF_CONFIG_TWR_3MCLK		0x00000600
#define   CXD9225GG_MEMC_MIF_CONFIG_TWR_4MCLK		0x00000800
#define   CXD9225GG_MEMC_MIF_CONFIG_TWR_5MCLK		0x00000A00
#define   CXD9225GG_MEMC_MIF_CONFIG_TWR_6MCLK		0x00000C00
#define   CXD9225GG_MEMC_MIF_CONFIG_TWR_7MCLK		0x00000E00
#define   CXD9225GG_MEMC_MIF_CONFIG_TRFC_MASK		0x0003F000
#define   CXD9225GG_MEMC_MIF_CONFIG_TRFC_SHIFT		(12)
#define   CXD9225GG_MEMC_MIF_CONFIG_TRFC_DEFAULT		0x21
#define   CXD9225GG_MEMC_MIF_CONFIG_TWTR_1MCLK		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG_TWTR_2MCLK		0x00040000
#define   CXD9225GG_MEMC_MIF_CONFIG_TWTR_3MCLK		0x00080000
#define   CXD9225GG_MEMC_MIF_CONFIG_TWTR_4MCLK		0x000C0000
#define   CXD9225GG_MEMC_MIF_CONFIG_TRAS_MASK		0x01F00000
#define   CXD9225GG_MEMC_MIF_CONFIG_TRAS_SHIFT		(20)
#define   CXD9225GG_MEMC_MIF_CONFIG_TRAS_DEFAULT		0x0B
#define   CXD9225GG_MEMC_MIF_CONFIG_CL_CL3			0x0C000000
#define   CXD9225GG_MEMC_MIF_CONFIG_CL_CL4			0x10000000
#define   CXD9225GG_MEMC_MIF_CONFIG_CL_CL5			0x14000000
#define   CXD9225GG_MEMC_MIF_CONFIG_CL_CL6			0x18000000
#define   CXD9225GG_MEMC_MIF_CONFIG_TRTP_2MCLK		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG_TRTP_3MCLK		0x20000000
#define   CXD9225GG_MEMC_MIF_CONFIG_DQ_4TO1		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG_DQ_8TO1		0x40000000
#define   CXD9225GG_MEMC_MIF_CONFIG_BANK_4BANK		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG_BANK_8BANK		0x80000000
#define CXD9225GG_MEMC_MIF_INIT		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_INIT_OFFSET)
#define   CXD9225GG_MEMC_MIF_INIT_REF_NOP			0x00000000
#define   CXD9225GG_MEMC_MIF_INIT_REF_REFRESH		0x00000001
#define   CXD9225GG_MEMC_MIF_INIT_REG_NOP			0x00000000
#define   CXD9225GG_MEMC_MIF_INIT_REG_MODE_REG_SET		0x00000002
#define   CXD9225GG_MEMC_MIF_INIT_PRE_NOP			0x00000000
#define   CXD9225GG_MEMC_MIF_INIT_PRE_PRECHARGE		0x00000004
#define   CXD9225GG_MEMC_MIF_INIT_SRF_NOP			0x00000000
#define   CXD9225GG_MEMC_MIF_INIT_SRF_SELF_REFRESH		0x00000008
#define   CXD9225GG_MEMC_MIF_INIT_PDN_NOP			0x00000000
#define   CXD9225GG_MEMC_MIF_INIT_PDN_POWER_DOWN		0x00000010
#define   CXD9225GG_MEMC_MIF_INIT_EXI_NOP			0x00000000
#define   CXD9225GG_MEMC_MIF_INIT_EXI_EXIT			0x00000020
#define   CXD9225GG_MEMC_MIF_INIT_OCD_NOP			0x00000000
#define   CXD9225GG_MEMC_MIF_INIT_OCD_CALIBRATION		0x00000040
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_NOP			0x00000000
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_PUPDRVAD1		0x00000100
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_PUPDRVSB1		0x00000200
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_PDNDRVAD1		0x00000400
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_PDNDRVSB1		0x00000800
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_PUPDRVAD1_PDNDRVAD1	0x00000500
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_PUPDRVSB1_PDNDRVAD1	0x00000600
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_PUPDRVAD1_PDNDRVSB1	0x00000900
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_PUPDRVSB1_PDNDRVSB1	0x00000A00
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_BA_MASK		0x0000E000
#define   CXD9225GG_MEMC_MIF_INIT_OCDA_ADDRESS_MASK	0x7FFF0000
#define CXD9225GG_MEMC_MIF_REFCNT		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_REFCNT_OFFSET)
#define   CXD9225GG_MEMC_MIF_REFCNT_REFCNT_MASK		0x000000FF
#define   CXD9225GG_MEMC_MIF_REFCNT_REN_DIS		0x00000000
#define   CXD9225GG_MEMC_MIF_REFCNT_REN_EN			0x00000100
#define CXD9225GG_MEMC_MIF_CONFIG2		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_CONFIG2_OFFSET)
#define   CXD9225GG_MEMC_MIF_CONFIG2_R2RD0_2MCLK		0x00000002
#define   CXD9225GG_MEMC_MIF_CONFIG2_R2RD0_3MCLK		0x00000003
#define   CXD9225GG_MEMC_MIF_CONFIG2_R2RD0_4MCLK		0x00000004
#define   CXD9225GG_MEMC_MIF_CONFIG2_R2RD0_5MCLK		0x00000005
#define   CXD9225GG_MEMC_MIF_CONFIG2_R2RD0_6MCLK		0x00000006
#define   CXD9225GG_MEMC_MIF_CONFIG2_R2RD0_7MCLK		0x00000007
#define   CXD9225GG_MEMC_MIF_CONFIG2_W2RD0_2MCLK		0x00000010
#define   CXD9225GG_MEMC_MIF_CONFIG2_W2RD0_3MCLK		0x00000018
#define   CXD9225GG_MEMC_MIF_CONFIG2_W2RD0_4MCLK		0x00000020
#define   CXD9225GG_MEMC_MIF_CONFIG2_W2RD0_5MCLK		0x00000028
#define   CXD9225GG_MEMC_MIF_CONFIG2_W2RD0_6MCLK		0x00000030
#define   CXD9225GG_MEMC_MIF_CONFIG2_W2RD0_7MCLK		0x00000038
#define   CXD9225GG_MEMC_MIF_CONFIG2_R2WD_1MCLK		0x00000040
#define   CXD9225GG_MEMC_MIF_CONFIG2_R2WD_2MCLK		0x00000080
#define   CXD9225GG_MEMC_MIF_CONFIG2_R2WD_3MCLK		0x000000C0
#define   CXD9225GG_MEMC_MIF_CONFIG2_TFAW_16MCLK		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG2_TFAW_17MCLK		0x00000100
#define   CXD9225GG_MEMC_MIF_CONFIG2_TFAW_18MCLK		0x00000200
#define   CXD9225GG_MEMC_MIF_CONFIG2_TFAW_19MCLK		0x00000300
#define   CXD9225GG_MEMC_MIF_CONFIG2_TFAW_20MCLK		0x00000400
#define   CXD9225GG_MEMC_MIF_CONFIG2_TFAW_21MCLK		0x00000500
#define   CXD9225GG_MEMC_MIF_CONFIG2_TFAW_22MCLK		0x00000600
#define   CXD9225GG_MEMC_MIF_CONFIG2_TFAW_23MCLK		0x00000700
#define   CXD9225GG_MEMC_MIF_CONFIG2_DQREAD_A		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG2_DQREAD_B		0x00003000
#define   CXD9225GG_MEMC_MIF_CONFIG2_DQREAD_C		0x00002000
#define   CXD9225GG_MEMC_MIF_CONFIG2_CS_1CS		0x00000000
#define   CXD9225GG_MEMC_MIF_CONFIG2_CS_2CS		0x00004000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_32MB_MBUS64	0x00020000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_64MB_MBUS64	0x00040000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_128MB_MBUS64	0x00080000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_256MB_MBUS64	0x00100000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_512MB_MBUS64	0x00110000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_1024MB_MBUS64	0x00120000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_32MB_MBUS128	0x00010000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_64MB_MBUS128	0x00020000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_128MB_MBUS128	0x00040000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_256MB_MBUS128	0x00080000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_512MB_MBUS128	0x00100000
#define   CXD9225GG_MEMC_MIF_CONFIG2_SIZE_1024MB_MBUS128	0x00130000
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK0TMG0_MASK		0x03000000
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK0TMG0_SHIFT	(24)
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK0TMG0_DEFAULT	0
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK1TMG0_MASK		0x0C000000
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK1TMG0_SHIFT	(26)
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK1TMG0_DEFAULT	0
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK2TMG0_MASK		0x30000000
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK2TMG0_SHIFT	(28)
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK2TMG0_DEFAULT	0
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK3TMG0_MASK		0xC0000000
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK3TMG0_SHIFT	(30)
#define   CXD9225GG_MEMC_MIF_CONFIG2_MSK3TMG0_DEFAULT	0
#define CXD9225GG_MEMC_MIF_CONFIG3		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_CONFIG3_OFFSET)
#define   CXD9225GG_MEMC_MIF_CONFIG3_R2RD1_2MCLK		0x00000002
#define   CXD9225GG_MEMC_MIF_CONFIG3_R2RD1_3MCLK		0x00000003
#define   CXD9225GG_MEMC_MIF_CONFIG3_R2RD1_4MCLK		0x00000004
#define   CXD9225GG_MEMC_MIF_CONFIG3_R2RD1_5MCLK		0x00000005
#define   CXD9225GG_MEMC_MIF_CONFIG3_R2RD1_6MCLK		0x00000006
#define   CXD9225GG_MEMC_MIF_CONFIG3_R2RD1_7MCLK		0x00000007
#define   CXD9225GG_MEMC_MIF_CONFIG3_W2RD1_2MCLK		0x00000010
#define   CXD9225GG_MEMC_MIF_CONFIG3_W2RD1_3MCLK		0x00000018
#define   CXD9225GG_MEMC_MIF_CONFIG3_W2RD1_4MCLK		0x00000020
#define   CXD9225GG_MEMC_MIF_CONFIG3_W2RD1_5MCLK		0x00000028
#define   CXD9225GG_MEMC_MIF_CONFIG3_W2RD1_6MCLK		0x00000030
#define   CXD9225GG_MEMC_MIF_CONFIG3_W2RD1_7MCLK		0x00000038
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK0TMG0_MASK		0x03000000
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK0TMG0_SHIFT	(24)
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK0TMG0_DEFAULT	0
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK1TMG0_MASK		0x0C000000
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK1TMG0_SHIFT	(26)
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK1TMG0_DEFAULT	0
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK2TMG0_MASK		0x30000000
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK2TMG0_SHIFT	(28)
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK2TMG0_DEFAULT	0
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK3TMG0_MASK		0xC0000000
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK3TMG0_SHIFT	(30)
#define   CXD9225GG_MEMC_MIF_CONFIG3_MSK3TMG0_DEFAULT	0
#define CXD9225GG_MEMC_MB0_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB0_CFG_OFFSET)
#define CXD9225GG_MEMC_MB1_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB1_CFG_OFFSET)
#define CXD9225GG_MEMC_MB2_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB2_CFG_OFFSET)
#define CXD9225GG_MEMC_MB3_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB3_CFG_OFFSET)
#define CXD9225GG_MEMC_MB4_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB4_CFG_OFFSET)
#define CXD9225GG_MEMC_MB5_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB5_CFG_OFFSET)
#define CXD9225GG_MEMC_MB6_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB6_CFG_OFFSET)
#define CXD9225GG_MEMC_MB7_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB7_CFG_OFFSET)
#define CXD9225GG_MEMC_MB8_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB8_CFG_OFFSET)
#define CXD9225GG_MEMC_MB9_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB9_CFG_OFFSET)
#define CXD9225GG_MEMC_MB10_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB10_CFG_OFFSET)
#define CXD9225GG_MEMC_MB11_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB11_CFG_OFFSET)
#define CXD9225GG_MEMC_MB12_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB12_CFG_OFFSET)
#define CXD9225GG_MEMC_MB13_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB13_CFG_OFFSET)
#define CXD9225GG_MEMC_MB14_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB14_CFG_OFFSET)
#define CXD9225GG_MEMC_MB15_CFG		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MB15_CFG_OFFSET)
#define   CXD9225GG_MEMC_MBX_CFG_COUNT1_MASK		0x000000FF
#define   CXD9225GG_MEMC_MBX_CFG_COUNT1_SHIFT		(0)
#define   CXD9225GG_MEMC_MBX_CFG_COUNT2_MASK		0x0000FF00
#define   CXD9225GG_MEMC_MBX_CFG_COUNT2_SHIFT		(8)
#define   CXD9225GG_MEMC_MBX_CFG_COUNT3_MASK		0x00FF0000
#define   CXD9225GG_MEMC_MBX_CFG_COUNT3_SHIFT		(16)
#define   CXD9225GG_MEMC_MBX_CFG_CS_TRANS_ASSERT		0x00000000
#define   CXD9225GG_MEMC_MBX_CFG_CS_TRANS_RECEIVE		0x01000000
#define   CXD9225GG_MEMC_MBX_CFG_MR_NO_CHK			0x00000000
#define   CXD9225GG_MEMC_MBX_CFG_MR_CHECK			0x02000000
#define   CXD9225GG_MEMC_MBX_CFG_UR_NO_REQ			0x00000000
#define   CXD9225GG_MEMC_MBX_CFG_UR_REQUEST		0x04000000
#define   CXD9225GG_MEMC_MBX_CFG_SR_ROUNDROBIN		0x00000000
#define   CXD9225GG_MEMC_MBX_CFG_SR_NO_ROUNDROBIN		0x08000000
#define   CXD9225GG_MEMC_MBX_CFG_IR_INT_ACCESS_DIS		0x00000000
#define   CXD9225GG_MEMC_MBX_CFG_IR_INT_ACCESS_EN		0x10000000
#define   CXD9225GG_MEMC_MBX_CFG_PR_SYSBUSIF0		0x00000000
#define   CXD9225GG_MEMC_MBX_CFG_PR_SYSBUSIF1		0x20000000
#define CXD9225GG_MEMC_MIF_CNT_CFG1	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_CNT_CFG1_OFFSET)
#define CXD9225GG_MEMC_MIF_CNT_CFG2	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_CNT_CFG2_OFFSET)
#define CXD9225GG_MEMC_MIF_REQCNT		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_REQCNT_OFFSET)
#define   CXD9225GG_MEMC_MIF_REQCNT_COUNT_MASK		0x7FFFFFFF
#define   CXD9225GG_MEMC_MIF_REQCNT_END_NOT_END		0x00000000
#define   CXD9225GG_MEMC_MIF_REQCNT_END_END		0x80000000
#define CXD9225GG_MEMC_MIF_INT_MASK	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_INT_MASK_OFFSET)
#define   CXD9225GG_MEMC_MIF_INT_MASK_AER_EN_NOT		0x00000000
#define   CXD9225GG_MEMC_MIF_INT_MASK_AER_EN		0x00000002
#define CXD9225GG_MEMC_MIF_AERR		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_AERR_OFFSET)
#define   CXD9225GG_MEMC_MIF_AERR_AER_NO_WRITE		0x00000000
#define   CXD9225GG_MEMC_MIF_AERR_AER_WRITE		0x00000001
#define   CXD9225GG_MEMC_MIF_AERR_AERR_MODE_MASK		0x001F0000
#define   CXD9225GG_MEMC_MIF_AERR_AERR_MODE_SHIFT		(16)
#define CXD9225GG_MEMC_MIF_AERR_CFG	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_AERR_CFG_OFFSET)
#define CXD9225GG_MEMC_MIF_AERR_START	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_AERR_START_OFFSET)
#define   CXD9225GG_MEMC_MIF_AERR_START_MASK		0x7FFFF000
#define CXD9225GG_MEMC_MIF_AERR_END	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_MEMC_MIF_AERR_END_OFFSET)
#define   CXD9225GG_MEMC_MIF_AERR_END_MASK			0x7FFFF000
#define CXD9225GG_DDR2TOP_MIF_RSTB		(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_RSTB_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_RSTB_RST_ACTIVE		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_RSTB_RST_INACTIVE		0x00000001
#define CXD9225GG_DDR2TOP_MIF_ODTSW	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_ODTSW_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_ODT_OFF		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_ODT_75OHM		0x00000001
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_ODT_150OHM		0x00000002
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_ODT_50OHM		0x00000003
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_UACOEN_HIZ		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_UACOEN_OUT		0x00000080
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEN0_UMCLKNORMAL	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEN0_UMCLKREVERSE	0x00000100
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEN1_UMCLKNORMAL	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEN1_UMCLKREVERSE	0x00000200
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEN2_UMCLKNORMAL	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEN2_UMCLKREVERSE	0x00000400
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEN3_UMCLKNORMAL	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEN3_UMCLKREVERSE	0x00000800
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEOEN0_STOP		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEOEN0_OUT		0x00010000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEOEN1_STOP		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEOEN1_OUT		0x00020000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEOEN2_STOP		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEOEN2_OUT		0x00040000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEOEN3_STOP		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKEOEN3_OUT		0x00080000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKOEN0_STOP		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKOEN0_OUT		0x01000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKOEN1_STOP		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKOEN1_OUT		0x02000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKOEN2_STOP		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKOEN2_OUT		0x04000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKOEN3_STOP		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_ODTSW_CKOEN3_OUT		0x08000000
#define CXD9225GG_DDR2TOP_MIF_IOLHRSTB	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_IOLHRSTB_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_IOLHRSTB_IORST_ACTIVE	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHRSTB_IORST_INACTIVE	0x00000001
#define CXD9225GG_DDR2TOP_MIF_IOLHCTRL	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_IOLHCTRL_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_FIX_NOTCMP	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_FIX_COMPLETE	0x00000001
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_STP_RETRY		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_STP_STOP		0x00000100
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_OCT_AUTO		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_OCT_MANUAL	0x00000200
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NC0_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NC0_EN		0x00010000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NC1_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NC1_EN		0x00020000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NC2_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NC2_EN		0x00040000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NC3_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NC3_EN		0x00080000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PC0_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PC0_EN		0x00100000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PC1_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PC1_EN		0x00200000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PC2_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PC2_EN		0x00400000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PC3_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PC3_EN		0x00800000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NCM0_NOMONI	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NCM0_MONITOR	0x01000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NCM1_NOMONI	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NCM1_MONITOR	0x02000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NCM2_NOMONI	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NCM2_MONITOR	0x04000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NCM3_NOMONI	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_NCM3_MONITOR	0x08000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PCM0_NOMONI	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PCM0_MONITOR	0x10000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PCM1_NOMONI	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PCM1_MONITOR	0x20000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PCM2_NOMONI	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PCM2_MONITOR	0x40000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PCM3_NOMONI	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL_PCM3_MONITOR	0x80000000
#define CXD9225GG_DDR2TOP_MIF_DLLSTBY	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_DLLSTBY_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_DLLSTBY_STBY0_INACTIVE	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLSTBY_STBY0_ACTIVE	0x00000001
#define   CXD9225GG_DDR2TOP_MIF_DLLSTBY_STBY1_INACTIVE	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLSTBY_STBY1_ACTIVE	0x00000002
#define CXD9225GG_DDR2TOP_MIF_DLLCTRL	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_DLLCTRL_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_LOCK0_UNLOCK	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_LOCK0_LOCK		0x00000001
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_LOCK1_UNLOCK	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_LOCK1_LOCK		0x00000002
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_WTH_NORMAL		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_WTH_THROUGH	0x00000100
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_RTH_NORMAL		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_RTH_THROUGH	0x00010000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_FSL0_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_FSL0_EN		0x01000000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_FSL1_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_FSL1_EN		0x02000000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_FSL2_DIS		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLCTRL_FSL2_EN		0x04000000
#define CXD9225GG_DDR2TOP_MIF_DLLOFSTW	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW00_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW00_EN	0x00000001
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW01_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW01_EN	0x00000002
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW02_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW02_EN	0x00000004
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW03_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW03_EN	0x00000008
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW04_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW04_EN	0x00000010
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW05_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW05_EN	0x00000020
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW10_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW10_EN	0x00000100
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW11_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW11_EN	0x00000200
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW12_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW12_EN	0x00000400
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW13_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW13_EN	0x00000800
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW14_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW14_EN	0x00001000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW15_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW15_EN	0x00002000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW20_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW20_EN	0x00010000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW21_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW21_EN	0x00020000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW22_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW22_EN	0x00040000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW23_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW23_EN	0x00080000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW24_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW24_EN	0x00100000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW25_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW25_EN	0x00200000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW30_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW30_EN	0x01000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW31_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW31_EN	0x02000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW32_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW32_EN	0x04000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW33_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW33_EN	0x08000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW34_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW34_EN	0x10000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW35_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTW_OFSTW35_EN	0x20000000
#define CXD9225GG_DDR2TOP_MIF_DLLOFSTR	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR00_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR00_EN	0x00000001
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR01_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR01_EN	0x00000002
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR02_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR02_EN	0x00000004
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR03_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR03_EN	0x00000008
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR04_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR04_EN	0x00000010
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR05_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR05_EN	0x00000020
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR10_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR10_EN	0x00000100
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR11_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR11_EN	0x00000200
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR12_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR12_EN	0x00000400
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR13_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR13_EN	0x00000800
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR14_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR14_EN	0x00001000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR15_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR15_EN	0x00002000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR20_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR20_EN	0x00010000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR21_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR21_EN	0x00020000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR22_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR22_EN	0x00040000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR23_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR23_EN	0x00080000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR24_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR24_EN	0x00100000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR25_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR25_EN	0x00200000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR30_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR30_EN	0x01000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR31_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR31_EN	0x02000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR32_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR32_EN	0x04000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR33_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR33_EN	0x08000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR34_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR34_EN	0x10000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR35_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTR_OFSTR35_EN	0x20000000
#define CXD9225GG_DDR2TOP_MIF_IOLHCTRL2	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_IO_91OHM		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_IO_150OHM	0x00000001
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_CK_91OHM		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_CK_150OHM	0x00000100
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_RQ_91OHM		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_RQ_150OHM	0x00001000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_AC_91OHM		0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOLHCTRL2_AC_150OHM	0x00002000
#define CXD9225GG_DDR2TOP_MIF_DLLOFSTM	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM00_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM00_EN	0x00000001
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM01_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM01_EN	0x00000002
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM10_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM10_EN	0x00000010
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM11_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM11_EN	0x00000020
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM20_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM20_EN	0x00000100
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM21_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM21_EN	0x00000200
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM30_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM30_EN	0x00001000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM31_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_DLLOFSTM_OFSTM31_EN	0x00002000
#define CXD9225GG_DDR2TOP_MIF_IOCTRL	(CXD9225GG_DDR2_MEMC_BASE + CXD9225GG_DDR2TOP_MIF_IOCTRL_OFFSET)
#define   CXD9225GG_DDR2TOP_MIF_IOCTRL_ACDLYAD0_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOCTRL_ACDLYAD0_EN		0x00000001
#define   CXD9225GG_DDR2TOP_MIF_IOCTRL_ACDLYAD1_DIS	0x00000000
#define   CXD9225GG_DDR2TOP_MIF_IOCTRL_ACDLYAD1_EN		0x00000002



/* Interrupt Control */
#define CXD9225GG_INTC_IRQS0_OFFSET	0x0000
#define CXD9225GG_INTC_IRQS1_OFFSET	0x0004
#define CXD9225GG_INTC_IRQS2_OFFSET	0x0008
#define CXD9225GG_INTC_IRQS3_OFFSET	0x000C
#define CXD9225GG_INTC_FIQS0_OFFSET	0x0020
#define CXD9225GG_INTC_FIQS1_OFFSET	0x0024
#define CXD9225GG_INTC_FIQS2_OFFSET	0x0028
#define CXD9225GG_INTC_FIQS3_OFFSET	0x002C
#define CXD9225GG_INTC_RAIS0_OFFSET	0x0040
#define CXD9225GG_INTC_RAIS1_OFFSET	0x0044
#define CXD9225GG_INTC_RAIS2_OFFSET	0x0048
#define CXD9225GG_INTC_RAIS3_OFFSET	0x004C
#define CXD9225GG_INTC_ISL0_OFFSET		0x0060
#define CXD9225GG_INTC_ISL1_OFFSET		0x0064
#define CXD9225GG_INTC_ISL2_OFFSET		0x0068
#define CXD9225GG_INTC_ISL3_OFFSET		0x006C
#define CXD9225GG_INTC_IEN0_OFFSET		0x0080
#define CXD9225GG_INTC_IEN1_OFFSET		0x0084
#define CXD9225GG_INTC_IEN2_OFFSET		0x0088
#define CXD9225GG_INTC_IEN3_OFFSET		0x008C
#define CXD9225GG_INTC_IEC0_OFFSET		0x00A0
#define CXD9225GG_INTC_IEC1_OFFSET		0x00A4
#define CXD9225GG_INTC_IEC2_OFFSET		0x00A8
#define CXD9225GG_INTC_IEC3_OFFSET		0x00AC
#define CXD9225GG_INTC_SWI0_OFFSET		0x00C0
#define CXD9225GG_INTC_SWI1_OFFSET		0x00C4
#define CXD9225GG_INTC_SWI2_OFFSET		0x00C8
#define CXD9225GG_INTC_SWI3_OFFSET		0x00CC
#define CXD9225GG_INTC_SWC0_OFFSET		0x00E0
#define CXD9225GG_INTC_SWC1_OFFSET		0x00E4
#define CXD9225GG_INTC_SWC2_OFFSET		0x00E8
#define CXD9225GG_INTC_SWC3_OFFSET		0x00EC
#define CXD9225GG_INTC_PLS0_OFFSET		0x0100
#define CXD9225GG_INTC_PLS1_OFFSET		0x0104
#define CXD9225GG_INTC_PLS2_OFFSET		0x0108
#define CXD9225GG_INTC_PLS3_OFFSET		0x010C
#define CXD9225GG_INTC_PIC0_OFFSET		0x0120
#define CXD9225GG_INTC_PIC1_OFFSET		0x0124
#define CXD9225GG_INTC_PIC2_OFFSET		0x0128
#define CXD9225GG_INTC_PIC3_OFFSET		0x012C
#define CXD9225GG_INTC_EDGC0_OFFSET	0x0140
#define CXD9225GG_INTC_EDGC1_OFFSET	0x0144
#define CXD9225GG_INTC_EDGC2_OFFSET	0x0148
#define CXD9225GG_INTC_EDGC3_OFFSET	0x014C
#define CXD9225GG_INTC_EDGC4_OFFSET	0x0150
#define CXD9225GG_INTC_EDGC5_OFFSET	0x0154
#define CXD9225GG_INTC_EDGC6_OFFSET	0x0158
#define CXD9225GG_INTC_EDGC7_OFFSET	0x015C
#define CXD9225GG_INTC_LVLC0_OFFSET	0x0180
#define CXD9225GG_INTC_LVLC1_OFFSET	0x0184
#define CXD9225GG_INTC_LVLC2_OFFSET	0x0188
#define CXD9225GG_INTC_LVLC3_OFFSET	0x018C
#define CXD9225GG_INTC_LVLC4_OFFSET	0x0190
#define CXD9225GG_INTC_LVLC5_OFFSET	0x0194
#define CXD9225GG_INTC_LVLC6_OFFSET	0x0198
#define CXD9225GG_INTC_LVLC7_OFFSET	0x019C
//#define CXD9225GG_INTC_PRLM_OFFSET		0x01C0
//#define CXD9225GG_INTC_PRLC_OFFSET		0x01C4
//#define CXD9225GG_INTC_UEN_OFFSET		0x01C8
//#define CXD9225GG_INTC_HVA_OFFSET		0x0200
#define CXD9225GG_INTC_ISS0_OFFSET		0x0210
#define CXD9225GG_INTC_ISS1_OFFSET		0x0214
#define CXD9225GG_INTC_ISS2_OFFSET		0x0218
#define CXD9225GG_INTC_ISS3_OFFSET		0x021C
#define CXD9225GG_INTC_ISC0_OFFSET		0x0230
#define CXD9225GG_INTC_ISC1_OFFSET		0x0234
#define CXD9225GG_INTC_ISC2_OFFSET		0x0238
#define CXD9225GG_INTC_ISC3_OFFSET		0x023C
//#define CXD9225GG_INTC_VADX_OFFSET		0x0400
//#define CXD9225GG_INTC_PRLX_OFFSET		0x0800
//#define CXD9225GG_INTC_TCR_OFFSET		0x0C00
//#define CXD9225GG_INTC_TICR_OFFSET		0x0C04
//#define CXD9225GG_INTC_TACR_OFFSET		0x0C08
//#define CXD9225GG_INTC_IOS_OFFSET		0x0C0C
//#define CXD9225GG_INTC_VAOS_OFFSET		0x0C10

#define CXD9225GG_INTC_IRQS0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IRQS0_OFFSET)
#define CXD9225GG_INTC_IRQS1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IRQS1_OFFSET)
#define CXD9225GG_INTC_IRQS2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IRQS2_OFFSET)
#define CXD9225GG_INTC_IRQS3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IRQS3_OFFSET)
#define CXD9225GG_INTC_FIQS0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_FIQS0_OFFSET)
#define CXD9225GG_INTC_FIQS1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_FIQS1_OFFSET)
#define CXD9225GG_INTC_FIQS2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_FIQS2_OFFSET)
#define CXD9225GG_INTC_FIQS3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_FIQS3_OFFSET)
#define CXD9225GG_INTC_RAIS0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_RAIS0_OFFSET)
#define CXD9225GG_INTC_RAIS1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_RAIS1_OFFSET)
#define CXD9225GG_INTC_RAIS2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_RAIS2_OFFSET)
#define CXD9225GG_INTC_RAIS3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_RAIS3_OFFSET)
#define CXD9225GG_INTC_ISL0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISL0_OFFSET)
#define CXD9225GG_INTC_ISL1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISL1_OFFSET)
#define CXD9225GG_INTC_ISL2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISL2_OFFSET)
#define CXD9225GG_INTC_ISL3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISL3_OFFSET)
#define   CXD9225GG_INTC_ISL_ALLIRQ	0x00000000
#define   CXD9225GG_INTC_ISL_ALLFIQ	0xFFFFFFFF
#define CXD9225GG_INTC_IEN0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IEN0_OFFSET)
#define CXD9225GG_INTC_IEN1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IEN1_OFFSET)
#define CXD9225GG_INTC_IEN2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IEN2_OFFSET)
#define CXD9225GG_INTC_IEN3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IEN3_OFFSET)
#define CXD9225GG_INTC_IEC0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IEC0_OFFSET)
#define CXD9225GG_INTC_IEC1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IEC1_OFFSET)
#define CXD9225GG_INTC_IEC2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IEC2_OFFSET)
#define CXD9225GG_INTC_IEC3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IEC3_OFFSET)
#define   CXD9225GG_INTC_IEC_ALLCLR	0xFFFFFFFF
#define CXD9225GG_INTC_SWI0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_SWI0_OFFSET)
#define CXD9225GG_INTC_SWI1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_SWI1_OFFSET)
#define CXD9225GG_INTC_SWI2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_SWI2_OFFSET)
#define CXD9225GG_INTC_SWI3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_SWI3_OFFSET)
#define CXD9225GG_INTC_SWC0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_SWC0_OFFSET)
#define CXD9225GG_INTC_SWC1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_SWC1_OFFSET)
#define CXD9225GG_INTC_SWC2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_SWC2_OFFSET)
#define CXD9225GG_INTC_SWC3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_SWC3_OFFSET)
#define CXD9225GG_INTC_PLS0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PLS0_OFFSET)
#define CXD9225GG_INTC_PLS1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PLS1_OFFSET)
#define CXD9225GG_INTC_PLS2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PLS2_OFFSET)
#define CXD9225GG_INTC_PLS3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PLS3_OFFSET)
#define   CXD9225GG_INTC_PLS_ALLLVL	0x00000000
#define   CXD9225GG_INTC_PLS_ALLEDG	0xFFFFFFFF
#define   CXD9225GG_INTC_PLS_LEVEL		0x00000000
#define   CXD9225GG_INTC_PLS_EDGE		0x00000001
#define CXD9225GG_INTC_PIC0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PIC0_OFFSET)
#define CXD9225GG_INTC_PIC1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PIC1_OFFSET)
#define CXD9225GG_INTC_PIC2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PIC2_OFFSET)
#define CXD9225GG_INTC_PIC3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PIC3_OFFSET)
#define CXD9225GG_INTC_EDGC0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_EDGC0_OFFSET)
#define CXD9225GG_INTC_EDGC1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_EDGC1_OFFSET)
#define CXD9225GG_INTC_EDGC2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_EDGC2_OFFSET)
#define CXD9225GG_INTC_EDGC3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_EDGC3_OFFSET)
#define CXD9225GG_INTC_EDGC4	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_EDGC4_OFFSET)
#define CXD9225GG_INTC_EDGC5	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_EDGC5_OFFSET)
#define CXD9225GG_INTC_EDGC6	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_EDGC6_OFFSET)
#define CXD9225GG_INTC_EDGC7	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_EDGC7_OFFSET)
#define   CXD9225GG_INTC_EDGC_MASK		0x00000003
#define   CXD9225GG_INTC_EDGC_RISING	0x00000001
#define   CXD9225GG_INTC_EDGC_FALLING	0x00000002
#define   CXD9225GG_INTC_EDGC_BOTH		0x00000003
#define CXD9225GG_INTC_LVLC0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_LVLC0_OFFSET)
#define CXD9225GG_INTC_LVLC1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_LVLC1_OFFSET)
#define CXD9225GG_INTC_LVLC2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_LVLC2_OFFSET)
#define CXD9225GG_INTC_LVLC3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_LVLC3_OFFSET)
#define CXD9225GG_INTC_LVLC4	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_LVLC4_OFFSET)
#define CXD9225GG_INTC_LVLC5	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_LVLC5_OFFSET)
#define CXD9225GG_INTC_LVLC6	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_LVLC6_OFFSET)
#define CXD9225GG_INTC_LVLC7	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_LVLC7_OFFSET)
#define   CXD9225GG_INTC_LVLC_MASK		0x00000003
#define   CXD9225GG_INTC_LVLC_HIGH		0x00000001
#define   CXD9225GG_INTC_LVLC_LOW		0x00000002
#define   CXD9225GG_INTC_LVLC_ALLHI	0x55555555
#define   CXD9225GG_INTC_LVLC_ALLLO	0xAAAAAAAA
#define CXD9225GG_INTC_PRLM	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PRLM_OFFSET)
#define   CXD9225GG_INTC_PRLM_ALLMASK	0x0000FFFF
#define CXD9225GG_INTC_PRLC	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PRLC_OFFSET)
#define   CXD9225GG_INTC_PRLC_ALLCLR	0x0000FFFF
#define CXD9225GG_INTC_UEN		(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_UEN_OFFSET)
#define   CXD9225GG_INTC_UEN_UE_DIS	0x00000000
#define   CXD9225GG_INTC_UEN_UE_EN		0x00000001
#define CXD9225GG_INTC_HVA		(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_HVA_OFFSET)
#define CXD9225GG_INTC_ISS0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISS0_OFFSET)
#define CXD9225GG_INTC_ISS1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISS1_OFFSET)
#define CXD9225GG_INTC_ISS2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISS2_OFFSET)
#define CXD9225GG_INTC_ISS3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISS3_OFFSET)
#define CXD9225GG_INTC_ISC0	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISC0_OFFSET)
#define   CXD9225GG_INTC_ISC0_APBTIMER_MASK	0xFC000000
#define CXD9225GG_INTC_ISC1	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISC1_OFFSET)
#define CXD9225GG_INTC_ISC2	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISC2_OFFSET)
#define CXD9225GG_INTC_ISC3	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_ISC3_OFFSET)
#define CXD9225GG_INTC_VADX	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_VADX_OFFSET)
#define CXD9225GG_INTC_PRLX	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_PRLX_OFFSET)
#define CXD9225GG_INTC_TCR		(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_TCR_OFFSET)
#define   CXD9225GG_INTC_TCR_ITEN_NORMAL	0x00000000
#define   CXD9225GG_INTC_TCR_ITEN_TEST	0x00000001
#define CXD9225GG_INTC_TICR	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_TICR_OFFSET)
#define   CXD9225GG_INTC_TICR_F		0x00000040
#define   CXD9225GG_INTC_TICR_I		0x00000080
#define CXD9225GG_INTC_TACR	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_TACR_OFFSET)
#define CXD9225GG_INTC_IOS		(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_IOS_OFFSET)
#define   CXD9225GG_INTC_IOS_F		0x00000040
#define   CXD9225GG_INTC_IOS_I		0x00000080
#define CXD9225GG_INTC_VAOS	(CXD9225GG_CPU0_INTC_BASE + CXD9225GG_INTC_VAOS_OFFSET)

#define CXD9225GG_INTC1_IRQS0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IRQS0_OFFSET)
#define CXD9225GG_INTC1_IRQS1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IRQS1_OFFSET)
#define CXD9225GG_INTC1_IRQS2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IRQS2_OFFSET)
#define CXD9225GG_INTC1_IRQS3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IRQS3_OFFSET)
#define CXD9225GG_INTC1_FIQS0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_FIQS0_OFFSET)
#define CXD9225GG_INTC1_FIQS1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_FIQS1_OFFSET)
#define CXD9225GG_INTC1_FIQS2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_FIQS2_OFFSET)
#define CXD9225GG_INTC1_FIQS3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_FIQS3_OFFSET)
#define CXD9225GG_INTC1_RAIS0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_RAIS0_OFFSET)
#define CXD9225GG_INTC1_RAIS1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_RAIS1_OFFSET)
#define CXD9225GG_INTC1_RAIS2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_RAIS2_OFFSET)
#define CXD9225GG_INTC1_RAIS3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_RAIS3_OFFSET)
#define CXD9225GG_INTC1_ISL0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISL0_OFFSET)
#define CXD9225GG_INTC1_ISL1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISL1_OFFSET)
#define CXD9225GG_INTC1_ISL2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISL2_OFFSET)
#define CXD9225GG_INTC1_ISL3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISL3_OFFSET)
#define CXD9225GG_INTC1_IEN0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IEN0_OFFSET)
#define CXD9225GG_INTC1_IEN1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IEN1_OFFSET)
#define CXD9225GG_INTC1_IEN2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IEN2_OFFSET)
#define CXD9225GG_INTC1_IEN3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IEN3_OFFSET)
#define CXD9225GG_INTC1_IEC0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IEC0_OFFSET)
#define CXD9225GG_INTC1_IEC1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IEC1_OFFSET)
#define CXD9225GG_INTC1_IEC2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IEC2_OFFSET)
#define CXD9225GG_INTC1_IEC3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IEC3_OFFSET)
#define CXD9225GG_INTC1_SWI0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_SWI0_OFFSET)
#define CXD9225GG_INTC1_SWI1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_SWI1_OFFSET)
#define CXD9225GG_INTC1_SWI2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_SWI2_OFFSET)
#define CXD9225GG_INTC1_SWI3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_SWI3_OFFSET)
#define CXD9225GG_INTC1_SWC0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_SWC0_OFFSET)
#define CXD9225GG_INTC1_SWC1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_SWC1_OFFSET)
#define CXD9225GG_INTC1_SWC2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_SWC2_OFFSET)
#define CXD9225GG_INTC1_SWC3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_SWC3_OFFSET)
#define CXD9225GG_INTC1_PLS0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PLS0_OFFSET)
#define CXD9225GG_INTC1_PLS1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PLS1_OFFSET)
#define CXD9225GG_INTC1_PLS2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PLS2_OFFSET)
#define CXD9225GG_INTC1_PLS3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PLS3_OFFSET)
#define CXD9225GG_INTC1_PIC0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PIC0_OFFSET)
#define CXD9225GG_INTC1_PIC1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PIC1_OFFSET)
#define CXD9225GG_INTC1_PIC2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PIC2_OFFSET)
#define CXD9225GG_INTC1_PIC3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PIC3_OFFSET)
#define CXD9225GG_INTC1_EDGC0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_EDGC0_OFFSET)
#define CXD9225GG_INTC1_EDGC1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_EDGC1_OFFSET)
#define CXD9225GG_INTC1_EDGC2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_EDGC2_OFFSET)
#define CXD9225GG_INTC1_EDGC3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_EDGC3_OFFSET)
#define CXD9225GG_INTC1_EDGC4	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_EDGC4_OFFSET)
#define CXD9225GG_INTC1_EDGC5	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_EDGC5_OFFSET)
#define CXD9225GG_INTC1_EDGC6	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_EDGC6_OFFSET)
#define CXD9225GG_INTC1_EDGC7	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_EDGC7_OFFSET)
#define CXD9225GG_INTC1_LVLC0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_LVLC0_OFFSET)
#define CXD9225GG_INTC1_LVLC1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_LVLC1_OFFSET)
#define CXD9225GG_INTC1_LVLC2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_LVLC2_OFFSET)
#define CXD9225GG_INTC1_LVLC3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_LVLC3_OFFSET)
#define CXD9225GG_INTC1_LVLC4	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_LVLC4_OFFSET)
#define CXD9225GG_INTC1_LVLC5	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_LVLC5_OFFSET)
#define CXD9225GG_INTC1_LVLC6	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_LVLC6_OFFSET)
#define CXD9225GG_INTC1_LVLC7	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_LVLC7_OFFSET)
#define CXD9225GG_INTC1_PRLM	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PRLM_OFFSET)
#define CXD9225GG_INTC1_PRLC	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PRLC_OFFSET)
#define CXD9225GG_INTC1_UEN	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_UEN_OFFSET)
#define CXD9225GG_INTC1_HVA	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_HVA_OFFSET)
#define CXD9225GG_INTC1_ISS0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISS0_OFFSET)
#define CXD9225GG_INTC1_ISS1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISS1_OFFSET)
#define CXD9225GG_INTC1_ISS2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISS2_OFFSET)
#define CXD9225GG_INTC1_ISS3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISS3_OFFSET)
#define CXD9225GG_INTC1_ISC0	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISC0_OFFSET)
#define CXD9225GG_INTC1_ISC1	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISC1_OFFSET)
#define CXD9225GG_INTC1_ISC2	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISC2_OFFSET)
#define CXD9225GG_INTC1_ISC3	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_ISC3_OFFSET)
#define CXD9225GG_INTC1_VADX	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_VADX_OFFSET)
#define CXD9225GG_INTC1_PRLX	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_PRLX_OFFSET)
#define CXD9225GG_INTC1_TCR	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_TCR_OFFSET)
#define CXD9225GG_INTC1_TICR	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_TICR_OFFSET)
#define CXD9225GG_INTC1_TACR	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_TACR_OFFSET)
#define CXD9225GG_INTC1_IOS	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_IOS_OFFSET)
#define CXD9225GG_INTC1_VAOS	(CXD9225GG_CPU1_INTC_BASE + CXD9225GG_INTC_VAOS_OFFSET)

/* Number of interrupt levels */
#define CXD9225GG_INT_NUM_SOURCES	(128)



/* APB Clock Control */
#define CXD9225GG_APB_CLKC_ACC_OFFSET	0x0200

#define CXD9225GG_APB_CLKC_ACC	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CLKC_ACC_OFFSET)
#define   CXD9225GG_APB_CLKC_ACC_APBREG_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_APBREG_CC_RUN	0x00000001
#define   CXD9225GG_APB_CLKC_ACC_CTM0_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CTM0_CC_RUN	0x00000002
#define   CXD9225GG_APB_CLKC_ACC_CTM1_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CTM1_CC_RUN	0x00000004
#define   CXD9225GG_APB_CLKC_ACC_CTM2_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CTM2_CC_RUN	0x00000008
#define   CXD9225GG_APB_CLKC_ACC_CTM3_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CTM3_CC_RUN	0x00000010
#define   CXD9225GG_APB_CLKC_ACC_CTM4_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CTM4_CC_RUN	0x00000020
#define   CXD9225GG_APB_CLKC_ACC_CTM5_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CTM5_CC_RUN	0x00000040
#define   CXD9225GG_APB_CLKC_ACC_CTM6_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CTM6_CC_RUN	0x00000080
#define   CXD9225GG_APB_CLKC_ACC_CTM7_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CTM7_CC_RUN	0x00000100
#define   CXD9225GG_APB_CLKC_ACC_CTM8_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CTM8_CC_RUN	0x00000200
#define   CXD9225GG_APB_CLKC_ACC_PWM0_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_PWM0_CC_RUN	0x00000400
#define   CXD9225GG_APB_CLKC_ACC_PWM1_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_PWM1_CC_RUN	0x00000800
#define   CXD9225GG_APB_CLKC_ACC_PWM2_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_PWM2_CC_RUN	0x00001000
#define   CXD9225GG_APB_CLKC_ACC_PWM3_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_PWM3_CC_RUN	0x00002000
#define   CXD9225GG_APB_CLKC_ACC_WDT_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_WDT_CC_RUN	0x00004000
#define   CXD9225GG_APB_CLKC_ACC_RTC_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_RTC_CC_RUN	0x00008000
#define   CXD9225GG_APB_CLKC_ACC_CSI0_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CSI0_CC_RUN	0x00010000
#define   CXD9225GG_APB_CLKC_ACC_CSI1_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CSI1_CC_RUN	0x00020000
#define   CXD9225GG_APB_CLKC_ACC_CSI2_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CSI2_CC_RUN	0x00040000
#define   CXD9225GG_APB_CLKC_ACC_CSI3_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_CSI3_CC_RUN	0x00080000
#define   CXD9225GG_APB_CLKC_ACC_UART0_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_UART0_CC_RUN	0x00100000
#define   CXD9225GG_APB_CLKC_ACC_UART1_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_UART1_CC_RUN	0x00200000
#define   CXD9225GG_APB_CLKC_ACC_UART2_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_UART2_CC_RUN	0x00400000
#define   CXD9225GG_APB_CLKC_ACC_UART3_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_UART3_CC_RUN	0x00800000
#define   CXD9225GG_APB_CLKC_ACC_IIC0_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_IIC0_CC_RUN	0x01000000
#define   CXD9225GG_APB_CLKC_ACC_IIC1_CC_STOP	0x00000000
#define   CXD9225GG_APB_CLKC_ACC_IIC1_CC_RUN	0x02000000



/* APB Reset Control */
#define CXD9225GG_APB_RESETC_ASR_OFFSET	0x0210

#define CXD9225GG_APB_RESETC_ASR	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_RESETC_ASR_OFFSET)
#define   CXD9225GG_APB_RESETC_ASR_APBREG_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_APBREG_SR_RUN	0x00000001
#define   CXD9225GG_APB_RESETC_ASR_CTM0_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CTM0_SR_RUN	0x00000002
#define   CXD9225GG_APB_RESETC_ASR_CTM1_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CTM1_SR_RUN	0x00000004
#define   CXD9225GG_APB_RESETC_ASR_CTM2_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CTM2_SR_RUN	0x00000008
#define   CXD9225GG_APB_RESETC_ASR_CTM3_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CTM3_SR_RUN	0x00000010
#define   CXD9225GG_APB_RESETC_ASR_CTM4_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CTM4_SR_RUN	0x00000020
#define   CXD9225GG_APB_RESETC_ASR_CTM5_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CTM5_SR_RUN	0x00000040
#define   CXD9225GG_APB_RESETC_ASR_CTM6_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CTM6_SR_RUN	0x00000080
#define   CXD9225GG_APB_RESETC_ASR_CTM7_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CTM7_SR_RUN	0x00000100
#define   CXD9225GG_APB_RESETC_ASR_CTM8_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CTM8_SR_RUN	0x00000200
#define   CXD9225GG_APB_RESETC_ASR_PWM0_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_PWM0_SR_RUN	0x00000400
#define   CXD9225GG_APB_RESETC_ASR_PWM1_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_PWM1_SR_RUN	0x00000800
#define   CXD9225GG_APB_RESETC_ASR_PWM2_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_PWM2_SR_RUN	0x00001000
#define   CXD9225GG_APB_RESETC_ASR_PWM3_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_PWM3_SR_RUN	0x00002000
#define   CXD9225GG_APB_RESETC_ASR_WDT_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_WDT_SR_RUN	0x00004000
#define   CXD9225GG_APB_RESETC_ASR_RTC_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_RTC_SR_RUN	0x00008000
#define   CXD9225GG_APB_RESETC_ASR_CSI0_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CSI0_SR_RUN	0x00010000
#define   CXD9225GG_APB_RESETC_ASR_CSI1_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CSI1_SR_RUN	0x00020000
#define   CXD9225GG_APB_RESETC_ASR_CSI2_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CSI2_SR_RUN	0x00040000
#define   CXD9225GG_APB_RESETC_ASR_CSI3_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CSI3_SR_RUN	0x00080000
#define   CXD9225GG_APB_RESETC_ASR_UART0_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_UART0_SR_RUN	0x00100000
#define   CXD9225GG_APB_RESETC_ASR_UART1_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_UART1_SR_RUN	0x00200000
#define   CXD9225GG_APB_RESETC_ASR_UART2_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_UART2_SR_RUN	0x00400000
#define   CXD9225GG_APB_RESETC_ASR_UART3_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_UART3_SR_RUN	0x00800000
#define   CXD9225GG_APB_RESETC_ASR_IIC0_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_IIC0_SR_RUN	0x01000000
#define   CXD9225GG_APB_RESETC_ASR_IIC1_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_IIC1_SR_RUN	0x02000000
#define   CXD9225GG_APB_RESETC_ASR_CC_SR_RESET	0x00000000
#define   CXD9225GG_APB_RESETC_ASR_CC_SR_RUN	0x04000000



/* APB Register */
#define CXD9225GG_APB_REG_APBREG0_OFFSE	0x0240
#define CXD9225GG_APB_REG_APBREG1_OFFSET	0x0244
#define CXD9225GG_APB_REG_APBREG2_OFFSET	0x0248
#define CXD9225GG_APB_REG_APBREG3_OFFSET	0x024C
#define CXD9225GG_APB_REG_APBREG4_OFFSET	0x0250
#define CXD9225GG_APB_REG_APBREG5_OFFSET	0x0254
#define CXD9225GG_APB_REG_APBREG6_OFFSET	0x0258
#define CXD9225GG_APB_REG_APBREG7_OFFSET	0x025C
#define CXD9225GG_APB_REG_APBREG8_OFFSET	0x0260
#define CXD9225GG_APB_REG_APBREG9_OFFSET	0x0264
#define CXD9225GG_APB_REG_APBREG10_OFFSET	0x0268
#define CXD9225GG_APB_REG_APBREG11_OFFSET	0x026C
#define CXD9225GG_APB_REG_APBREG12_OFFSET	0x0270
#define CXD9225GG_APB_REG_APBREG13_OFFSET	0x0274
#define CXD9225GG_APB_REG_APBREG14_OFFSET	0x0278
#define CXD9225GG_APB_REG_APBREG15_OFFSET	0x027C

#define CXD9225GG_APB_REG_APBREG0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG0_OFFSET)
#define CXD9225GG_APB_REG_APBREG1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG1_OFFSET)
#define CXD9225GG_APB_REG_APBREG2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG2_OFFSET)
#define CXD9225GG_APB_REG_APBREG3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG3_OFFSET)
#define CXD9225GG_APB_REG_APBREG4	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG4_OFFSET)
#define CXD9225GG_APB_REG_APBREG5	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG5_OFFSET)
#define CXD9225GG_APB_REG_APBREG6	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG6_OFFSET)
#define CXD9225GG_APB_REG_APBREG7	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG7_OFFSET)
#define CXD9225GG_APB_REG_APBREG8	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG8_OFFSET)
#define CXD9225GG_APB_REG_APBREG9	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG9_OFFSET)
#define CXD9225GG_APB_REG_APBREG10	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG10_OFFSET)
#define CXD9225GG_APB_REG_APBREG11	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG11_OFFSET)
#define CXD9225GG_APB_REG_APBREG12	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG12_OFFSET)
#define CXD9225GG_APB_REG_APBREG13	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG13_OFFSET)
#define CXD9225GG_APB_REG_APBREG14	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG14_OFFSET)
#define CXD9225GG_APB_REG_APBREG15	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_REG_APBREG15_OFFSET)



/* APB Compare Timer */
#define CXD9225GG_APB_TIMER_TMD0_OFFSET	0x1000
#define CXD9225GG_APB_TIMER_TMD1_OFFSET	0x1010
#define CXD9225GG_APB_TIMER_TMD2_OFFSET	0x1020
#define CXD9225GG_APB_TIMER_TMD3_OFFSET	0x1030
#define CXD9225GG_APB_TIMER_TMD4_OFFSET	0x1040
#define CXD9225GG_APB_TIMER_TMD5_OFFSET	0x1050
#define CXD9225GG_APB_TIMER_TMD6_OFFSET	0x1060
#define CXD9225GG_APB_TIMER_TMD7_OFFSET	0x1070
#define CXD9225GG_APB_TIMER_TMD8_OFFSET	0x1080
#define CXD9225GG_APB_TIMER_CMD0_OFFSET	0x1004
#define CXD9225GG_APB_TIMER_CMD1_OFFSET	0x1014
#define CXD9225GG_APB_TIMER_CMD2_OFFSET	0x1024
#define CXD9225GG_APB_TIMER_CMD3_OFFSET	0x1034
#define CXD9225GG_APB_TIMER_CMD4_OFFSET	0x1044
#define CXD9225GG_APB_TIMER_CMD5_OFFSET	0x1054
#define CXD9225GG_APB_TIMER_CMD6_OFFSET	0x1064
#define CXD9225GG_APB_TIMER_CMD7_OFFSET	0x1074
#define CXD9225GG_APB_TIMER_CMD8_OFFSET	0x1084
#define CXD9225GG_APB_TIMER_TMCD0_OFFSET	0x1008
#define CXD9225GG_APB_TIMER_TMCD1_OFFSET	0x1018
#define CXD9225GG_APB_TIMER_TMCD2_OFFSET	0x1028
#define CXD9225GG_APB_TIMER_TMCD3_OFFSET	0x1038
#define CXD9225GG_APB_TIMER_TMCD4_OFFSET	0x1048
#define CXD9225GG_APB_TIMER_TMCD5_OFFSET	0x1058
#define CXD9225GG_APB_TIMER_TMCD6_OFFSET	0x1068
#define CXD9225GG_APB_TIMER_TMCD7_OFFSET	0x1078
#define CXD9225GG_APB_TIMER_TMCD8_OFFSET	0x1088

#define CXD9225GG_APB_TIMER_TMD0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMD0_OFFSET)
#define CXD9225GG_APB_TIMER_TMD1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMD1_OFFSET)
#define CXD9225GG_APB_TIMER_TMD2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMD2_OFFSET)
#define CXD9225GG_APB_TIMER_TMD3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMD3_OFFSET)
#define CXD9225GG_APB_TIMER_TMD4	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMD4_OFFSET)
#define CXD9225GG_APB_TIMER_TMD5	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMD5_OFFSET)
#define CXD9225GG_APB_TIMER_TMD6	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMD6_OFFSET)
#define CXD9225GG_APB_TIMER_TMD7	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMD7_OFFSET)
#define CXD9225GG_APB_TIMER_TMD8	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMD8_OFFSET)
#define CXD9225GG_APB_TIMER_CMD0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_CMD0_OFFSET)
#define CXD9225GG_APB_TIMER_CMD1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_CMD1_OFFSET)
#define CXD9225GG_APB_TIMER_CMD2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_CMD2_OFFSET)
#define CXD9225GG_APB_TIMER_CMD3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_CMD3_OFFSET)
#define CXD9225GG_APB_TIMER_CMD4	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_CMD4_OFFSET)
#define CXD9225GG_APB_TIMER_CMD5	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_CMD5_OFFSET)
#define CXD9225GG_APB_TIMER_CMD6	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_CMD6_OFFSET)
#define CXD9225GG_APB_TIMER_CMD7	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_CMD7_OFFSET)
#define CXD9225GG_APB_TIMER_CMD8	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_CMD8_OFFSET)
#define CXD9225GG_APB_TIMER_TMCD0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMCD0_OFFSET)
#define CXD9225GG_APB_TIMER_TMCD1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMCD1_OFFSET)
#define CXD9225GG_APB_TIMER_TMCD2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMCD2_OFFSET)
#define CXD9225GG_APB_TIMER_TMCD3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMCD3_OFFSET)
#define CXD9225GG_APB_TIMER_TMCD4	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMCD4_OFFSET)
#define CXD9225GG_APB_TIMER_TMCD5	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMCD5_OFFSET)
#define CXD9225GG_APB_TIMER_TMCD6	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMCD6_OFFSET)
#define CXD9225GG_APB_TIMER_TMCD7	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMCD7_OFFSET)
#define CXD9225GG_APB_TIMER_TMCD8	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_TIMER_TMCD8_OFFSET)
#define   CXD9225GG_APB_TIMER_TMCDX_CAE_CLKDIS	0x00000000
#define   CXD9225GG_APB_TIMER_TMCDX_CAE_CLKEN	0x00000001
#define   CXD9225GG_APB_TIMER_TMCDX_CE_CNTDIS	0x00000000
#define   CXD9225GG_APB_TIMER_TMCDX_CE_CNTEN	0x00000002
#define   CXD9225GG_APB_TIMER_TMCDX_CS_DIV2	0x00000000
#define   CXD9225GG_APB_TIMER_TMCDX_CS_DIV4	0x00000010
#define   CXD9225GG_APB_TIMER_TMCDX_CS_DIV8	0x00000020
#define   CXD9225GG_APB_TIMER_TMCDX_CS_DIV16	0x00000030
#define   CXD9225GG_APB_TIMER_TMCDX_CS_DIV32	0x00000040
#define   CXD9225GG_APB_TIMER_TMCDX_CS_DIV64	0x00000050
#define   CXD9225GG_APB_TIMER_TMCDX_CS_DIV128	0x00000060
#define   CXD9225GG_APB_TIMER_TMCDX_CS_DIV256	0x00000070
#define   CXD9225GG_APB_TIMER_TMCDX_TEST_NORMAL	0x00000000
#define   CXD9225GG_APB_TIMER_TMCDX_TEST_TEST	0x00000080



/* APB PWM */
#define CXD9225GG_APB_PWM_PWMCTR0_OFFSET		0x1200
#define CXD9225GG_APB_PWM_PWMCTR1_OFFSET		0x1240
#define CXD9225GG_APB_PWM_PWMCTR2_OFFSET		0x1280
#define CXD9225GG_APB_PWM_PWMCTR3_OFFSET		0x12C0
#define CXD9225GG_APB_PWM_PWMCYC0_OFFSET		0x1204
#define CXD9225GG_APB_PWM_PWMCYC1_OFFSET		0x1244
#define CXD9225GG_APB_PWM_PWMCYC2_OFFSET		0x1284
#define CXD9225GG_APB_PWM_PWMCYC3_OFFSET		0x12C4
#define CXD9225GG_APB_PWM_PWMLOW0_OFFSET		0x1208
#define CXD9225GG_APB_PWM_PWMLOW1_OFFSET		0x1248
#define CXD9225GG_APB_PWM_PWMLOW2_OFFSET		0x1288
#define CXD9225GG_APB_PWM_PWMLOW3_OFFSET		0x12C8
#define CXD9225GG_APB_PWM_PWMCNT0_OFFSET		0x120C
#define CXD9225GG_APB_PWM_PWMCNT1_OFFSET		0x124C
#define CXD9225GG_APB_PWM_PWMCNT2_OFFSET		0x128C
#define CXD9225GG_APB_PWM_PWMCNT3_OFFSET		0x12CC
#define CXD9225GG_APB_PWM_PWMIEN0_OFFSET		0x1210
#define CXD9225GG_APB_PWM_PWMIEN1_OFFSET		0x1250
#define CXD9225GG_APB_PWM_PWMIEN2_OFFSET		0x1290
#define CXD9225GG_APB_PWM_PWMIEN3_OFFSET		0x12D0
#define CXD9225GG_APB_PWM_PWMINT0_OFFSET		0x1214
#define CXD9225GG_APB_PWM_PWMINT1_OFFSET		0x1254
#define CXD9225GG_APB_PWM_PWMINT2_OFFSET		0x1294
#define CXD9225GG_APB_PWM_PWMINT3_OFFSET		0x12D4

#define CXD9225GG_APB_PWM_PWMCTR0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCTR0_OFFSET)
#define CXD9225GG_APB_PWM_PWMCTR1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCTR1_OFFSET)
#define CXD9225GG_APB_PWM_PWMCTR2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCTR2_OFFSET)
#define CXD9225GG_APB_PWM_PWMCTR3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCTR3_OFFSET)
#define   CXD9225GG_APB_PWM_PWMCTRX_PWMS		0x00000001
#define   CXD9225GG_APB_PWM_PWMCTRX_PWME_DIS	0x00000000
#define   CXD9225GG_APB_PWM_PWMCTRX_PWME_EN	0x00000002
#define   CXD9225GG_APB_PWM_PWMCTRX_PWMTM_NORMAL	0x00000000
#define   CXD9225GG_APB_PWM_PWMCTRX_PWMTM_TEST	0x00000004
#define CXD9225GG_APB_PWM_PWMCYC0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCYC0_OFFSET)
#define CXD9225GG_APB_PWM_PWMCYC1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCYC1_OFFSET)
#define CXD9225GG_APB_PWM_PWMCYC2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCYC2_OFFSET)
#define CXD9225GG_APB_PWM_PWMCYC3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCYC3_OFFSET)
#define   CXD9225GG_APB_PWM_PWMCYCX_6HZ		0x00EE5029
#define   CXD9225GG_APB_PWM_PWMCYCX_100HZ		0x000F423F
#define   CXD9225GG_APB_PWM_PWMCYCX_1KHZ		0x0001869F
#define   CXD9225GG_APB_PWM_PWMCYCX_10KHZ		0x0000270F
#define   CXD9225GG_APB_PWM_PWMCYCX_100KHZ		0x000003E7
#define   CXD9225GG_APB_PWM_PWMCYCX_10MHZ		0x00000009
#define   CXD9225GG_APB_PWM_PWMCYCX_50MHZ		0x00000001
#define CXD9225GG_APB_PWM_PWMLOW0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMLOW0_OFFSET)
#define CXD9225GG_APB_PWM_PWMLOW1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMLOW1_OFFSET)
#define CXD9225GG_APB_PWM_PWMLOW2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMLOW2_OFFSET)
#define CXD9225GG_APB_PWM_PWMLOW3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMLOW3_OFFSET)
#define   CXD9225GG_APB_PWM_PWMLOW_MASK		0x00FFFFFF
#define CXD9225GG_APB_PWM_PWMCNT0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCNT0_OFFSET)
#define CXD9225GG_APB_PWM_PWMCNT1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCNT1_OFFSET)
#define CXD9225GG_APB_PWM_PWMCNT2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCNT2_OFFSET)
#define CXD9225GG_APB_PWM_PWMCNT3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMCNT3_OFFSET)
#define   CXD9225GG_APB_PWM_PWMCNT_MASK		0x00FFFFFF
#define CXD9225GG_APB_PWM_PWMIEN0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMIEN0_OFFSET)
#define CXD9225GG_APB_PWM_PWMIEN1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMIEN1_OFFSET)
#define CXD9225GG_APB_PWM_PWMIEN2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMIEN2_OFFSET)
#define CXD9225GG_APB_PWM_PWMIEN3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMIEN3_OFFSET)
#define   CXD9225GG_APB_PWM_PWMIENX_PWMEC_DIS	0x00000000
#define   CXD9225GG_APB_PWM_PWMIENX_PWMEC_EN	0x00000001
#define   CXD9225GG_APB_PWM_PWMIENX_PWMEF_DIS	0x00000000
#define   CXD9225GG_APB_PWM_PWMIENX_PWMEF_EN	0x00000002
#define   CXD9225GG_APB_PWM_PWMIENX_PWMER_DIS	0x00000000
#define   CXD9225GG_APB_PWM_PWMIENX_PWMER_EN	0x00000004
#define CXD9225GG_APB_PWM_PWMINT0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMINT0_OFFSET)
#define CXD9225GG_APB_PWM_PWMINT1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMINT1_OFFSET)
#define CXD9225GG_APB_PWM_PWMINT2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMINT2_OFFSET)
#define CXD9225GG_APB_PWM_PWMINT3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_PWM_PWMINT3_OFFSET)
#define   CXD9225GG_APB_PWM_PWMINTX_PWMIC		0x00000001
#define   CXD9225GG_APB_PWM_PWMINTX_PWMIF		0x00000002
#define   CXD9225GG_APB_PWM_PWMINTX_PWMIR		0x00000004



/* APB CSI */
#define CXD9225GG_APB_CSI_MODE0_OFFSET		0x4000
#define CXD9225GG_APB_CSI_MODE1_OFFSET		0x4040
#define CXD9225GG_APB_CSI_MODE2_OFFSET		0x4080
#define CXD9225GG_APB_CSI_MODE3_OFFSET		0x40C0
#define CXD9225GG_APB_CSI_CLKSEL0_OFFSET		0x4004
#define CXD9225GG_APB_CSI_CLKSEL1_OFFSET		0x4044
#define CXD9225GG_APB_CSI_CLKSEL2_OFFSET		0x4084
#define CXD9225GG_APB_CSI_CLKSEL3_OFFSET		0x40C4
#define CXD9225GG_APB_CSI_CNT0_OFFSET		0x4008
#define CXD9225GG_APB_CSI_CNT1_OFFSET		0x4048
#define CXD9225GG_APB_CSI_CNT2_OFFSET		0x4088
#define CXD9225GG_APB_CSI_CNT3_OFFSET		0x40C8
#define CXD9225GG_APB_CSI_INT0_OFFSET		0x400C
#define CXD9225GG_APB_CSI_INT1_OFFSET		0x404C
#define CXD9225GG_APB_CSI_INT2_OFFSET		0x408C
#define CXD9225GG_APB_CSI_INT3_OFFSET		0x40CC
#define CXD9225GG_APB_CSI_IFIFOL0_OFFSET		0x4010
#define CXD9225GG_APB_CSI_IFIFOL1_OFFSET		0x4050
#define CXD9225GG_APB_CSI_IFIFOL2_OFFSET		0x4090
#define CXD9225GG_APB_CSI_IFIFOL3_OFFSET		0x40D0
#define CXD9225GG_APB_CSI_OFIFOL0_OFFSET		0x4014
#define CXD9225GG_APB_CSI_OFIFOL1_OFFSET		0x4054
#define CXD9225GG_APB_CSI_OFIFOL2_OFFSET		0x4094
#define CXD9225GG_APB_CSI_OFIFOL3_OFFSET		0x40D4
#define CXD9225GG_APB_CSI_IFIFO0_OFFSET		0x4018
#define CXD9225GG_APB_CSI_IFIFO1_OFFSET		0x4058
#define CXD9225GG_APB_CSI_IFIFO2_OFFSET		0x4098
#define CXD9225GG_APB_CSI_IFIFO3_OFFSET		0x40D8
#define CXD9225GG_APB_CSI_OFIFO0_OFFSET		0x401C
#define CXD9225GG_APB_CSI_OFIFO1_OFFSET		0x405C
#define CXD9225GG_APB_CSI_OFIFO2_OFFSET		0x409C
#define CXD9225GG_APB_CSI_OFIFO3_OFFSET		0x40DC
#define CXD9225GG_APB_CSI_FIFOTRG0_OFFSET		0x4020
#define CXD9225GG_APB_CSI_FIFOTRG1_OFFSET		0x4060
#define CXD9225GG_APB_CSI_FIFOTRG2_OFFSET		0x40A0
#define CXD9225GG_APB_CSI_FIFOTRG3_OFFSET		0x40E0

#define CXD9225GG_APB_CSI_MODE0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_MODE0_OFFSET)
#define CXD9225GG_APB_CSI_MODE1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_MODE1_OFFSET)
#define CXD9225GG_APB_CSI_MODE2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_MODE2_OFFSET)
#define CXD9225GG_APB_CSI_MODE3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_MODE3_OFFSET)
#define   CXD9225GG_APB_CSI_MODEX_CSOT_STOP	0x00000000
#define   CXD9225GG_APB_CSI_MODEX_CSOT_RUN		0x00000001
#define   CXD9225GG_APB_CSI_MODEX_DIR_MSB		0x00000000
#define   CXD9225GG_APB_CSI_MODEX_DIR_LSB		0x00000010
#define   CXD9225GG_APB_CSI_MODEX_CCL_8BIT		0x00000000
#define   CXD9225GG_APB_CSI_MODEX_CCL_16BIT	0x00000020
#define   CXD9225GG_APB_CSI_MODEX_TRMD_RCV		0x00000000
#define   CXD9225GG_APB_CSI_MODEX_TRMD_TR		0x00000040
#define   CXD9225GG_APB_CSI_MODEX_CSIE_STOP	0x00000000
#define   CXD9225GG_APB_CSI_MODEX_CSIE_RUN		0x00000080
#define   CXD9225GG_APB_CSI_MODEX_DATWT_MASK	0x000F0000
#define   CXD9225GG_APB_CSI_MODEX_DATWT_SHIFT	(16)
#define CXD9225GG_APB_CSI_CLKSEL0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_CLKSEL0_OFFSET)
#define CXD9225GG_APB_CSI_CLKSEL1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_CLKSEL1_OFFSET)
#define CXD9225GG_APB_CSI_CLKSEL2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_CLKSEL2_OFFSET)
#define CXD9225GG_APB_CSI_CLKSEL3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_CLKSEL3_OFFSET)
#define   CXD9225GG_APB_CSI_CLKSELX_CKS_DIV2	0x00000002
#define   CXD9225GG_APB_CSI_CLKSELX_CKS_DIV4	0x00000004
#define   CXD9225GG_APB_CSI_CLKSELX_CKS_DIV6	0x00000006
#define   CXD9225GG_APB_CSI_CLKSELX_CKS_DIV8	0x00000008
#define   CXD9225GG_APB_CSI_CLKSELX_CKS_DIV16	0x00000010
#define   CXD9225GG_APB_CSI_CLKSELX_CKS_DIV32	0x00000020
#define   CXD9225GG_APB_CSI_CLKSELX_CKS_DIV512	0x00000200
#define   CXD9225GG_APB_CSI_CLKSELX_CKS_DIV8K	0x00002000
#define   CXD9225GG_APB_CSI_CLKSELX_CKS_DIV32K	0x00007FFE
#define   CXD9225GG_APB_CSI_CLKSELX_SLAVE_MASTER	0x00000000
#define   CXD9225GG_APB_CSI_CLKSELX_SLAVE_SLAVE	0x00008000
#define   CXD9225GG_APB_CSI_CLKSELX_DAP_SAME	0x00000000
#define   CXD9225GG_APB_CSI_CLKSELX_DAP_HALF	0x00010000
#define   CXD9225GG_APB_CSI_CLKSELX_CKP_HIGH	0x00000000
#define   CXD9225GG_APB_CSI_CLKSELX_CKP_LOW	0x00020000
#define   CXD9225GG_APB_CSI_CLKSELX_SS_POL_LOW	0x00000000
#define   CXD9225GG_APB_CSI_CLKSELX_SS_POL_HIGH	0x00040000
#define   CXD9225GG_APB_CSI_CLKSELX_SS_ENA_DIS	0x00000000
#define   CXD9225GG_APB_CSI_CLKSELX_SS_ENA_EN	0x00080000
#define CXD9225GG_APB_CSI_CNT0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_CNT0_OFFSET)
#define CXD9225GG_APB_CSI_CNT1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_CNT1_OFFSET)
#define CXD9225GG_APB_CSI_CNT2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_CNT2_OFFSET)
#define CXD9225GG_APB_CSI_CNT3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_CNT3_OFFSET)
#define   CXD9225GG_APB_CSI_CNTX_R_TRGR_E_INTDIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_R_TRGR_E_INTEN	0x00000001
#define   CXD9225GG_APB_CSI_CNTX_T_TRGR_E_INTDIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_T_TRGR_E_INTEN	0x00000010
#define   CXD9225GG_APB_CSI_CNTX_CSIEND_E_INTDIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_CSIEND_E_INTEN	0x00000100
#define   CXD9225GG_APB_CSI_CNTX_TREND_E_INTDIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_TREND_E_INTEN	0x00000200
#define   CXD9225GG_APB_CSI_CNTX_OVERF_E_INTDIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_OVERF_E_INTEN	0x00001000
#define   CXD9225GG_APB_CSI_CNTX_UNDER_E_INTDIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_UNDER_E_INTEN	0x00002000
#define   CXD9225GG_APB_CSI_CNTX_R_DMAEN_DIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_R_DMAEN_EN	0x00010000
#define   CXD9225GG_APB_CSI_CNTX_R_FIFOF_NOFULL	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_R_FIFOF_FULL	0x00040000
#define   CXD9225GG_APB_CSI_CNTX_R_TRGEN_DIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_R_TRGEN_EN	0x00080000
#define   CXD9225GG_APB_CSI_CNTX_SS_MON_LOW	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_SS_MON_HIGH	0x00200000
#define   CXD9225GG_APB_CSI_CNTX_T_DMAEN_DIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_T_DMAEN_EN	0x01000000
#define   CXD9225GG_APB_CSI_CNTX_T_FIFOF_NOFULL	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_T_FIFOF_FULL	0x04000000
#define   CXD9225GG_APB_CSI_CNTX_T_TRGEN_DIS	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_T_TRGEN_EN	0x08000000
#define   CXD9225GG_APB_CSI_CNTX_CSIRST_DEASERT	0x00000000
#define   CXD9225GG_APB_CSI_CNTX_CSIRST_ASERT	0x10000000
#define CXD9225GG_APB_CSI_INT0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_INT0_OFFSET)
#define CXD9225GG_APB_CSI_INT1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_INT1_OFFSET)
#define CXD9225GG_APB_CSI_INT2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_INT2_OFFSET)
#define CXD9225GG_APB_CSI_INT3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_INT3_OFFSET)
#define   CXD9225GG_APB_CSI_INTX_R_TRGR_RD_NOTRG	0x00000000
#define   CXD9225GG_APB_CSI_INTX_R_TRGR_RD_TRG	0x00000001
#define   CXD9225GG_APB_CSI_INTX_R_TRGR_WR_HOLD	0x00000000
#define   CXD9225GG_APB_CSI_INTX_R_TRGR_WR_RESET	0x00000001
#define   CXD9225GG_APB_CSI_INTX_T_TRGR_RD_NOTRG	0x00000000
#define   CXD9225GG_APB_CSI_INTX_T_TRGR_RD_TRG	0x00000010
#define   CXD9225GG_APB_CSI_INTX_T_TRGR_WR_HOLD	0x00000000
#define   CXD9225GG_APB_CSI_INTX_T_TRGR_WR_RESET	0x00000010
#define   CXD9225GG_APB_CSI_INTX_CSIEND_RD_NOINT	0x00000000
#define   CXD9225GG_APB_CSI_INTX_CSIEND_RD_CMP	0x00000100
#define   CXD9225GG_APB_CSI_INTX_CSIEND_WR_HOLD	0x00000000
#define   CXD9225GG_APB_CSI_INTX_CSIEND_WR_RESET	0x00000100
#define   CXD9225GG_APB_CSI_INTX_TREND_RD_NOINT	0x00000000
#define   CXD9225GG_APB_CSI_INTX_TREND_RD_CMP	0x00000200
#define   CXD9225GG_APB_CSI_INTX_TREND_WR_HOLD	0x00000000
#define   CXD9225GG_APB_CSI_INTX_TREND_WR_RESET	0x00000200
#define   CXD9225GG_APB_CSI_INTX_OVERF_RD_NOINT	0x00000000
#define   CXD9225GG_APB_CSI_INTX_OVERF_RD_OVERF	0x00001000
#define   CXD9225GG_APB_CSI_INTX_OVERF_WR_HOLD	0x00000000
#define   CXD9225GG_APB_CSI_INTX_OVERF_WR_RESET	0x00001000
#define   CXD9225GG_APB_CSI_INTX_UNDER_RD_NOINT	0x00000000
#define   CXD9225GG_APB_CSI_INTX_UNDER_RD_UNDER	0x00002000
#define   CXD9225GG_APB_CSI_INTX_UNDER_WR_HOLD	0x00000000
#define   CXD9225GG_APB_CSI_INTX_UNDER_WR_RESET	0x00002000
#define CXD9225GG_APB_CSI_IFIFOL0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_IFIFOL0_OFFSET)
#define CXD9225GG_APB_CSI_IFIFOL1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_IFIFOL1_OFFSET)
#define CXD9225GG_APB_CSI_IFIFOL2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_IFIFOL2_OFFSET)
#define CXD9225GG_APB_CSI_IFIFOL3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_IFIFOL3_OFFSET)
#define CXD9225GG_APB_CSI_OFIFOL0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_OFIFOL0_OFFSET)
#define CXD9225GG_APB_CSI_OFIFOL1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_OFIFOL1_OFFSET)
#define CXD9225GG_APB_CSI_OFIFOL2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_OFIFOL2_OFFSET)
#define CXD9225GG_APB_CSI_OFIFOL3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_OFIFOL3_OFFSET)
#define CXD9225GG_APB_CSI_IFIFO0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_IFIFO0_OFFSET)
#define CXD9225GG_APB_CSI_IFIFO1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_IFIFO1_OFFSET)
#define CXD9225GG_APB_CSI_IFIFO2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_IFIFO2_OFFSET)
#define CXD9225GG_APB_CSI_IFIFO3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_IFIFO3_OFFSET)
#define CXD9225GG_APB_CSI_OFIFO0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_OFIFO0_OFFSET)
#define CXD9225GG_APB_CSI_OFIFO1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_OFIFO1_OFFSET)
#define CXD9225GG_APB_CSI_OFIFO2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_OFIFO2_OFFSET)
#define CXD9225GG_APB_CSI_OFIFO3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_OFIFO3_OFFSET)
#define CXD9225GG_APB_CSI_FIFOTRG0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_FIFOTRG0_OFFSET)
#define CXD9225GG_APB_CSI_FIFOTRG1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_FIFOTRG1_OFFSET)
#define CXD9225GG_APB_CSI_FIFOTRG2	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_FIFOTRG2_OFFSET)
#define CXD9225GG_APB_CSI_FIFOTRG3	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_CSI_FIFOTRG3_OFFSET)
#define   CXD9225GG_APB_CSI_FIFOTRGX_R_TRG_X1	0x00000000
#define   CXD9225GG_APB_CSI_FIFOTRGX_R_TRG_X2	0x00000001
#define   CXD9225GG_APB_CSI_FIFOTRGX_R_TRG_X4	0x00000002
#define   CXD9225GG_APB_CSI_FIFOTRGX_R_TRG_X8	0x00000003
#define   CXD9225GG_APB_CSI_FIFOTRGX_R_TRG_X16	0x00000004
#define   CXD9225GG_APB_CSI_FIFOTRGX_R_TRG_X32	0x00000005
#define   CXD9225GG_APB_CSI_FIFOTRGX_T_TRG_X1	0x00000000
#define   CXD9225GG_APB_CSI_FIFOTRGX_T_TRG_X2	0x00000100
#define   CXD9225GG_APB_CSI_FIFOTRGX_T_TRG_X4	0x00000200
#define   CXD9225GG_APB_CSI_FIFOTRGX_T_TRG_X8	0x00000300
#define   CXD9225GG_APB_CSI_FIFOTRGX_T_TRG_X16	0x00000400
#define   CXD9225GG_APB_CSI_FIFOTRGX_T_TRG_X32	0x00000500



/* APB UART */
#define CXD9225GG_APB_UART0_BASE		(CXD9225GG_APBSS_BASE + 0x4800)
#define CXD9225GG_APB_UART1_BASE		(CXD9225GG_APBSS_BASE + 0x4A00)
#define CXD9225GG_APB_UART2_BASE		(CXD9225GG_APBSS_BASE + 0x4C00)
#define CXD9225GG_APB_UART3_BASE		(CXD9225GG_APBSS_BASE + 0x4E00)

#define CXD9225GG_APB_UART_RBR_OFFSET	0x000
#define CXD9225GG_APB_UART_THR_OFFSET	0x000
#define CXD9225GG_APB_UART_DLL_OFFSET	0x000
#define CXD9225GG_APB_UART_DLH_OFFSET	0x004
#define CXD9225GG_APB_UART_IER_OFFSET	0x004
#define CXD9225GG_APB_UART_IIR_OFFSET	0x008
#define CXD9225GG_APB_UART_FCR_OFFSET	0x008
#define CXD9225GG_APB_UART_LCR_OFFSET	0x00C
#define CXD9225GG_APB_UART_MCR_OFFSET	0x010
#define CXD9225GG_APB_UART_LSR_OFFSET	0x014
#define CXD9225GG_APB_UART_MSR_OFFSET	0x018
#define CXD9225GG_APB_UART_SCR_OFFSET	0x01C
#define CXD9225GG_APB_UART_USR_OFFSET	0x07C
#define CXD9225GG_APB_UART_FDR_OFFSET	0x100

#define CXD9225GG_APB_UART_RBR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_RBR_OFFSET)
#define CXD9225GG_APB_UART_RBR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_RBR_OFFSET)
#define CXD9225GG_APB_UART_RBR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_RBR_OFFSET)
#define CXD9225GG_APB_UART_RBR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_RBR_OFFSET)
#define CXD9225GG_APB_UART_THR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_THR_OFFSET)
#define CXD9225GG_APB_UART_THR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_THR_OFFSET)
#define CXD9225GG_APB_UART_THR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_THR_OFFSET)
#define CXD9225GG_APB_UART_THR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_THR_OFFSET)
#define CXD9225GG_APB_UART_DLL0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_DLL_OFFSET)
#define CXD9225GG_APB_UART_DLL1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_DLL_OFFSET)
#define CXD9225GG_APB_UART_DLL2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_DLL_OFFSET)
#define CXD9225GG_APB_UART_DLL3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_DLL_OFFSET)
#define CXD9225GG_APB_UART_DLH0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_DLH_OFFSET)
#define CXD9225GG_APB_UART_DLH1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_DLH_OFFSET)
#define CXD9225GG_APB_UART_DLH2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_DLH_OFFSET)
#define CXD9225GG_APB_UART_DLH3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_DLH_OFFSET)
#define CXD9225GG_APB_UART_IER0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_IER_OFFSET)
#define CXD9225GG_APB_UART_IER1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_IER_OFFSET)
#define CXD9225GG_APB_UART_IER2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_IER_OFFSET)
#define CXD9225GG_APB_UART_IER3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_IER_OFFSET)
#define   CXD9225GG_APB_UART_IERX_IE0_RINTDIS	0x00
#define   CXD9225GG_APB_UART_IERX_IE0_RINTEN	0x01
#define   CXD9225GG_APB_UART_IERX_IE1_TEMPINTDIS	0x00
#define   CXD9225GG_APB_UART_IERX_IE1_TEMPINTEN	0x02
#define   CXD9225GG_APB_UART_IERX_IE1_RSINTDIS	0x00
#define   CXD9225GG_APB_UART_IERX_IE1_RSINTEN	0x04
#define   CXD9225GG_APB_UART_IERX_IE1_MSINTDIS	0x00
#define   CXD9225GG_APB_UART_IERX_IE1_MSINTEN	0x08
#define CXD9225GG_APB_UART_IIR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_IIR_OFFSET)
#define CXD9225GG_APB_UART_IIR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_IIR_OFFSET)
#define CXD9225GG_APB_UART_IIR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_IIR_OFFSET)
#define CXD9225GG_APB_UART_IIR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_IIR_OFFSET)
#define   CXD9225GG_APB_UART_IIRX_NOINT		0x01
#define   CXD9225GG_APB_UART_IIRX_RCVLINSTS	0x06
#define   CXD9225GG_APB_UART_IIRX_RCVDATA		0x04
#define   CXD9225GG_APB_UART_IIRX_CHARTIMOUT	0x0C
#define   CXD9225GG_APB_UART_IIRX_TRANSEMPTY	0x02
#define   CXD9225GG_APB_UART_IIRX_MODEMSTS		0x00
#define   CXD9225GG_APB_UART_IIRX_BUSY		0x07
#define CXD9225GG_APB_UART_FCR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_FCR_OFFSET)
#define CXD9225GG_APB_UART_FCR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_FCR_OFFSET)
#define CXD9225GG_APB_UART_FCR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_FCR_OFFSET)
#define CXD9225GG_APB_UART_FCR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_FCR_OFFSET)
#define   CXD9225GG_APB_UART_FCRX_FCR0_DIS		0x00
#define   CXD9225GG_APB_UART_FCRX_FCR0_EN		0x01
#define   CXD9225GG_APB_UART_FCRX_FCR1_FIFOCLR	0x00
#define   CXD9225GG_APB_UART_FCRX_FCR1_NORMAL	0x02
#define   CXD9225GG_APB_UART_FCRX_FCR2_FIFOCLR	0x00
#define   CXD9225GG_APB_UART_FCRX_FCR2_NORMAL	0x04
#define   CXD9225GG_APB_UART_FCRX_FCR76_1BYTE	0x00
#define   CXD9225GG_APB_UART_FCRX_FCR76_4BYTE	0x40
#define   CXD9225GG_APB_UART_FCRX_FCR76_8BYTE	0x80
#define   CXD9225GG_APB_UART_FCRX_FCR76_14BYTE	0xC0
#define CXD9225GG_APB_UART_LCR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_LCR_OFFSET)
#define CXD9225GG_APB_UART_LCR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_LCR_OFFSET)
#define CXD9225GG_APB_UART_LCR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_LCR_OFFSET)
#define CXD9225GG_APB_UART_LCR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_LCR_OFFSET)
#define   CXD9225GG_APB_UART_LCRX_LCR10_5BIT	0x00
#define   CXD9225GG_APB_UART_LCRX_LCR10_6BIT	0x01
#define   CXD9225GG_APB_UART_LCRX_LCR10_7BIT	0x02
#define   CXD9225GG_APB_UART_LCRX_LCR10_8BIT	0x03
#define   CXD9225GG_APB_UART_LCRX_LCR2_1BIT	0x00
#define   CXD9225GG_APB_UART_LCRX_LCR2_2BIT	0x04
#define   CXD9225GG_APB_UART_LCRX_LCR3_NOPARITY	0x00
#define   CXD9225GG_APB_UART_LCRX_LCR3_PARITY	0x08
#define   CXD9225GG_APB_UART_LCRX_LCR4_ODD		0x00
#define   CXD9225GG_APB_UART_LCRX_LCR4_EVEN	0x10
#define   CXD9225GG_APB_UART_LCRX_LCR6_NOBRK	0x00
#define   CXD9225GG_APB_UART_LCRX_LCR6_BREAK	0x40
#define   CXD9225GG_APB_UART_LCRX_LCR7_RCVTRNINT	0x00
#define   CXD9225GG_APB_UART_LCRX_LCR7_DIVLATCH	0x80
#define CXD9225GG_APB_UART_MCR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_MCR_OFFSET)
#define CXD9225GG_APB_UART_MCR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_MCR_OFFSET)
#define CXD9225GG_APB_UART_MCR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_MCR_OFFSET)
#define CXD9225GG_APB_UART_MCR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_MCR_OFFSET)
#define   CXD9225GG_APB_UART_MCRX_MCR0_HIGH	0x00
#define   CXD9225GG_APB_UART_MCRX_MCR0_LOW		0x01
#define   CXD9225GG_APB_UART_MCRX_MCR1_HIGH	0x00
#define   CXD9225GG_APB_UART_MCRX_MCR1_LOW		0x02
#define   CXD9225GG_APB_UART_MCRX_MCR2_HIGH	0x00
#define   CXD9225GG_APB_UART_MCRX_MCR2_LOW		0x04
#define   CXD9225GG_APB_UART_MCRX_MCR3_HIGH	0x00
#define   CXD9225GG_APB_UART_MCRX_MCR3_LOW		0x08
#define   CXD9225GG_APB_UART_MCRX_MCR4_DIS		0x00
#define   CXD9225GG_APB_UART_MCRX_MCR4_EN		0x10
#define   CXD9225GG_APB_UART_MCRX_MCR5_DIS		0x00
#define   CXD9225GG_APB_UART_MCRX_MCR5_EN		0x20
#define CXD9225GG_APB_UART_LSR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_LSR_OFFSET)
#define CXD9225GG_APB_UART_LSR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_LSR_OFFSET)
#define CXD9225GG_APB_UART_LSR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_LSR_OFFSET)
#define CXD9225GG_APB_UART_LSR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_LSR_OFFSET)
#define   CXD9225GG_APB_UART_LSRX_LSR0_RECEIVE	0x01
#define   CXD9225GG_APB_UART_LSRX_LSR1_OVERRUN	0x02
#define   CXD9225GG_APB_UART_LSRX_LSR2_PARITY	0x04
#define   CXD9225GG_APB_UART_LSRX_LSR3_FLAMING	0x08
#define   CXD9225GG_APB_UART_LSRX_LSR4_BREAK	0x10
#define   CXD9225GG_APB_UART_LSRX_LSR5_TREMPTY	0x20
#define   CXD9225GG_APB_UART_LSRX_LSR6_TEMPTY	0x40
#define   CXD9225GG_APB_UART_LSRX_LSR7_ERROR	0x80
#define CXD9225GG_APB_UART_MSR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_MSR_OFFSET)
#define CXD9225GG_APB_UART_MSR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_MSR_OFFSET)
#define CXD9225GG_APB_UART_MSR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_MSR_OFFSET)
#define CXD9225GG_APB_UART_MSR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_MSR_OFFSET)
#define   CXD9225GG_APB_UART_MSRX_MSR0_CTS_N_CHG	0x01
#define   CXD9225GG_APB_UART_MSRX_MSR1_DSR_N_CHG	0x02
#define   CXD9225GG_APB_UART_MSRX_MSR2_RI_N_CHG	0x04
#define   CXD9225GG_APB_UART_MSRX_MSR3_DCD_N_CHG	0x08
#define   CXD9225GG_APB_UART_MSRX_MSR4_CTS_N_AST	0x10
#define   CXD9225GG_APB_UART_MSRX_MSR5_DSR_N_AST	0x20
#define   CXD9225GG_APB_UART_MSRX_MSR6_RI_N_AST	0x40
#define   CXD9225GG_APB_UART_MSRX_MSR7_DCD_N_AST	0x80
#define CXD9225GG_APB_UART_SCR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_SCR_OFFSET)
#define CXD9225GG_APB_UART_SCR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_SCR_OFFSET)
#define CXD9225GG_APB_UART_SCR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_SCR_OFFSET)
#define CXD9225GG_APB_UART_SCR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_SCR_OFFSET)
#define CXD9225GG_APB_UART_USR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_USR_OFFSET)
#define CXD9225GG_APB_UART_USR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_USR_OFFSET)
#define CXD9225GG_APB_UART_USR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_USR_OFFSET)
#define CXD9225GG_APB_UART_USR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_USR_OFFSET)
#define   CXD9225GG_APB_UART_USRX_BUSY_IDLE	0x00
#define   CXD9225GG_APB_UART_USRX_BUSY_BUSY	0x01
#define CXD9225GG_APB_UART_FDR0	(CXD9225GG_APB_UART0_BASE + CXD9225GG_APB_UART_FDR_OFFSET)
#define CXD9225GG_APB_UART_FDR1	(CXD9225GG_APB_UART1_BASE + CXD9225GG_APB_UART_FDR_OFFSET)
#define CXD9225GG_APB_UART_FDR2	(CXD9225GG_APB_UART2_BASE + CXD9225GG_APB_UART_FDR_OFFSET)
#define CXD9225GG_APB_UART_FDR3	(CXD9225GG_APB_UART3_BASE + CXD9225GG_APB_UART_FDR_OFFSET)
#define   CXD9225GG_APB_UART_FDRX_FDR4_TRNRST	0x40
#define   CXD9225GG_APB_UART_FDRX_FDR6_RCVRST	0x10


/* APB IIC */
#define CXD9225GG_APB_IIC_IICACT0_OFFSET		0x5000
#define CXD9225GG_APB_IIC_IICACT1_OFFSET		0x5040
#define CXD9225GG_APB_IIC_IIC0_OFFSET		0x5004
#define CXD9225GG_APB_IIC_IIC1_OFFSET		0x5044
#define CXD9225GG_APB_IIC_IICC0_OFFSET		0x5008
#define CXD9225GG_APB_IIC_IICC1_OFFSET		0x5048
#define CXD9225GG_APB_IIC_SVA0_OFFSET		0x500C
#define CXD9225GG_APB_IIC_SVA1_OFFSET		0x504C
#define CXD9225GG_APB_IIC_IICCL0_OFFSET		0x5010
#define CXD9225GG_APB_IIC_IICCL1_OFFSET		0x5050
#define CXD9225GG_APB_IIC_IICCX0_OFFSET		0x5014
#define CXD9225GG_APB_IIC_IICCX1_OFFSET		0x5054
#define CXD9225GG_APB_IIC_IICCS0_OFFSET		0x5018
#define CXD9225GG_APB_IIC_IICCS1_OFFSET		0x5058
#define CXD9225GG_APB_IIC_IICSE0_OFFSET		0x501C
#define CXD9225GG_APB_IIC_IICSE1_OFFSET		0x505C
#define CXD9225GG_APB_IIC_IICCF0_OFFSET		0x5020
#define CXD9225GG_APB_IIC_IICCF1_OFFSET		0x5060

#define CXD9225GG_APB_IIC_IICACT0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICACT0_OFFSET)
#define CXD9225GG_APB_IIC_IICACT1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICACT1_OFFSET)
#define   CXD9225GG_APB_IIC_IICACTX_IICE_RST	0x00
#define   CXD9225GG_APB_IIC_IICACTX_IICE_EN	0x01
#define CXD9225GG_APB_IIC_IIC0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IIC0_OFFSET)
#define CXD9225GG_APB_IIC_IIC1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IIC1_OFFSET)
#define CXD9225GG_APB_IIC_IICC0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICC0_OFFSET)
#define CXD9225GG_APB_IIC_IICC1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICC1_OFFSET)
#define   CXD9225GG_APB_IIC_IICCX_SPT_STPCOND	0x01
#define   CXD9225GG_APB_IIC_IICCX_STT_STTCOND	0x02
#define   CXD9225GG_APB_IIC_IICCX_ACKE_DIS		0x00
#define   CXD9225GG_APB_IIC_IICCX_ACKE_EN		0x04
#define   CXD9225GG_APB_IIC_IICCX_WTIM_AFTER8CYC	0x00
#define   CXD9225GG_APB_IIC_IICCX_WTIM_AFTER9CYC	0x08
#define   CXD9225GG_APB_IIC_IICCX_SPIE_DIS		0x00
#define   CXD9225GG_APB_IIC_IICCX_SPIE_EN		0x10
#define   CXD9225GG_APB_IIC_IICCX_WREL_NOWAIT	0x00
#define   CXD9225GG_APB_IIC_IICCX_WREL_HOLD	0x20
#define   CXD9225GG_APB_IIC_IICCX_LREL_WAIT	0x00
#define   CXD9225GG_APB_IIC_IICCX_LREL_NORMAL	0x40
#define CXD9225GG_APB_IIC_SVA0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_SVA0_OFFSET)
#define CXD9225GG_APB_IIC_SVA1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_SVA1_OFFSET)
#define CXD9225GG_APB_IIC_IICCL0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICCL0_OFFSET)
#define CXD9225GG_APB_IIC_IICCL1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICCL1_OFFSET)
#define   CXD9225GG_APB_IIC_IICCLX_CL_2MTO4M	0x00
#define   CXD9225GG_APB_IIC_IICCLX_CL_4MTO8M	0x01
#define   CXD9225GG_APB_IIC_IICCLX_SMC_STD		0x00
#define   CXD9225GG_APB_IIC_IICCLX_SMC_FAST	0x08
#define   CXD9225GG_APB_IIC_IICCLX_DAD_LOW		0x00
#define   CXD9225GG_APB_IIC_IICCLX_DAD_HIGH	0x10
#define   CXD9225GG_APB_IIC_IICCLX_CLD_LOW		0x00
#define   CXD9225GG_APB_IIC_IICCLX_CLD_HIGH	0x20
#define CXD9225GG_APB_IIC_IICCX0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICCX0_OFFSET)
#define CXD9225GG_APB_IIC_IICCX1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICCX1_OFFSET)
#define   CXD9225GG_APB_IIC_IICCXX_CLX_SMC		0x00
#define   CXD9225GG_APB_IIC_IICCXX_CLX_SNGLMSTR	0x01
#define CXD9225GG_APB_IIC_IICCS0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICCS0_OFFSET)
#define CXD9225GG_APB_IIC_IICCS1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICCS1_OFFSET)
#define   CXD9225GG_APB_IIC_IICCSX_SPD_STPCND	0x01
#define   CXD9225GG_APB_IIC_IICCSX_STD_STTCND	0x02
#define   CXD9225GG_APB_IIC_IICCSX_ACKD_ACK	0x04
#define   CXD9225GG_APB_IIC_IICCSX_TRC_TRN		0x08
#define   CXD9225GG_APB_IIC_IICCSX_COI_ADRMATCH	0x10
#define   CXD9225GG_APB_IIC_IICCSX_EXC_EXTCOD	0x20
#define   CXD9225GG_APB_IIC_IICCSX_ALD_ARBLOST	0x40
#define   CXD9225GG_APB_IIC_IICCSX_MSTS_MASTER	0x80
#define CXD9225GG_APB_IIC_IICSE0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICSE0_OFFSET)
#define CXD9225GG_APB_IIC_IICSE1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICSE1_OFFSET)
#define CXD9225GG_APB_IIC_IICCF0	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICCF0_OFFSET)
#define CXD9225GG_APB_IIC_IICCF1	(CXD9225GG_APBSS_BASE + CXD9225GG_APB_IIC_IICCF1_OFFSET)
#define   CXD9225GG_APB_IIC_IICCFX_IICRSV_DIS	0x00
#define   CXD9225GG_APB_IIC_IICCFX_IICRSV_EN	0x01
#define   CXD9225GG_APB_IIC_IICCFX_STCEN_STPCND	0x00
#define   CXD9225GG_APB_IIC_IICCFX_STCEN_NOSTPCND	0x02
#define   CXD9225GG_APB_IIC_IICCFX_IICBSY_BUSFREE	0x00
#define   CXD9225GG_APB_IIC_IICCFX_IICBSY_BUSCOM	0x40
#define   CXD9225GG_APB_IIC_IICCFX_STCF_STTCOND	0x00
#define   CXD9225GG_APB_IIC_IICCFX_STCF_STTFCLR	0x80



/* Port Register */
#define CXD9225GG_PORT00_OFFSET		0x8000
#define CXD9225GG_PM00_OFFSET		0x8004
#define CXD9225GG_PMC00_OFFSET		0x8008
#define CXD9225GG_PORTIN00_OFFSET		0x8010
#define CXD9225GG_PORT01_OFFSET		0x8020
#define CXD9225GG_PM01_OFFSET		0x8024
#define CXD9225GG_PMC01_OFFSET		0x8028
#define CXD9225GG_PORTIN01_OFFSET		0x8030
#define CXD9225GG_PORT02_OFFSET		0x8040
#define CXD9225GG_PM02_OFFSET		0x8044
#define CXD9225GG_PMC02_OFFSET		0x8048
#define CXD9225GG_PORTIN02_OFFSET		0x8050
#define CXD9225GG_PORT03_OFFSET		0x8060
#define CXD9225GG_PM03_OFFSET		0x8064
#define CXD9225GG_PMC03_OFFSET		0x8068
#define CXD9225GG_PORTIN03_OFFSET		0x8070
#define CXD9225GG_PORT04_OFFSET		0x8080
#define CXD9225GG_PM04_OFFSET		0x8084
#define CXD9225GG_PMC04_OFFSET		0x8088
#define CXD9225GG_PORTIN04_OFFSET		0x8090
#define CXD9225GG_PORT05_OFFSET		0x80A0
#define CXD9225GG_PM05_OFFSET		0x80A4
#define CXD9225GG_PMC05_OFFSET		0x80A8
#define CXD9225GG_PORTIN05_OFFSET		0x80B0
#define CXD9225GG_PORT10_OFFSET		0x8100
#define CXD9225GG_PM10_OFFSET		0x8104
#define CXD9225GG_PMC10_OFFSET		0x8108
#define CXD9225GG_PORTIN10_OFFSET		0x8110
#define CXD9225GG_PORT11_OFFSET		0x8120
#define CXD9225GG_PM11_OFFSET		0x8124
#define CXD9225GG_PMC11_OFFSET		0x8128
#define CXD9225GG_PORTIN11_OFFSET		0x8130
#define CXD9225GG_PORT12_OFFSET		0x8140
#define CXD9225GG_PM12_OFFSET		0x8144
#define CXD9225GG_PMC12_OFFSET		0x8148
#define CXD9225GG_PORTIN12_OFFSET		0x8150
#define CXD9225GG_PORT13_OFFSET		0x8160
#define CXD9225GG_PM13_OFFSET		0x8164
#define CXD9225GG_PMC13_OFFSET		0x8168
#define CXD9225GG_PORTIN13_OFFSET		0x8170
#define CXD9225GG_PORT14_OFFSET		0x8180
#define CXD9225GG_PM14_OFFSET		0x8184
#define CXD9225GG_PMC14_OFFSET		0x8188
#define CXD9225GG_PORTIN14_OFFSET		0x8190
#define CXD9225GG_PORT15_OFFSET		0x81A0
#define CXD9225GG_PM15_OFFSET		0x81A4
#define CXD9225GG_PMC15_OFFSET		0x81A8
#define CXD9225GG_PORTIN15_OFFSET		0x81B0

#define CXD9225GG_PORT00		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT00_OFFSET)
#define CXD9225GG_PM00		(CXD9225GG_APBSS_BASE + CXD9225GG_PM00_OFFSET)
#define CXD9225GG_PMC00		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC00_OFFSET)
#define CXD9225GG_PORTIN00		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN00_OFFSET)
#define CXD9225GG_PORT01		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT01_OFFSET)
#define CXD9225GG_PM01		(CXD9225GG_APBSS_BASE + CXD9225GG_PM01_OFFSET)
#define CXD9225GG_PMC01		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC01_OFFSET)
#define CXD9225GG_PORTIN01		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN01_OFFSET)
#define CXD9225GG_PORT02		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT02_OFFSET)
#define CXD9225GG_PM02		(CXD9225GG_APBSS_BASE + CXD9225GG_PM02_OFFSET)
#define CXD9225GG_PMC02		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC02_OFFSET)
#define CXD9225GG_PORTIN02		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN02_OFFSET)
#define CXD9225GG_PORT03		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT03_OFFSET)
#define CXD9225GG_PM03		(CXD9225GG_APBSS_BASE + CXD9225GG_PM03_OFFSET)
#define CXD9225GG_PMC03		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC03_OFFSET)
#define CXD9225GG_PORTIN03		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN03_OFFSET)
#define CXD9225GG_PORT04		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT04_OFFSET)
#define CXD9225GG_PM04		(CXD9225GG_APBSS_BASE + CXD9225GG_PM04_OFFSET)
#define CXD9225GG_PMC04		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC04_OFFSET)
#define CXD9225GG_PORTIN04		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN04_OFFSET)
#define CXD9225GG_PORT05		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT05_OFFSET)
#define CXD9225GG_PM05		(CXD9225GG_APBSS_BASE + CXD9225GG_PM05_OFFSET)
#define CXD9225GG_PMC05		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC05_OFFSET)
#define CXD9225GG_PORTIN05		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN05_OFFSET)
#define CXD9225GG_PORT10		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT10_OFFSET)
#define CXD9225GG_PM10		(CXD9225GG_APBSS_BASE + CXD9225GG_PM10_OFFSET)
#define CXD9225GG_PMC10		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC10_OFFSET)
#define CXD9225GG_PORTIN10		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN10_OFFSET)
#define CXD9225GG_PORT11		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT11_OFFSET)
#define CXD9225GG_PM11		(CXD9225GG_APBSS_BASE + CXD9225GG_PM11_OFFSET)
#define CXD9225GG_PMC11		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC11_OFFSET)
#define CXD9225GG_PORTIN11		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN11_OFFSET)
#define CXD9225GG_PORT12		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT12_OFFSET)
#define CXD9225GG_PM12		(CXD9225GG_APBSS_BASE + CXD9225GG_PM12_OFFSET)
#define CXD9225GG_PMC12		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC12_OFFSET)
#define CXD9225GG_PORTIN12		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN12_OFFSET)
#define CXD9225GG_PORT13		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT13_OFFSET)
#define CXD9225GG_PM13		(CXD9225GG_APBSS_BASE + CXD9225GG_PM13_OFFSET)
#define CXD9225GG_PMC13		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC13_OFFSET)
#define CXD9225GG_PORTIN13		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN13_OFFSET)
#define CXD9225GG_PORT14		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT14_OFFSET)
#define CXD9225GG_PM14		(CXD9225GG_APBSS_BASE + CXD9225GG_PM14_OFFSET)
#define CXD9225GG_PMC14		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC14_OFFSET)
#define CXD9225GG_PORTIN14		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN14_OFFSET)
#define CXD9225GG_PORT15		(CXD9225GG_APBSS_BASE + CXD9225GG_PORT15_OFFSET)
#define CXD9225GG_PM15		(CXD9225GG_APBSS_BASE + CXD9225GG_PM15_OFFSET)
#define CXD9225GG_PMC15		(CXD9225GG_APBSS_BASE + CXD9225GG_PMC15_OFFSET)
#define CXD9225GG_PORTIN15		(CXD9225GG_APBSS_BASE + CXD9225GG_PORTIN15_OFFSET)



/* DebugHW Register */
#define CXD9225GG_DBG_CTRL_OFFSET			0x9000
#define CXD9225GG_DBG_INTERNAL_RADDR_OFFSET	0x9020
#define CXD9225GG_DBG_INTERNAL_RDATA_OFFSET	0x9024
#define CXD9225GG_DBG_INTERNAL_WADDR_OFFSET	0x9028
#define CXD9225GG_DBG_INTERNAL_WDATA_OFFSET	0x902C

#define CXD9225GG_DBG_CTRL			(CXD9225GG_APBSS_BASE + CXD9225GG_DBG_CTRL_OFFSET)
#define   CXD9225GG_DBG_CTRL_DBGP_RESET		0x00000000
#define   CXD9225GG_DBG_CTRL_DBGP_RUN		0x00000001
#define   CXD9225GG_DBG_CTRL_DBGP_NORMAL		0x00000000
#define   CXD9225GG_DBG_CTRL_DBGP_HALT		0x00000002
#define CXD9225GG_DBG_INTERNAL_RADDR	(CXD9225GG_APBSS_BASE + CXD9225GG_DBG_INTERNAL_RADDR_OFFSET)
#define CXD9225GG_DBG_INTERNAL_RDATA	(CXD9225GG_APBSS_BASE + CXD9225GG_DBG_INTERNAL_RDATA_OFFSET)
#define CXD9225GG_DBG_INTERNAL_WADDR	(CXD9225GG_APBSS_BASE + CXD9225GG_DBG_INTERNAL_WADDR_OFFSET)
#define CXD9225GG_DBG_INTERNAL_WDATA	(CXD9225GG_APBSS_BASE + CXD9225GG_DBG_INTERNAL_WDATA_OFFSET)



#ifdef __cplusplus
}
#endif

#endif	/* INCcxd9225ggChipseth */
